program BPView;

{ Project BPView - View & Edit BP }

uses
  ShareMem,
  Windows,
  SysUtils,
  Forms,
  Printers,
  MainUnit in 'MainUnit.pas' {BPViewLFSMainForm},
  StartUnit in 'StartUnit.pas' {StartForm},
  Bpframe in 'Bpframe.pas',
  BPLabel in 'Bplabel.pas',
  BPNode in 'Bpnode.pas',
  BPDef in 'Bpdef.pas',
  PrevUnit in 'PrevUnit.pas' {PreviewForm},
  BPStream in 'Bpstream.pas',
  SSrcUnit in 'SSrcUnit.pas' {SelectSourceDlg},
  FontDlg in 'FontDlg.pas' {FontSelectDlg},
  PrepUnit in 'PrepUnit.pas' {PrepareForm},
  ConstUnt in 'ConstUnt.pas',
  SelWEBImageDlgUnit in 'SelWEBImageDlgUnit.pas' {SelWEBImageDlg},
  AboutBoxUnit in 'AboutBoxUnit.pas' {AboutBox},
  BPPropDlgUnit in 'BPPropDlgUnit.pas' {BPPropDlg},
  NodeTypeDlgUnit in 'NodeTypeDlgUnit.pas' {NodeTypeDlg},
  BPDfd in 'Bpdfd.pas',
  BPNav in 'bpnav.pas',
  TextExportUnit in 'TextExportUnit.pas',
  TranslateUnit in 'TranslateUnit.pas',
  ImportTextFormUnit in 'ImportTextFormUnit.pas' {ImportTextForm},
  BPInt in 'Bpint.pas',
  BPLsa in 'BPLsa.pas',
  TransformTopologyDialog in 'TransformTopologyDialog.pas' {TransformTopologySetupDlg},
  BPRename in 'bprename.pas',
  RamkaPropDlgUnit in 'RamkaPropDlgUnit.pas' {RamkaPropDlg},
  AlgFormatSetupFormUnit in 'AlgFormatSetupFormUnit.pas' {AlgFormatSetupForm},
  QRepFrm1Unit in 'QRepFrm1Unit.pas' {QRepForm},
  BPDFDNew in 'bpdfdnew.pas',
  MyUtils in 'MyUtils.pas',
  SetupMyUtilsUnit in 'SetupMyUtilsUnit.pas' {SetupMyUtilsForm},
  AnalizeGraphUnit in 'AnalizeGraphUnit.pas' {AnalizeGraphForm},
  FontSizeDlgUnit in 'FontSizeDlgUnit.pas' {FontSizeDlg},
  SetCaptionFormUnit1 in 'SetCaptionFormUnit1.pas' {SetCaptionForm1},
  SetCaptionFormUnit in 'SetCaptionFormUnit.pas' {SetCaptionForm},
  SetMaxGOSDlgUnit in 'SetMaxGOSDlgUnit.pas' {SetMaxGOSDlg},
  MaxFontDlgUnit in '..\OCHART\MaxFontDlgUnit.pas' {MaxFontDlg},
  bppnd in 'bppnd.pas',
  NLDSetupDialogUnit in '..\..\..\Program Files\Borland\Delphi 3\HLAM\NLDSetupDialogUnit.pas' {NLDSetupDialog};

{$R *.RES}

Var hwndPrev:HWND;
    HasDefPrn:Boolean;

begin
  StartForm:=TStartForm.Create(Application);
  StartForm.Show;
  StartForm.Update;
  hwndPrev:=FindWindow('TBPViewLFSMainForm',nil);
  if hwndPrev<>0 then
   begin
    PostMessage(hwndPrev,MSG_CLOSEBP,0,0);
   end;
  Application.Initialize;
  Application.ShowHint:=True;
  Application.Title := '- 6.3';
  Application.HelpFile := 'Bpview.hlp';
//  Application.HelpFile := ExtractFilePath(Application.ExeName)+'Bpview.hlp';
  { Printer Initialization Block }
  HasDefPrn:=CheckAndSetWorkingPrinter; { Check there is at last one Prn Device }
  if (not(HasDefPrn)) then
    begin
      StartForm.CloseTimer.Enabled:=False;
      StartForm.Close;
      Application.MessageBox('        ','    ',MB_OK or MB_ICONERROR);
    end;
  MainUnit.HasPrnDevice:=HasDefPrn; { Set enabled/disabled prn device }
  AnalizeGraphForm:=nil;
  { End Printer Initialization Block }
  Application.CreateForm(TBPViewLFSMainForm, BPViewMainForm);
  Application.CreateForm(TSelectSourceDlg, SelectSourceDlg);
  Application.CreateForm(TPrepareForm, PrepareForm);
  Application.CreateForm(TSelWEBImageDlg, SelWEBImageDlg);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.CreateForm(TBPPropDlg, BPPropDlg);
  Application.CreateForm(TNodeTypeDlg, NodeTypeDlg);
  Application.CreateForm(TTransformTopologySetupDlg, TransformTopologySetupDlg);
  Application.CreateForm(TRamkaPropDlg, RamkaPropDlg);
  Application.CreateForm(TAlgFormatSetupForm, AlgFormatSetupForm);
  Application.CreateForm(TQRepForm, QRepForm);
  Application.CreateForm(TSetupMyUtilsForm, SetupMyUtilsForm);
  Application.CreateForm(TFontSizeDlg, FontSizeDlg);
  Application.CreateForm(TSetCaptionForm1, SetCaptionForm1);
  Application.CreateForm(TSetCaptionForm, SetCaptionForm);
  Application.CreateForm(TSetMaxGOSDlg, SetMaxGOSDlg);
  Application.CreateForm(TAnalizeGraphForm, AnalizeGraphForm);
  Application.CreateForm(TMaxFontDlg, MaxFontDlg);
  Application.CreateForm(TNLDSetupDialog, NLDSetupDialog);
  Application.ShowHint:=True;
  StartForm.CloseTimer.Enabled:=True;
  Application.Run;
end.
