unit FontSizeDlgUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin;

type
  TFontSizeDlg = class(TForm)
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    UpdateAllDiagrams: TCheckBox;
    Bevel4: TBevel;
    procedure CheckBox2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure SpinEdit5Change(Sender: TObject);
  private
    { Private declarations }
    FNFSC,FDNFSC,FDPFSC,FIPFSC,FLFSC:Boolean;
    FONFSC,FODNFSC,FOIPFSC,FOLFSC:Boolean;
  public
    { Public declarations }
    procedure InitDialog;
    property NFSChanged:Boolean read FNFSC;
    property DNFSChanged:Boolean read FDNFSC;
    property DPFSChanged:Boolean read FDPFSC;
    property IPFSChanged:Boolean read FIPFSC;
    property LFSChanged:Boolean read FLFSC;
    property ONFSChanged:Boolean read FONFSC;
    property ODNFSChanged:Boolean read FODNFSC;
    property OIPFSChanged:Boolean read FOIPFSC;
    property OLFSChanged:Boolean read FOLFSC;
  end;

var
  FontSizeDlg: TFontSizeDlg;

implementation

{$R *.DFM}

procedure TFontSizeDlg.InitDialog;
 begin
  FNFSC:=False;
  FDNFSC:=False;
  FDPFSC:=False;
  FIPFSC:=False;
  FLFSC:=False;
  FONFSC:=False;
  FODNFSC:=False;
  FOIPFSC:=False;
  FOLFSC:=False;
 end;

procedure TFontSizeDlg.CheckBox2Click(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FONFSC:=True;
end;

procedure TFontSizeDlg.SpinEdit1Change(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FNFSC:=True;
end;

procedure TFontSizeDlg.CheckBox3Click(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FODNFSC:=True;
end;

procedure TFontSizeDlg.SpinEdit2Change(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FDNFSC:=True;
end;

procedure TFontSizeDlg.SpinEdit3Change(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FDPFSC:=True;
end;

procedure TFontSizeDlg.CheckBox1Click(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FOIPFSC:=True;
end;

procedure TFontSizeDlg.SpinEdit4Change(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FIPFSC:=True;
end;

procedure TFontSizeDlg.CheckBox4Click(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FOLFSC:=True;
end;

procedure TFontSizeDlg.SpinEdit5Change(Sender: TObject);
begin
 if UpdateAllDiagrams.Checked then FLFSC:=True;
end;

end.
