unit SSrcUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Spin, fcLabel;

type
  TSelectSourceDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    RadioGroup: TRadioGroup;
    GroupBox1: TGroupBox;
    HorzZoomEdit: TSpinEdit;
    VertZoomEdit: TSpinEdit;
    Bevel1: TBevel;
    fcLabel1: TfcLabel;
    fcLabel2: TfcLabel;
    SaveProport: TCheckBox;
    GroupBox2: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    PrintHeader: TCheckBox;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure SaveProportClick(Sender: TObject);
    procedure HorzZoomEditChange(Sender: TObject);
    procedure RadioGroupClick(Sender: TObject);
  private
    { Private declarations }
    FPreview:Boolean;
  public
    { Public declarations }
    procedure Prepare(Preview:Boolean);
  end;

var
  SelectSourceDlg: TSelectSourceDlg;

implementation

{$R *.DFM}

procedure TSelectSourceDlg.Prepare(Preview:Boolean);
 begin
   PrintHeader.Checked:=False;
   PrintHeader.Enabled:=(RadioGroup.ItemIndex=1);
   FPreview:=Preview;
 end;

procedure TSelectSourceDlg.FormCreate(Sender: TObject);
begin
 HorzZoomEdit.Value:=1;
 VertZoomEdit.Value:=1;
 SaveProport.Checked:=True;
 VertZoomEdit.Enabled:=False;
end;

procedure TSelectSourceDlg.SaveProportClick(Sender: TObject);
begin
  VertZoomEdit.Enabled:=not(SaveProport.Checked);
end;

procedure TSelectSourceDlg.HorzZoomEditChange(Sender: TObject);
begin
  if SaveProport.Checked then
    VertZoomEdit.Value:=HorzZoomEdit.Value;
end;

procedure TSelectSourceDlg.RadioGroupClick(Sender: TObject);
begin
  if (RadioGroup.ItemIndex=1) and (RadioButton3.Enabled=False) then
      RadioButton3.Enabled:=True;
  case RadioGroup.ItemIndex of
   0:  PrintHeader.Enabled:=False;
   1:  PrintHeader.Enabled:=not(FPreview);
  end;
end;

end.
