program mastero;

uses
  ShareMem,
  Windows,
  Forms,
  SysUtils,
  SyncObjs,
  MasterOFormUnit in 'MasterOFormUnit.pas' {MasterForm},
  MyStringUnit in 'MyStringUnit.pas',
  StartUpFormUnit in 'StartUpFormUnit.pas' {StartUpForm},
  AutoFormatFormUnit in 'AutoFormatFormUnit.pas' {AutoFormatForm},
  AFSetupFormUnit in 'AFSetupFormUnit.pas' {AFSetupForm},
  DebugUnit in 'DebugUnit.pas',
  CreatePrilFormUnit in 'CreatePrilFormUnit.pas' {CreatePrilForm},
  PlanHash in 'PlanHash.pas',
  AboutBoxUnit in 'AboutBoxUnit.pas' {AboutBox},
  ColonTitleDlgUnit in 'ColonTitleDlgUnit.pas' {ColonTitleDlg},
  RichPrint in '..\..\..\Program Files\Borland\Delphi 3\HLAM\RichPrint.pas',
  RichPreview in '..\..\..\Program Files\Borland\Delphi 3\HLAM\RichPreview.pas' {RichPreviewForm},
  RichPreview2 in '..\..\..\Program Files\Borland\Delphi 3\HLAM\RichPreview2.pas' {Preview2},
  RichEdit2 in '..\..\..\Program Files\Borland\Delphi 3\HLAM\Richedit2.pas',
  TextPP in 'Textpp.pas',
  RXCtrls in '..\..\..\Program Files\Borland\Delphi 3\RX\UNITS\Rxctrls.pas',
  BPPropDlgUnit in 'BPPropDlgUnit.pas' {BPPropDlg},
  SelAFTableDlgUnit in 'SelAFTableDlgUnit.pas' {SelAFTableDlg},
  SymbolDlgUnit in 'SymbolDlgUnit.pas' {SymbolDlg},
  FormatDebugDlgUnit in 'FormatDebugDlgUnit.pas' {FormatDebugDlg};

{$R *.RES}

Var hwndPrev:HWND;

begin
  StartUpForm:=TStartUpForm.Create(Application);
  StartUpForm.Show;
  StartUpForm.Update;
  Application.Initialize;
  hwndPrev:=FindWindow('TMasterForm',nil);
  if hwndPrev<>0 then
   begin
    StartUpForm.Timer2.Enabled:=False;
    StartUpForm.Close;
    SetForegroundWindow(hwndPrev);
    Application.Terminate;
    Exit;
   end;
  StartUpForm.Timer2.Enabled:=True;
  Application.Title := '  ';
  Application.HelpFile :='Mastero.hlp';
//  Application.HelpFile :=ExtractFilePath(Application.ExeName)+'Mastero.hlp';
  Application.CreateForm(TMasterForm, MasterForm);
  Application.CreateForm(TAFSetupForm, AFSetupForm);
  Application.CreateForm(TCreatePrilForm, CreatePrilForm);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.CreateForm(TColonTitleDlg, ColonTitleDlg);
  Application.CreateForm(TBPPropDlg, BPPropDlg);
  Application.CreateForm(TSelAFTableDlg, SelAFTableDlg);
  Application.CreateForm(TSymbolDlg, SymbolDlg);
  Application.CreateForm(TFormatDebugDlg, FormatDebugDlg);
  StartUpForm.Timer2.Enabled:=False;
  StartUpForm.Close;
{  AvostForm.Close;}
  Application.Run;
end.
