
////////////////////////////////////////////////////
//                                                //
//   ExcelRpt 2.12                                //
//                                                //
//   Report generator based on Microsoft Excel    //
//                                                //
//   Copyright (C) 2000, Andrew N. Driazgov       //
//   e-mail: andrey@asp.tstu.ru                   //
//                                                //
//   Last updated: November 18, 2000              //
//                                                //
////////////////////////////////////////////////////

unit ExcelRpt;
{
Modified (c) . .  2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes,
  Dialogs, Graphics, Clipbrd, ActiveX, ComObj,Excel_TLB, grids,gauges;

{  ExcelRpt ( TExcelReport)    
         Microsoft Excel.

  2.12 -   ;
  2.11 -   ClearInnerHLines    
             ;
  2.10 -  ,      
           ,       
          /    -   Excel;
  2.09 -      Excel  DDE- 
          ,      
              Excel ( ),    ;
  2.08 -   FontApplied,    
                 Cells;
  2.07 -     TExcelReport.SetColumnsPrnHeader;
  2.06 -  ,      
           Excel     ExcelRpt.    
            ,  Alt+F8,  -
          .     :

         Application.CommandBars(1).Enabled = True

             ( F5),   Excel 
           .    , 
               .    
             -.

          
    Excel.      
  ,       , , 
   .      ,
         . 
       .  ,
     ,       
  Excel ().  ,     , 
        ,    
    Excel,      
       Visual Basic.  
       Microsoft Excel  , 
  Microsoft Excel Visual Basic Reference. }

const

// ,    FormatRange.   
//     " " (OR).

  frBordersLineStyle     = $00000001;  //   
  frBordersWeight        = $00000002;  //   
  frBordersColorIndex    = $00000004;  //   
  frFontBold             = $00000008;  // /  
  frFontColorIndex       = $00000010;  //   
  frFontItalic           = $00000020;  // /  
  frFontName             = $00000040;  //    ( )
  frFontSize             = $00000080;  //   
  frFontStrikethrough    = $00000100;  // /  
  frFontSubscript        = $00000200;  // /  
  frFontSuperscript      = $00000400;  // /  
  frFontUnderline        = $00000800;  // /  
  frHorizontalAlignment  = $00001000;  //    
  frVerticalAlignment    = $00002000;  //    
  frOrientation          = $00004000;  //   
  frWrapText             = $00008000;  // /   
  frShrinkToFit          = $00010000;  //    ,     
  frInteriorColorIndex   = $00020000;  //    
  frInteriorPattern      = $00040000;  //    
  frInteriorPCI          = $00080000;  //   
  frNumberFormat         = $00100000;  //     

  frBorders              = $00000007;  //   ,   
  frFont                 = $00000FF8;  //   ,  
  frAligns               = $0000F000;  //   ,     
  frInterior             = $000E0000;  //  ,     

// ,     (  
//     ) (XlEnableSelection)

  xlNoRestrictions = $00000000;        //   
  xlUnlockedCells = $00000001;         //     
  xlNoSelection = Integer($FFFFEFD2);  //       

//   (XlLineStyle)

  xlNone = Integer($FFFFEFD2);           //  
  xlLineStyleNone = Integer($FFFFEFD2);  //  
  xlContinuous = $00000001;              //  
  xlDash = Integer($FFFFEFED);           //    
  xlDashDot = $00000004;                 //  - 
  xlDashDotDot = $00000005;              //  -  - 
  xlDot = Integer($FFFFEFEA);            //    
  xlDouble = Integer($FFFFEFE9);         //   
  xlSlantDashDot = $0000000D;            //       

//   (XlBordersWeight)

  xlHairline = $00000001;         //   
  xlThin = $00000002;             //  
  xlMedium = Integer($FFFFEFD6);  //    ()
  xlThick = $00000004;            //  

// ,   .     ,
//   . (XlColorIndex)

  xlColorIndexAutomatic = Integer($FFFFEFF7);  //   
  xlColorIndexNone = Integer($FFFFEFD2);       //  

  xlColor1  =  1;  // 
  xlColor53 = 53;  // 
  xlColor52 = 52;  // 
  xlColor51 = 51;  // -
  xlColor49 = 49;  // -
  xlColor11 = 11;  // -
  xlColor55 = 55;  // 
  xlColor56 = 56;  //  80%
  xlColor9  =  9;  // -
  xlColor46 = 46;  // 
  xlColor12 = 12;  // -
  xlColor10 = 10;  // 
  xlColor14 = 14;  // -
  xlColor5  =  5;  // 
  xlColor47 = 47;  // 
  xlColor16 = 16;  //  50%
  xlColor3  =  3;  // 
  xlColor45 = 45;  // -
  xlColor43 = 43;  // 
  xlColor50 = 50;  // 
  xlColor42 = 42;  // -
  xlColor41 = 41;  // -
  xlColor13 = 13;  // 
  xlColor48 = 48;  //  40%
  xlColor7  =  7;  // 
  xlColor44 = 44;  // 
  xlColor6  =  6;  // 
  xlColor4  =  4;  // -
  xlColor8  =  8;  // 
  xlColor33 = 33;  // 
  xlColor54 = 54;  // 
  xlColor15 = 15;  //  25%
  xlColor38 = 38;  // 
  xlColor40 = 40;  // -
  xlColor36 = 36;  // -
  xlColor35 = 35;  // -
  xlColor34 = 34;  // -
  xlColor37 = 37;  // -
  xlColor39 = 39;  // 
  xlColor2  =  2;  // 
  xlColor17 = 17;  // -
  xlColor18 = 18;  // 
  xlColor19 = 19;  //  
  xlColor20 = 20;  // -
  xlColor21 = 21;  // -
  xlColor22 = 22;  // 
  xlColor23 = 23;  // 
  xlColor24 = 24;  //  
  xlColor25 = 25;  // -
  xlColor26 = 26;  // 
  xlColor27 = 27;  // 
  xlColor28 = 28;  // 
  xlColor29 = 29;  // 
  xlColor30 = 30;  // -
  xlColor31 = 31;  // -
  xlColor32 = 32;  // 

//   (XlUnderlineStyle)

  xlUnderlineStyleNone = Integer($FFFFEFD2);     //  
  xlUnderlineStyleSingle = $00000002;            //    
  xlUnderlineStyleSingleAccounting = $00000004;  //    
  xlUnderlineStyleDouble = Integer($FFFFEFE9);   //    
  xlUnderlineStyleDoubleAccounting = $00000005;  //    

//    (XlHAlign)

  xlHAlignCenter = Integer($FFFFEFF4);        //   
  xlHAlignCenterAcrossSelection = $00000007;  //    
  xlHAlignLeft = Integer($FFFFEFDD);          //     (  )
  xlHAlignRight = Integer($FFFFEFC8);         //    
  xlHAlignFill = $00000005;                   //   
  xlHAlignGeneral = $00000001;                //      
  xlHAlignJustify = Integer($FFFFEFDE);       //   ,     

//    (XlVAlign)

  xlVAlignCenter = Integer($FFFFEFF4);       //   
  xlVAlignTop = Integer($FFFFEFC0);          //    
  xlVAlignBottom = Integer($FFFFEFF5);       //    
  xlVAlignJustify = Integer($FFFFEFDE);      //   ,     

// ,    (XlPattern)

  xlPatternAutomatic = Integer($FFFFEFF7);   //  
  xlPatternChecker = $00000009;              //   
  xlPatternCrissCross = $00000010;           //   
  xlPatternDown = Integer($FFFFEFE7);        //   
  xlPatternGray16 = $00000011;               // 12.5- 
  xlPatternGray25 = Integer($FFFFEFE4);      // 25%- 
  xlPatternGray50 = Integer($FFFFEFE3);      // 50%- 
  xlPatternGray75 = Integer($FFFFEFE2);      // 75%- 
  xlPatternGray8 = $00000012;                // 6.25- 
  xlPatternGrid = $0000000F;                 //   
  xlPatternHorizontal = Integer($FFFFEFE0);  //  
  xlPatternLightDown = $0000000D;            //    
  xlPatternLightHorizontal = $0000000B;      //   
  xlPatternLightUp = $0000000E;              //    
  xlPatternLightVertical = $0000000C;        //   
  xlPatternNone = Integer($FFFFEFD2);        //  
  xlPatternSemiGray75 = $0000000A;           //   
  xlPatternSolid = $00000001;                //  
  xlPatternUp = Integer($FFFFEFBE);          //   
  xlPatternVertical = Integer($FFFFEFBA);    //  

//   (      -90  90 )
// (XlOrientation)

  xlDownward = Integer($FFFFEFB6);    //   .
  xlHorizontal = Integer($FFFFEFE0);  //   
  xlUpward = Integer($FFFFEFB5);      //   .
  xlVertical = Integer($FFFFEFBA);    //  .        .

//    (XlOrder)

  xlDownThenOver = $00000001;  // ,  
  xlOverThenDown = $00000002;  // ,  

//   (XlPageOrientation)

  xlPortrait = $00000001;   // 
  xlLandscape = $00000002;  // 

//   (XlPaperSize)

  xlPaper10x14 = $00000010;
  xlPaper11x17 = $00000011;
  xlPaperA3 = $00000008;
  xlPaperA4 = $00000009;
  xlPaperA4Small = $0000000A;
  xlPaperA5 = $0000000B;
  xlPaperB4 = $0000000C;
  xlPaperB5 = $0000000D;
  xlPaperCsheet = $00000018;
  xlPaperDsheet = $00000019;
  xlPaperEnvelope10 = $00000014;
  xlPaperEnvelope11 = $00000015;
  xlPaperEnvelope12 = $00000016;
  xlPaperEnvelope14 = $00000017;
  xlPaperEnvelope9 = $00000013;
  xlPaperEnvelopeB4 = $00000021;
  xlPaperEnvelopeB5 = $00000022;
  xlPaperEnvelopeB6 = $00000023;
  xlPaperEnvelopeC3 = $0000001D;
  xlPaperEnvelopeC4 = $0000001E;
  xlPaperEnvelopeC5 = $0000001C;
  xlPaperEnvelopeC6 = $0000001F;
  xlPaperEnvelopeC65 = $00000020;
  xlPaperEnvelopeDL = $0000001B;
  xlPaperEnvelopeItaly = $00000024;
  xlPaperEnvelopeMonarch = $00000025;
  xlPaperEnvelopePersonal = $00000026;
  xlPaperEsheet = $0000001A;
  xlPaperExecutive = $00000007;
  xlPaperFanfoldLegalGerman = $00000029;
  xlPaperFanfoldStdGerman = $00000028;
  xlPaperFanfoldUS = $00000027;
  xlPaperFolio = $0000000E;
  xlPaperLedger = $00000004;
  xlPaperLegal = $00000005;
  xlPaperLetter = $00000001;
  xlPaperLetterSmall = $00000002;
  xlPaperNote = $00000012;
  xlPaperQuarto = $0000000F;
  xlPaperStatement = $00000006;
  xlPaperTabloid = $00000003;
  xlPaperUser = $00000100;

//    (XlCommentDisplayMode)

  xlNoIndicator = $00000000;                    //  
  xlCommentIndicatorOnly = Integer($FFFFFFFF);  //  
  xlCommentAndIndicator = $00000001;            //   

// ,         

  xlDoesnotUpdateAnyRefs = 0;             //    
  xlUpdateExternalButNotRemoteRefs = 1;   //  ,     
  xlUpdateRemoteButNotExternalRefs = 2;   //  ,     
  xlUpdateBothRemoteAndExternalRefs = 3;  //      

//       (xlDelimiterType)

  xlTabsDelimiter       = 1;  //   (#8)
  xlCommasDelimiter     = 2;  // 
  xlSpacesDelimiter     = 3;  // 
  xlSemicolonsDelimiter = 4;  //   
  xlNothingDelimiter    = 5;  //  
  xlCustomDelimiter     = 6;  //  

// ,  ,     
// (XlPlatform)

  xlMacintosh = $00000001;  // Apple Macintosh
  xlMSDOS = $00000003;      //  MS-DOS
  xlWindows = $00000002;    //  Windows

// ,    

  xlAutomatic = Integer($FFFFEFF7);

// ,     

type
  PPageSetup = ^TPageSetup;
  TPageSetup = record
    BlackAndWhite: Boolean;       // - 
    mm_BottomMargin: Double;      //  , 
    CenterFooter: string;         // ,  ,     
    CenterHeader: string;         // ,  ,     
    CenterHorizontally: Boolean;  //    
    CenterVertically: Boolean;    //    
    Draft: Boolean;               //  True,  
    FirstPageNumber: Integer;     //     xlAutomatic
    FitToPagesTall: Variant;      // False     ,      
    FitToPagesWide: Variant;      // False     ,      
    mm_FooterMargin: Double;      //  , 
    mm_HeaderMargin: Double;      //  , 
    LeftFooter: string;           // ,  ,      
    LeftHeader: string;           // ,  ,      
    mm_LeftMargin: Double;        //  , 
    Order: Integer;               //    ( XlOrder)
    Orientation: Integer;         //   ( XlPageOrientation)
    PaperSize: Integer;           //   ( XlPaperSize)
    PrintGridlines: Boolean;      //  
    PrintHeadings: Boolean;       //     
    RightFooter: string;          // ,  ,      
    RightHeader: string;          // ,  ,      
    mm_RightMargin: Double;       //  , 
    mm_TopMargin: Double;         //  , 
    Zoom: Variant;                // False  ,     ( )
  end;

type
  PStoredParams = ^TStoredParams;
  TStoredParams = record
    App_SheetsInNewWorkbook: Integer;
    App_DisplayFormulaBar: WordBool;
    App_ReferenceStyle: LongWord;
    App_DisplayStatusBar: WordBool;
    App_IgnoreRemoteRequests: WordBool;
  end;
  TexcelReport = class;
  TExcelBook=class;
  TExcelSheet  = class
  private
    fOwner: TExcelBook;
    fSheet: ExcelWorkSheet;
    FID: Integer;
    FBordersLineStyle: Integer;
    FBordersWeight: Integer;
    FBordersColorIndex: Integer;
    FFontColorIndex: Integer;
    FFontName: string;
    FFontSize: Integer;
    FFontUnderline: Integer;
    FHorizontalAlignment: Integer;
    FVerticalAlignment: Integer;
    FOrientation: Integer;
    FInteriorColorIndex: Integer;
    FInteriorPattern: Integer;
    FInteriorPCI: Integer;
    FLeftWorkColumn: Integer;
    FUpperWorkRow: Integer;
    FNumberFormat: string;
    FFontBold: Boolean;
    FFontItalic: Boolean;
    FFontStrikethrough: Boolean;
    FFontSubscript: Boolean;
    FFontSuperscript: Boolean;
    FWrapText: Boolean;
    FShrinkToFit: Boolean;
    FFontApplied: Boolean;
    fMergeAreas:TList;
    fAutoFitRanges:TList;
    procedure InitVariables;
    function GetCells(R,C: Integer): string;
    procedure SetCells(R,C: Integer; AValue: string);
    function GetFormulas(R, C: Integer): string;
    procedure SetFormulas(R, C: Integer; const Value: string);
    function GetFormulasR1C1(R, C: Integer): string;
    procedure SetFormulasR1C1(R, C: Integer; const Value: string);
    function GetDisplayPageBreaks: Boolean;
    procedure SetDisplayPageBreaks(Value: Boolean);
    function GetEnableSelection: Integer;
    procedure SetEnableSelection(Value: Integer);
    function getName:string;
    procedure SetName(s:string);
    procedure ClearMergeAreas;
    procedure ClearAutoFitRanges;
    procedure AddMergeArea(R1,C1,R2,C2:integer);
 public
   property SheetInterface:ExcelWorkSheet read fSheet;
   constructor Create(owner:TExcelBook;ID:integer;Sheet:ExcelWorkSheet);
   destructor Destroy;override;
  { SetColumnsPrnHeader  , ,    
        ,      
    ( ). C1  C2 - , ,   
      . }

    procedure SetColumnsPrnHeader(C1, C2: Integer);

  { SetRowsPrnHeader  ,      
        (..   ). R1  R2 -
           . }
    procedure GetText(var TextTable:Variant;Bounds:array of integer);
    procedure SetRowsPrnHeader(R1, R2: Integer);
  {  CreateTable  ,   
     V,    ,    (R,C),
     R -  ,  C -  .  IsFontUsed = True,  
            . 
    IsFramed  True,      
      BordersColorIndex, BordersLineStyle  BordersWeight. 
         Excel  ,  
        (   Cells).

           :
      V: Variant;

               
    . ,  RCnt -  ,  CCnt -  . ,

      V := VarArrayCreate([1, RCnt, 1, CCnt], varVariant);

         .  
      .       : ,
    , , ,    ..    
      V[R,C],  R -   ( 1  RCnt),  C - 
     ( 1  CCnt).   ,     
     ,   :

      V := VarArrayCreate([0, RCnt-1, 0, CCnt-1], varVariant);

      V (   ) 
         CreateTable. }
    function CellValue(R,C:integer):string;

  {  Cells       
    ,    R-   C- .  
           . 
          ,  
    FontApplied  True ( ). }
    property Cells[R,C: Integer]: string read GetCells write SetCells;
  {  Formulas       ,
       R-   C- .  
         . }

    property Formulas[R,C: Integer]: string read GetFormulas write SetFormulas;
    property FormulaR1C1[R,C: Integer]: string read GetFormulasR1C1 write SetFormulasR1C1;

  {  FontApplied  ,     
     ,       Cells  Formulas. 
    FontApplied  True,    , ,  . }

    property FontApplied: Boolean read FFontApplied write FFontApplied;

  { SetHPageBreaks       ( ).
            , 
      ,     . }

    procedure SetHPageBreaks(Rows: array of Integer);

  { SetVPageBreaks       ( ).
            , 
      ,      . }

    procedure SetVPageBreaks(Columns: array of Integer);
    function getHPageBreakCount:integer;
    function getHPageBreak(i:integer):integer;
    function getVPageBreakCount:integer;
    function getVPageBreak(i:integer):integer;


  {  DisplayPageBreaks     
     .  DisplayPageBreaks   True,  
           . }

    property DisplayPageBreaks: Boolean read GetDisplayPageBreaks write SetDisplayPageBreaks;

  {         , .. 
     ,   SetHPageBreaks  SetVPageBreaks. }

    procedure ResetAllPageBreaks;

  { SetColumnsWidth     C1-  C2-  ,
       W.     W  
       (2-1+1). }
    function getColumnWidth(C: Integer):integer;
    procedure SetColumnWidth(C: Integer; W: Integer);

  { SetRowsHeight     R1-  R2-  , 
      H.     H   
     (R2-R1+1). }
    function getRowHeight(R: Integer):integer;
    procedure SetRowHeight(R: Integer; H:Integer);

  {  BordersColorIndex   ,   
     . ( XlColorIndex) }

    property BordersColorIndex: Integer read FBordersColorIndex write FBordersColorIndex;

  {  BordersLineStyle     . (
    XlLineStyle) }

    property BordersLineStyle: Integer read FBordersLineStyle write FBordersLineStyle;

  {  BordersWeight     . (
    XlBordersWeight) }

    property BordersWeight: Integer read FBordersWeight write FBordersWeight;

  { DrawAllFrames       
      (R1,C1)-(R2,C2)   ,  
     ,   BordersColorIndex, BordersLineStyle 
    BordersWeight. }

    procedure DrawAllFrames(R1,C1,R2,C2: Integer);

  { DrawInnerFrames       
      (R1,C1)-(R2,C2). }

    procedure DrawInnerFrames(R1,C1,R2,C2: Integer);

  { DrawOuterFrame       
      (R1,C1)-(R2,C2). }

    procedure DrawOuterFrame(R1,C1,R2,C2: Integer);

  { DrawLeftLines    ,     
          (R1,C1)-(R2,C2). }

    procedure DrawLeftLines(R1,C1,R2,C2: Integer);

  { DrawRightLines    ,     
          (R1,C1)-(R2,C2). }

    procedure DrawRightLines(R1,C1,R2,C2: Integer);

  { DrawTopLines    ,     
           (R1,C1)-(R2,C2). }

    procedure DrawTopLines(R1,C1,R2,C2: Integer);

  { DrawBottomLines    ,     
           (R1,C1)-(R2,C2). }

    procedure DrawBottomLines(R1,C1,R2,C2: Integer);

  { DrawDiagonalLines      
     (R1,C1)-(R2,C2)   ()  
     ,    .   IsDown  True,
              .
      IsUp  True,      
         . }

    procedure DrawDiagonalLines(R1,C1,R2,C2: Integer; IsDown, IsUp: Boolean);

  { ClearInnerHLines      
        (R1,C1)-(R2,C2). }

    procedure ClearInnerHLines(R1,C1,R2,C2: Integer);

  { MergeRowCells        
     (R1,C1)-(R2,C2). }

    procedure MergeRowCells(R1,C1,R2,C2: Integer);

  { MergeAllCells       
    (R1,C1)-(R2,C2)   . }

    procedure MergeAllCells(R1,C1,R2,C2: Integer);
    procedure AddAutoFitArea(R1,C1,R2,C2:integer);
    procedure ApplyMergeAreas;
    function MergeCount:integer;
  { UnMergeCells       
    (R1,C1)-(R2,C2). }

    procedure UnMergeCells(R1,C1,R2,C2: Integer);

    function getMergeArea(R,C: Integer):String;
    function MergeRectangle(R,C: Integer):TRect;

  { InsertColumns  Count      
       C (  ).   
         . }

    procedure InsertColumns(C, Count: Integer);

  { InsertRows  Count       
      R (  ).     
       R. }

    procedure InsertRows(R, Count: Integer);

  { DeleteColumns  Count     , 
        C (  ). }

    procedure DeleteColumns(C, Count: Integer);

  { DeleteRows  Count     ,   
      R (  ). }

    procedure DeleteRows(R, Count: Integer);

  { AutoFitColumns   Count ,    
     C,  ,       
     . }

    procedure AutoFitColumns(C, Count: Integer);

  { AutoFitRows   Count ,      R,
     ,        
    . }

    procedure AutoFitRows(R, Count: Integer);
    procedure setTextWrap(R,C,H,W:integer;Value:boolean);

  {  FontBold     () . }

    property FontBold: Boolean read FFontBold write FFontBold;

  {  FontColorIndex      ( 
     XlColorIndex). }

    property FontColorIndex: Integer read FFontColorIndex write FFontColorIndex;

  {  FontItalic     . }

    property FontItalic: Boolean read FFontItalic write FFontItalic;

  {  FontName     
    ( ). }

    property FontName: string read FFontName write FFontName;

  {  FontSize     . }

    property FontSize: Integer read FFontSize write FFontSize;

  {  FontStrikethrough     (
       ). }

    property FontStrikethrough: Boolean read FFontStrikethrough write FFontStrikethrough;

  {  FontSubscript     . }

    property FontSubscript: Boolean read FFontSubscript write FFontSubscript;

  {  FontSuperscript     . }

    property FontSuperscript: Boolean read FFontSuperscript write FFontSuperscript;

  {  FontUnderline    . }

    property FontUnderline: Integer read FFontUnderline write FFontUnderline;

  { AlignHorizontal    , 
     (R1,C1)  (R2,C2)  ,  
      HAlign ( XlHAlign).  HAlign=xlHAlignLeft
    (   ),      ( 
     Indent). }

    procedure AlignHorizontal(R1,C1,R2,C2, HAlign: Integer; Indent: Integer = 0);
    procedure CopyCells(fromSheet:TExcelSheet;fromRect:TRect;ToPoint:TPoint);
    procedure CopyBorders(fromSheet:TExcelSheet;fromRect:TRect;ToPoint:TPoint);
    procedure CopyCell(fromSheet:TExcelSheet;fromPoint:TPoint;ToPoint:TPoint);


  { AlignVertical    ,  
    (R1,C1)  (R2,C2)  ,   
     VAlign ( XlVAlign). }

    procedure AlignVertical(R1,C1,R2,C2, VAlign: Integer);

  { SetArrangement    ,  
    (R1,C1)  (R2,C2)  :   (AOrientation)
    ( XlOrientation),      
    (IsWrapText),    ,     
        ,      
      (IsShrinkToFit). }

    procedure SetArrangement(R1,C1,R2,C2: Integer;
      AOrientation: Integer; IsWrapText, IsShrinkToFit: Boolean);

  { Justify        
     (   ) ,     
           .  
        .      
     .     ,
       -- Microsoft Excel. }

    procedure Justify(R1,C1,R2,C2: Integer);

  { SetInterior      (R1,C1)-(R2,C2). 
     (AColorIndex)    ( XlColorIndex),
      (APattern)    ( XlPattern),
       (APatternColorIndex)    
    ( XlColorIndex). }

    procedure SetInterior(R1,C1,R2,C2: Integer;
      AColorIndex, APattern, APatternColorIndex: Integer);

  {          
       FormatRange. }

  {  HorizontalAlignment    
     (   XlHAlign). }

    property HorizontalAlignment: Integer read FHorizontalAlignment write FHorizontalAlignment;

  {  VerticalAlignment     
    (   XlVAlign). }

    property VerticalAlignment: Integer read FVerticalAlignment write FVerticalAlignment;

  {  Orientation      (
    XlOrientation). }

    property Orientation: Integer read FOrientation write FOrientation;

  {  WrapText      
      . }

    property WrapText: Boolean read FWrapText write FWrapText;

  {  ShrinkToFit      
    ()       ,     
       (    ). }

    property ShrinkToFit: Boolean read FShrinkToFit write FShrinkToFit;

  {  InteriorColorIndex       (
    XlColorIndex). }

    property InteriorColorIndex: Integer read FInteriorColorIndex write FInteriorColorIndex;

  {  InteriorPattern       
    ( XlPattern). }

    property InteriorPattern: Integer read FInteriorPattern write FInteriorPattern;

  {  InteriorPatternColorIndex     
    ( XlColorIndex). }

    property InteriorPatternColorIndex: Integer read FInteriorPCI write FInteriorPCI;

  { ApplyNumberFormat   ,   Fmt 
      (R1,C1)-(R2,C2).    
         ,   ""  
    " ",    - Microsoft Excel. }

    procedure ApplyNumberFormat(R1,C1,R2,C2: Integer; const Fmt: string);

  {  NumberFormat   ,  
     .    . }

    property NumberFormat: string read FNumberFormat write FNumberFormat;

  { FormatRange     (R1,C1)-(R2,C2) 
     , , ,  .  
     ,     Flags.  
    ,    ,     
       . }

    procedure FormatRange(R1,C1,R2,C2, Flags: Integer);


  { UnProtectSheet     .     
    ,        Password
    (   ). }

    procedure UnProtectSheet(Password: string);

  { Lock    (R1,C1)-(R2,C2)  ,  
             
    .    EnableSelection  xlUnlockedCells,
              
          . }

    procedure Lock(R1,C1,R2,C2: Integer);

  { UnLock       (R1,C1)-(R2,C2). 
    ,     ,    
      . }

    procedure UnLock(R1,C1,R2,C2: Integer);

  {  EnableSelection    
    (   ). ( XlEnableSelection) }

    property EnableSelection: Integer read GetEnableSelection write SetEnableSelection;

  { Clear       
    (R1,C1)-(R2,C2).   OnlyContents  True,  
      ,   OnlyFormats  True,
       ,  OnlyOutline  True, 
       . }
    procedure ClearAll;
    procedure Clear(R1, C1, R2, C2: Integer; OnlyContents: Boolean = False;
      OnlyFormats: Boolean = False; OnlyOutline: Boolean = False);
    property Name:String read getName write SetName;
    procedure MakeActive;
    function RightColumn:integer;
    function BottomRow:integer;
  end;
  TExcelBook = class
  private
   fFileName:string;
    FSheets: TList;
    FSPms: PStoredParams;
    FWNLong: string;
    FWNShort: string;
    fowner:TExcelReport;
    fBook:ExcelWorkBook;
  protected
   function getSheet(index:integer):TExcelSheet;
   function getSheetCount:integer;
  public

  {  FApp       
    Microsoft Excel.     , ,
     , -   .     FApp
           Excel97. }

    FWorkBook: ExcelWorkBook;
  {  Create    ,   CountOfSheets
    .       .  IsShortToolBar
     True,       (
        ). ,   ,
             
      - .        
            , 
      . }
    property Book:ExcelWorkBook read fBook;
    constructor Create(owner:TExcelReport;Book:ExcelWorkBook;filename:string);

    destructor Destroy; override;

  procedure SaveAs(SavefileName:String);
  procedure Close;
  procedure Activate;

  {  NameOfSheet       
       (   ). }

   property FileName:string read fFilename;
   property Sheet[index:integer]:TExcelSheet read getSheet;
   property SheetCount:integer read getSheetCount;
  {  ActiveSheetNumber      -
       , ..     
          (   ). }
  {  WinCaption1  WinCaption2    ,
       .     :  
      "Microsoft Excel"  "ExcelRpt",     
        .       
       ,    WinCaption1
     WinCaption2, . }
  end;

  TExcelReport = class
  private
   fFileName:string;
    FBooks: TList;
    FSPms: PStoredParams;
    FWNLong: string;
    FWNShort: string;
    FExcelWasFound: Boolean;
    FVisible: Boolean;
    fActiveBookNumber:integer;
    procedure InitVariables;
    procedure RestoreOldParams;
    procedure SetVisible(A: Boolean);
    function GetScreenUpdating: Boolean;
    procedure SetScreenUpdating(Value: Boolean);
    function GetDisplayStatusBar: Boolean;
    procedure SetDisplayStatusBar(Value: Boolean);
    procedure SetDisplayFormulaBar(Value: Boolean);
  protected
   function getBook(index:integer):TExcelBook;
  public

  {  FApp       
    Microsoft Excel.     , ,
     , -   .     FApp
           Excel97. }
    Progress:TGauge;
    FApp: ExcelApplication;

  {  Create    ,   CountOfSheets
    .       .  IsShortToolBar
     True,       (
        ). ,   ,
             
      - .        
            , 
      . }

    constructor Create(IsShortToolBar: Boolean = False);

  {  Destroy   MS Excel   ,
      .      (
      Free).       . }

    destructor Destroy; override;

  {  ExcelWasFound  True,  Microsoft Excel   
        (..    
     OpenNewFile  ). }

    property ExcelWasFound: Boolean read FExcelWasFound;

   function OpenNewFile(const FileName: string; ReadOnly: Boolean):TExcelBook;
   function AddBook(const FileName: string):TExcelBook;
  { GetPageSetup       TPageSetup,
      PS. }

    procedure GetPageSetup(var PS: TPageSetup);
    procedure SetUserControl;

  { SetPageSetup        
    ,   PS. }

    procedure SetPageSetup(var PS: TPageSetup);

   property Book[index:integer]:TExcelBook read getBook;

  {  Visible      Microsoft Excel. 
           . 
          Microsoft Excel. }

    property Visible: Boolean read FVisible write SetVisible;

  {  ScreenUpdating      
     (  Microsoft Excel , ..  Visible  True).
            
       (     ). }

    property ScreenUpdating: Boolean read GetScreenUpdating write SetScreenUpdating;

  {  DisplayStatusBar     
        Microsoft Excel.   ,
     ,     . }

    property DisplayStatusBar: Boolean read GetDisplayStatusBar write SetDisplayStatusBar;


  {  DisplayFormulaBar    . 
        True,   . }

    property DisplayFormulaBar: Boolean write SetDisplayFormulaBar;

  {  WinCaption1  WinCaption2    ,
       .     :  
      "Microsoft Excel"  "ExcelRpt",     
        .       
       ,    WinCaption1
     WinCaption2, . }
  end;

{ ToggleScrollLockOn    Scroll Lock ( 
   ,    ).   Excel 
    , ..      
    .       
  .        , ,
  ,      SCROLL LOCK ( 
   Excel       ). }

procedure ToggleScrollLockOn;

{ ToggleScrollLockOff   Scroll Lock,   .  
        (  finalization), 
        . }

procedure ToggleScrollLockOff;

{            
  .  () FixDestCell    ,
           .
   E_CAdr  ,      
   ,   .  CAdr 
   ,     . ,   
  FixDestCell(3,6)   E_CAdr(4,5)   "=R6C10", 
   CAdr(-1,0)   "R1C5".    
     InsR, InsC. }

procedure FixDestCell(R, C: Integer);
function E_CAdr(R, C: Integer): string;
function CAdr(R, C: Integer): string;
function Col2Number(s:string):integer;
var
  InsR, InsC: Integer;

implementation
uses variants,fileutil,types,logs, utils,oleserver,otherlists;
const
  ExcelNotFoundErrMsg = '       '+
    '     Microsoft Excel 97 '+
    ' Microsoft Excel 2000.'^M^M' ,    '+
    '  Microsoft Excel  .';

  PointsToMM: Double = 25.4/72;
  MMToPoints: Double = 72/25.4;
  EXLReportLCID = LOCALE_USER_DEFAULT;
var   
Ua:Variant;
procedure ToggleScrollLockOn;
var
  ScanCode: Byte;
begin
  if GetKeyState(VK_SCROLL) and 1 = 0 then
  begin
    ScanCode := Lo(MapVirtualKey(VK_SCROLL, 0));
    keybd_event(VK_SCROLL, ScanCode, 0, 0);
    keybd_event(VK_SCROLL, ScanCode, KEYEVENTF_KEYUP, 0);
  end;
end;

procedure ToggleScrollLockOff;
var
  ScanCode: Byte;
begin
  if GetKeyState(VK_SCROLL) and 1 <> 0 then
  begin
    ScanCode := Lo(MapVirtualKey(VK_SCROLL, 0));
    keybd_event(VK_SCROLL, ScanCode, 0, 0);
    keybd_event(VK_SCROLL, ScanCode, KEYEVENTF_KEYUP, 0);
  end;
end;

procedure ExchgVals(var A,B);
asm
        PUSH    EBX
        MOV     ECX,[EDX]
        MOV     EBX,[EAX]
        MOV     [EAX],ECX
        MOV     [EDX],EBX
        POP     EBX
end;

procedure FixDestCell(R, C: Integer);
begin
  InsR := R-1;
  InsC := C-1;
end;

function E_CAdr(R, C: Integer): string;
begin
  Result := '=R'+IntToStr(InsR+R)+'C'+IntToStr(InsC+C);
end;

function CAdr(R, C: Integer): string;
begin
  Result := 'R'+IntToStr(InsR+R)+'C'+IntToStr(InsC+C);
end;

{ TExcelReport }

constructor TExcelReport.Create(IsShortToolBar: Boolean);
begin
  FExcelWasFound := True;
    try
    fApp := CoExcelApplication.Create;

  except
    FExcelWasFound := False;
  end;
  if FExcelWasFound then
  begin
    FApp.UserControl:=false;
    FApp.EnableEvents := false;
    fBooks:=TList.create;
    InitVariables;
    New(FSPms);
    with FApp do
    begin
//      Set_DisplayFormulaBar(0, true);
      Set_ReferenceStyle(0, (xlR1C1));
//      Set_DisplayStatusBar(0, False);
      Set_Caption('ExcelReport');
    end;
//    CreateToolBar(IsShortToolBar);
    logs.startproc('ExcelRPT','startExcel','','',5);
  end else
    ShowMessage(ExcelNotFoundErrMsg);
end;

constructor TExcelBook.Create(owner:TExcelReport;Book:ExcelWorkBook;FileName:string);
var
 newSheet:TExcelSheet;
 i:integer;
begin
    fSheets:=TList.create;
    fBook:=Book;
    fowner:=owner;
  ffilename:=utils.RemoveDuplicatedSlashes(FileName);

      for i:=1 to Book.Get_Sheets.Get_Count do
      begin
      newSheet:=TExcelSheet.create(self,i,Book.Get_Sheets.item[i] as ExcelWorkSheet);
      fsheets.add(newSheet);
      end;

end;

function TExcelReport.OpenNewFile(const FileName: string; ReadOnly: Boolean):TExcelBook;
var
  WB: _WorkBook;
  WBooks:OleVariant;
  newBook:TExcelBook;
  realFilename:string;
  ii:IInterface ;
begin
//  RestoreOldParams;
  realfilename:=utils.RemoveDuplicatedSlashes(filename);
  InitVariables;
  with FApp do
  begin
    logs.startproc('ExcelRPT','OpenNewfile','',realfilename,5);
    if not fileexists(realfilename) then
    begin
    logs.startproc('ExcelRPT','OpenNewfile','Error','File not found',5);
    end;
    WBooks:=Get_Workbooks;
    ii := WBooks.Open(realFileName, 0, ReadOnly, 4);
    ii.QueryInterface(_WorkBook,WB);
    Get_ActiveWindow.DisplayWorkbookTabs := WB.Get_Sheets.Get_Count > 1;
    newBook:=TExcelBook.create(self,WB,realfilename);
    result:=newbook;
    fbooks.add(newBook);
    WB:=nil;
//    MakeVBScript(WB);
  end;
end;
function TExcelReport.AddBook(const FileName: string):TExcelBook;
var
  WB: ExcelWorkBook;
  newBook:TExcelBook;
  realfilename:string;
  WBooks,WBEmpty:olevariant;
  ii:IInterface ;
begin
//  RestoreOldParams;
realfilename:=utils.RemoveDuplicatedSlashes(filename);
  InitVariables;
  with FApp do
  begin
logs.startproc('ExcelRPT','AddBook','',realfilename,5);
UA:=unassigned;
if filename<>'' then
    WB := Get_Workbooks.Add(realfilename,EXLReportLCID)
else
begin
WBooks:=Get_WorkBooks;
ii:=(WBooks.add);
ii.QueryInterface(_WorkBook,WB);
//fApp.ActiveWindow.View:=xlNormalView;
end;
    newBook:=TExcelBook.create(self,WB,realfilename);
    newBook.FWorkBook:=WB;
    result:=newbook;
    fbooks.add(newBook);
    WB:=nil;
//    MakeVBScript(WB);
  end;
end;



destructor TExcelBook.Destroy;
var i:integer;
begin
  begin
    for i:=0 to fsheets.count-1 do
     TExcelSheet(fsheets[i]).free;
    fsheets.free;
    Dispose(FSPms);

  end;
  fBook:=nil;
  inherited Destroy;
end;
destructor TExcelReport.Destroy;
var i:integer;
begin
    for i:=0 to fBooks.count-1 do
     TExcelBook(fbooks[i]).free;
    fbooks.free;
 if FExcelWasFound then
  begin
//     RestoreOldParams;
FApp.UserControl:=true;
FApp.EnableEvents := true;
    if not fvisible then
    begin
    FApp.Quit;
    end;
    Dispose(FSPms);
  end;
//  fApp.free;
  inherited Destroy;
end;

procedure TExcelSheet.DrawAllFrames(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].Borders do
  begin
    ColorIndex := FBordersColorIndex;
    LineStyle := FBordersLineStyle;
    Weight := FBordersWeight;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.DrawInnerFrames(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
  begin
    if R1 <> R2 then
      with Borders[xlInsideHorizontal] do
      begin
        ColorIndex := FBordersColorIndex;
        LineStyle := FBordersLineStyle;
        Weight := FBordersWeight;
      end;
    if C1 <> C2 then
      with Borders[xlInsideVertical] do
      begin
        ColorIndex := FBordersColorIndex;
        LineStyle := FBordersLineStyle;
        Weight := FBordersWeight;
      end;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.DrawOuterFrame(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].BorderAround(FBordersLineStyle,
    FBordersWeight,FBordersColorIndex,Null);
    Rng:=nil;
end;

procedure TExcelSheet.DrawLeftLines(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
  begin
    if C1 <> C2 then
      with Borders[xlInsideVertical] do
      begin
        ColorIndex := FBordersColorIndex;
        LineStyle := FBordersLineStyle;
        Weight := FBordersWeight;
      end;
    with Borders[xlEdgeLeft] do
    begin
      ColorIndex := FBordersColorIndex;
      LineStyle := FBordersLineStyle;
      Weight := FBordersWeight;
    end;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.DrawRightLines(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
  begin
    if C1 <> C2 then
      with Borders[xlInsideVertical] do
      begin
        ColorIndex := FBordersColorIndex;
        LineStyle := FBordersLineStyle;
        Weight := FBordersWeight;
      end;
    with Borders[xlEdgeRight] do
    begin
      ColorIndex := FBordersColorIndex;
      LineStyle := FBordersLineStyle;
      Weight := FBordersWeight;
    end;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.DrawTopLines(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
  begin
    if R1 <> R2 then
      with Borders[xlInsideHorizontal] do
      begin
        ColorIndex := FBordersColorIndex;
        LineStyle := FBordersLineStyle;
        Weight := FBordersWeight;
      end;
    with Borders[xlEdgeTop] do
    begin
      ColorIndex := FBordersColorIndex;
      LineStyle := FBordersLineStyle;
      Weight := FBordersWeight;
    end;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.DrawBottomLines(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
  begin
    if R1 <> R2 then
      with Borders[xlInsideHorizontal] do
      begin
        ColorIndex := FBordersColorIndex;
        LineStyle := FBordersLineStyle;
        Weight := FBordersWeight;
      end;
    with Borders[xlEdgeBottom] do
    begin
      ColorIndex := FBordersColorIndex;
      LineStyle := FBordersLineStyle;
      Weight := FBordersWeight;
    end;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.DrawDiagonalLines(R1,C1,R2,C2: Integer;
  IsDown,IsUp: Boolean);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
  begin
    if IsDown then
      with Borders[xlDiagonalDown] do
      begin
        ColorIndex := FBordersColorIndex;
        LineStyle := FBordersLineStyle;
        Weight := FBordersWeight;
      end;
    if IsUp then
      with Borders[xlDiagonalUp] do
      begin
        ColorIndex := FBordersColorIndex;
        LineStyle := FBordersLineStyle;
        Weight := FBordersWeight;
      end;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.ClearInnerHLines(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  if R1 <> R2 then
  begin
    Rng := fSheet.Get_Cells;
    with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
      Borders[xlInsideHorizontal].LineStyle := xlLineStyleNone;
  end;
  Rng:=nil;
end;
function TExcelSheet.CellValue(R,C:integer):string;
var v:variant;
    rng,Rng1,RngA: Range;
    R1,C1:integer;
begin
  Rng := fSheet.Get_Cells;
  Rng1:=Rng.Range_[Rng.item[R,C],Rng.item[R,C]];
  RngA:=Rng1.MergeArea;
  R1:=RngA.Row;
  C1:=RngA.Column;
  v:=RngA.Item[1,1];
  result:=string(v);
  Rng:=nil;
  Rng1:=nil;
  RngA:=nil;
end;
procedure TExcelSheet.GetText(var TextTable:Variant;Bounds:array of integer);
var rng:Range;
begin
rng:=fsheet.get_Cells;
rng:=rng.Range_[Rng.Item[Bounds[1],Bounds[0]],Rng.item[Bounds[3],Bounds[2]]];
textTable:=rng.Value;
end;
function TExcelSheet.GetCells(R,C: Integer):string;
var v:variant;

begin
  v := fSheet.Get_Cells.Item[R,C];
  result:=string(v);
end;



var
  MainProcId: DWORD;
  ProcHandle: THandle;
  EscapeScan: Byte;
  NeedNext: Boolean;
  NeedBreak: Boolean;

function EnumWindowsProc(WHandle: HWND; lParam: Longint): BOOL; stdcall;
const
  StFlags = WS_POPUPWINDOW or WS_VISIBLE or WS_DLGFRAME;
var
  Style,ExStyle: LongWord;
  CurrProcId: DWORD;
begin
  Style := LongWord(GetWindowLong(WHandle,GWL_STYLE));
  ExStyle := LongWord(GetWindowLong(WHandle,GWL_EXSTYLE));
  Result := True;
  if (Style and StFlags=StFlags) and (Style and WS_DISABLED=0) and
      (ExStyle and WS_EX_DLGMODALFRAME<>0) then
    begin
      GetWindowThreadProcessId(WHandle, @CurrProcId);
      if CurrProcId = MainProcId then
      begin
        Result := False;
        if SetForegroundWindow(WHandle) then
        begin
          keybd_event(VK_ESCAPE, EscapeScan, 0, 0);
          keybd_event(VK_ESCAPE, EscapeScan, KEYEVENTF_KEYUP, 0);
          Sleep(1000);
          WaitForInputIdle(ProcHandle, INFINITE);
          NeedNext := True;
        end else
          NeedBreak := True;
      end;
    end;
end;

procedure SetRegularMode(WinHandle: HWND);
var
  I: Integer;
begin
  EscapeScan := Lo(MapVirtualKey(VK_ESCAPE, 0));
  GetWindowThreadProcessId(WinHandle, @MainProcId);
  ProcHandle := OpenProcess(PROCESS_QUERY_INFORMATION, False, MainProcId);
  if ProcHandle <> 0 then
  begin
    NeedBreak := False;
    for I := 1 to 10 do
    begin
      NeedNext := False;
      EnumWindows(@EnumWindowsProc,0);
      if not NeedNext then
        Break;
    end;
    if not NeedBreak and SetForegroundWindow(WinHandle) then
    begin
      keybd_event(VK_ESCAPE, EscapeScan, 0, 0);
      keybd_event(VK_ESCAPE, EscapeScan, KEYEVENTF_KEYUP, 0);
      Sleep(1000);
      WaitForInputIdle(ProcHandle, INFINITE);
    end;
    CloseHandle(ProcHandle);
  end;
end;

procedure TExcelReport.RestoreOldParams;
var
  W: Excel_TLB.Window;
  WinHandle: HWND;
begin
  if Length(FWNLong) > 0 then
  begin
    WinHandle := FindWindow('XLMAIN', PChar(FWNLong));
    if (WinHandle=0) and (Length(FWNShort)>0) then
      WinHandle := FindWindow('XLMAIN', PChar(FWNShort));
    if (WinHandle<>0) and
        (GetWindowLong(WinHandle,GWL_STYLE) and WS_VISIBLE<>0) then
      SetRegularMode(WinHandle);
  end;
  with FSPms^ do
  begin
    with FApp do
    begin
      Set_SheetsInNewWorkbook(0,App_SheetsInNewWorkbook);
      Set_DisplayFormulaBar(0, App_DisplayFormulaBar);
      Set_ReferenceStyle(0, Integer(App_ReferenceStyle));
      Set_DisplayStatusBar(0, App_DisplayStatusBar);
      Set_IgnoreRemoteRequests(0, App_IgnoreRemoteRequests);
      W := Get_ActiveWindow;
    end;
    if W <> nil then
      W.Close(False,'',False);
  end;
  W:=nil;
end;
procedure TExcelSheet.CopyCell(fromSheet:TExcelSheet;fromPoint:TPoint;ToPoint:TPoint);
begin
CopyCells(fromSheet,types.Rect(fromPoint.X,frompoint.Y,fromPoint.X,frompoint.Y),toPoint);
end;
procedure TExcelSheet.CopyCells(fromSheet:TExcelSheet;fromRect:TRect;toPoint:TPoint);
var rngFrom,rngTo:Range;
begin
logs.startproc('Excel','ExcelRpt','CopyCells','('+inttostr(fromrect.Left)+','
                                                 +inttostr(fromrect.Top)+','
                                                 +inttostr(fromrect.Right)+','
                                                 +inttostr(fromrect.Bottom)+')->'
                                              +'('+inttostr(topoint.x)+','
                                                 +inttostr(topoint.y)+')',20);
//UnMergeCells(toPoint.Y,toPoint.X,ToPoint.Y+fromrect.Bottom-fromRect.Top,ToPoint.x+fromrect.right-fromRect.left);
RngFrom := fromsheet.fsheet.Get_Cells;
RngTo := fSheet.Get_Cells;
if fromsheet<>self then
with RngFrom.Range_[RngFrom.Item[fromRect.top,fromRect.left],RngFrom.Item[fromRect.bottom,fromRect.right].mergearea] do
begin
copy(RngTo.Range_[RngTo.Item[toPoint.y,toPoint.x],RngTo.Item[toPoint.y,toPoint.x]]);
end
else
with RngFrom.Range_[RngFrom.Item[fromRect.top,fromRect.left],RngFrom.Item[fromRect.bottom,fromRect.right]] do
begin
copy(RngTo.Range_[RngTo.Item[toPoint.y,toPoint.x],RngTo.Item[toPoint.y,toPoint.x]]);
end;
Rngfrom:=nil;
RngTo:=nil;
end;
procedure TExcelSheet.CopyBorders(fromSheet:TExcelSheet;fromRect:TRect;ToPoint:TPoint);
procedure CopyBorder(bto,bfrom:Border;copycolor:boolean);
var weight,linestyle:integer;
begin
weight:=bfrom.Weight;
bto.Weight:=weight;
bto.Color:=bfrom.color;
bto.ColorIndex:=bfrom.ColorIndex;
linestyle:=bfrom.LineStyle;
bto.LineStyle:=linestyle;
end;
var rngFrom,rngTo:Range;
begin

RngFrom := fromsheet.fsheet.Get_Cells;
RngTo := fSheet.Get_Cells;
RngTo:=Rngto.Range_[Rngto.Item[toPoint.y,fromRect.left],Rngto.Item[toPoint.Y,fromRect.right].mergeArea];
RngFrom:=RngFrom.Range_[RngFrom.Item[fromRect.top,fromRect.left],RngFrom.Item[fromRect.bottom,fromRect.right].mergeArea];
begin
logs.startproc('Excel','ExcelRpt','CopyBorders','('+inttostr(fromrect.Left)+','
                                                 +inttostr(fromrect.Top)+','
                                                 +inttostr(fromrect.Right)+','
                                                 +inttostr(fromrect.Bottom)+')->'
                                              +'('+inttostr(topoint.x)+','
                                                 +inttostr(topoint.y)+')',20);
if fromRect.left<fromRect.Right then
CopyBorder(RngTo.Borders[xlInsideVertical],RngFrom.Borders[xlInsideVertical],true);
CopyBorder(RngTo.Borders[xlEdgeBottom],RngFrom.Borders[xlEdgeBottom],true);
CopyBorder(RngTo.Borders[xlEdgeLeft],RngFrom.Borders[xlEdgeLeft],true);
CopyBorder(RngTo.Borders[xlEdgeRight],RngFrom.Borders[xlEdgeRight],true);
CopyBorder(RngTo.Borders[xlEdgeTop],RngFrom.Borders[xlEdgeTop],true);
end;
RngFrom:=nil;
RngTo:=nil;
end;

procedure TExcelSheet.SetCells(R,C: Integer; AValue: string);
var
  Rng: Range;
begin
if copy(AValue,1,1)='=' then
 SetFormulas(R,C,AValue)
 else
 begin
  Rng := fSheet.Get_Cells;
  Rng.Item[R,C].Value := ClearSpaces(AValue)
 end;
 Rng:=nil;
end;
function GetColName(C: Integer): string;
var
  FL: Integer;
begin
  FL := 0;
  while C > 26 do
  begin
    Inc(FL);
    Dec(C,26);
  end;
  if FL = 0 then
    Result := Char(64+C)
  else
    Result := Char(64+FL)+Char(64+C);
end;

procedure TExcelSheet.SetColumnsPrnHeader(C1,C2: Integer);
var
  S: string;
begin
  if C1 <= C2 then
    S := '$'+GetColName(C1)+':$'+GetColName(C2)
  else
    S := '$'+GetColName(C2)+':$'+GetColName(C1);
  fsheet.Get_PageSetup.PrintTitleColumns := S;
end;

procedure TExcelSheet.SetRowsPrnHeader(R1,R2: Integer);
var
  S: string;
begin
  if R1 <= R2 then
    S := '$'+IntToStr(R1)+':$'+IntToStr(R2)
  else
    S := '$'+IntToStr(R2)+':$'+IntToStr(R1);
  fsheet.Get_PageSetup.PrintTitleRows := S;
end;

procedure TExcelReport.SetVisible(A: Boolean);
var
  Wn: Excel_TLB.Window;
  WinHandle: HWND;
  S: string;
begin
  if A then
  begin
    FApp.Set_ScreenUpdating(0,True);
    Wn := FApp.Get_ActiveWindow;
    if wn<>nil then
    Wn.WindowState := (xlMaximized);
    FWNLong := FApp.Get_Caption;
    S := Wn.Caption;
    FWNShort := Copy(FWNLong,1,Length(FWNLong)-Length(S)-3);
  end;
  FApp.Set_Visible(0,A);
  FVisible := A;
  if A then
  begin
    WinHandle := FindWindow('XLMAIN', PChar(FWNLong));
    if WinHandle <> 0 then
      SetForegroundWindow(WinHandle);
  end;
  Wn:=nil;
end;
function TExcelSheet.getMergeArea(R,C: Integer):String;
var
  Rng: Range;
  merged: Range;

begin
RNG:=fsheet.Get_Cells;
merged:=RNG.Range_[Rng.Item[R,C],Rng.Item[R,C]].MergeArea;
result:=merged.Address[true,
true,xlR1C1,
false,ua];
RNG:=nil;
merged:=nil;
end;
function TExcelSheet.MergeRectangle(R,C: Integer):TRect;
var s,s1,s2:string;
    p:integer;
    R1,R2,C1,C2:string;
begin
 s:=getMergeArea(R,C);
 p:=pos(':',s);
 if p=0 then
 result:=Rect(C,R,C,R)
 else
 begin
 s1:=copy(s,1,p-1);
 s2:=copy(s,p+1,length(s));
 p:=Pos('C',s1);
 if p>0 then
 begin
 R1:=copy(s1,2,p-2);
 C1:=copy(s1,p+1,length(s1));
 end
 else
 begin
 R1:=copy(s1,2,length(s1));
 C1:=R1;
 end;
  p:=Pos('C',s2);
 if p>0 then
 begin
 R2:=copy(s2,2,p-2);
 C2:=copy(s2,p+1,length(s2));
 end
 else
 begin
 R2:=copy(s2,2,length(s2));
 C2:=R2;
 end;
 result:=Rect(StrToIntDef(C1,C),StrToIntDef(R1,R),StrToIntDef(C2,C),StrToIntDef(R2,R));
 end;
end;

procedure TExcelSheet.MergeAllCells(R1, C1, R2, C2: Integer);
begin
if (R1=R2)and(c1=c2) then exit;
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
//setTextWrap(R1,C1,1,C2-C1+1,true);
logs.startproc('Excel','ExcelRpt','MergeAllCells',inttostr(R1)+','+inttostr(C1)+'-'+inttostr(R2)+','+inttostr(C2),12);
AddMergeArea(R1,C1,R2,C2);
end;

procedure TExcelSheet.MergeRowCells(R1, C1, R2, C2: Integer);
var
  Rng: Range;
begin
  if c1=c2 then exit;
logs.startproc('Excel','ExcelRpt','MergeRowCells',inttostr(R1)+','+inttostr(C1)+'-'+inttostr(R2)+','+inttostr(C2),12);
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].Merge(True);
  Rng:=nil;
end;

procedure TExcelSheet.UnMergeCells(R1, C1, R2, C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].UnMerge;
  Rng:=nil;
end;

procedure TExcelSheet.InsertColumns(C, Count: Integer);
var
  V: Variant;
  I: Integer;
begin
  V := fsheet.Get_Cells.Item[1,C].EntireColumn;
  for I := 1 to Count do
    V.Insert(Null);
end;

procedure TExcelSheet.InsertRows(R, Count: Integer);
var
  V: Variant;
  I: Integer;
begin
  V := fsheet.Get_Cells.Item[R,1].EntireRow;
  for I := 1 to Count do
    V.Insert(Null);
end;

procedure TExcelSheet.DeleteColumns(C, Count: Integer);
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[1,C],Rng.Item[1,C+Count-1]].EntireColumn.Delete(Integer(xlShiftToLeft));
  Rng:=nil;
end;

procedure TExcelSheet.DeleteRows(R, Count: Integer);
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[R,1],Rng.Item[R+Count-1,1]].EntireRow.Delete(Integer(xlShiftUp));
  Rng:=nil;
end;

procedure TExcelSheet.AutoFitColumns(C, Count: Integer);
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[1,C],Rng.Item[1,C+Count-1]].EntireColumn.AutoFit;
  Rng:=nil;
end;
procedure TExcelSheet.setTextWrap(R,C,H,W:integer;Value:Boolean);
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[R,C],Rng.Item[R+H-1,C+W-1]].WrapText:=Value;
  Rng:=nil;
end;

procedure TExcelSheet.AutoFitRows(R, Count: Integer);
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[R,1],Rng.Item[R+Count-1,1]].EntireRow.AutoFit;
  Rng:=nil;
end;
function TExcelSheet.getColumnWidth(C: Integer):integer;
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  result:=Rng.Item[1,C].ColumnWidth;
  Rng:=nil;
end;

procedure TExcelSheet.SetColumnWidth(C: Integer; W:Integer);
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Rng.Item[1,C].ColumnWidth := W;
  Rng:=nil;
end;
function TExcelSheet.getRowHeight(R: Integer):integer;
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Result:=Rng.Item[R,1].RowHeight;
  Rng:=nil;
end;

procedure TExcelSheet.SetRowHeight(R: Integer; H: integer);
var
  Rng: Range;
begin
if H>409 then H:=409;
  Rng := fsheet.Get_Cells;
  Rng.Item[R,1].RowHeight := H;
  Rng:=nil;
end;

function TExcelReport.GetScreenUpdating: Boolean;
begin
  Result := FApp.Get_ScreenUpdating(0);
end;

procedure TExcelReport.SetScreenUpdating(Value: Boolean);
begin
  FApp.Set_ScreenUpdating(0,Value);
end;

function TExcelSheet.GetFormulas(R, C: Integer): string;
var
  V: Variant;
begin
  V := fsheet.Get_Cells.Item[R,C].Formula;
  if not VarIsNull(V) then
    Result := V
  else
    Result := '';
end;

procedure TExcelSheet.SetFormulas(R, C: Integer; const Value: string);
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Rng := Range(TVarData(Rng.Item[R,C]).VDispatch);
  Rng.Formula := Value;
  Rng:=nil;
end;
function TExcelSheet.GetFormulasR1C1(R, C: Integer): string;
var
  V: Variant;
begin
  V := fsheet.Get_Cells.Item[R,C].FormulaR1C1;
  if not VarIsNull(V) then
    Result := V
  else
    Result := '';
end;

procedure TExcelSheet.SetFormulasR1C1(R, C: Integer; const Value: string);
var
  Rng: Range;
begin
  Rng := fsheet.Get_Cells;
  Rng := Range(TVarData(Rng.Item[R,C]).VDispatch);
  Rng.FormulaR1C1 := Value;
  Rng:=nil;
end;

procedure TExcelSheet.AlignHorizontal(R1,C1,R2,C2, HAlign, Indent: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
  begin
    HorizontalAlignment := HAlign;
    if HAlign = xlHAlignLeft then
      IndentLevel := Indent;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.AlignVertical(R1, C1, R2, C2, VAlign: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].VerticalAlignment := VAlign;
  Rng:=nil;
end;

procedure TExcelSheet.SetArrangement(R1,C1,R2,C2: Integer;
  AOrientation: Integer; IsWrapText, IsShrinkToFit: Boolean);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
  begin
    Orientation := AOrientation;
    WrapText := IsWrapText;
    ShrinkToFit := IsShrinkToFit;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.Justify(R1,C1,R2,C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].Justify;
  Rng:=nil;
end;

procedure TExcelSheet.SetInterior(R1, C1, R2, C2, AColorIndex, APattern,
  APatternColorIndex: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].Interior do
  begin
    ColorIndex := AColorIndex;
    Pattern := APattern;
    PatternColorIndex := APatternColorIndex;
  end;
  Rng:=nil;
end;

procedure TExcelSheet.ApplyNumberFormat(R1, C1, R2, C2: Integer;
  const Fmt: string);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].NumberFormat := Fmt;
  Rng:=nil;
end;
procedure TExcelSheet.ClearAll;
begin
fsheet.Cells.Clear;
end;
procedure TExcelSheet.Clear(R1, C1, R2, C2: Integer; OnlyContents,
  OnlyFormats, OnlyOutline: Boolean);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  with Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]] do
    if not(OnlyContents or OnlyFormats or OnlyOutline) then
      Clear
    else
    begin
      if OnlyContents then
        ClearContents
      else if OnlyFormats then
        ClearFormats
      else if OnlyOutline then
        ClearOutline;
    end;
    Rng:=nil;
end;

procedure TExcelSheet.FormatRange(R1, C1, R2, C2, Flags: Integer);
var
  Rng: Range;
  V1: Variant;
  test:variant;
begin
if (r1<=0)or(r2<=0)or(c1<=0)or(c2<=0) then exit;
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fsheet.Get_Cells;
  Rng:=Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]];
  with Rng do
  begin
    if Flags and frBorders <> 0 then
      with Rng.Borders do
      begin
        if Flags and frBordersColorIndex <> 0 then
          ColorIndex := FBordersColorIndex;
        if Flags and frBordersLineStyle <> 0 then
          LineStyle := FBordersLineStyle;
        if Flags and frBordersWeight <> 0 then
          Weight := FBordersWeight;
      end;
    if Flags and frFont <> 0 then
      with Rng.Font do
      begin
        if Flags and frFontBold <> 0 then
        begin
          V1 := Bold;
          if VarIsNull(V1) or (V1<>FFontBold) then
            Bold := FFontBold;
        end;
        if Flags and frFontColorIndex <> 0 then
        begin
          V1 := ColorIndex;
          if VarIsNull(V1) or (V1<>FFontColorIndex) then
            ColorIndex := FFontColorIndex;
        end;
        if Flags and frFontItalic <> 0 then
        begin
          V1 := Italic;
          if VarIsNull(V1) or (V1<>FFontItalic) then
            Italic := FFontItalic;
        end;
        if Flags and frFontName <> 0 then
        begin
          V1 := Name;
          if VarIsNull(V1) or (V1<>FFontName) then
            Name := FFontName;
        end;
        if Flags and frFontSize <> 0 then
        begin
          V1 := Size;
          if VarIsNull(V1) or (V1<>FFontSize) then
            Size := FFontSize;
        end;
        if Flags and frFontStrikethrough <> 0 then
        begin
          V1 := Strikethrough;
          if VarIsNull(V1) or (V1<>FFontStrikethrough) then
            Strikethrough := FFontStrikethrough;
        end;
        if Flags and frFontSubscript <> 0 then
        begin
          V1 := Subscript;
          if VarIsNull(V1) or (V1<>FFontSubscript) then
            Subscript := FFontSubscript;
        end;
        if Flags and Superscript <> 0 then
        begin
          V1 := Superscript;
          if VarIsNull(V1) or (V1<>FFontSuperscript) then
            Superscript := FFontSuperscript;
        end;
        if Flags and frFontUnderline <> 0 then
        begin
          V1 := Underline;
          if VarIsNull(V1) or (V1<>FFontUnderline) then
            Underline := FFontUnderline;
        end;
      end;
    if Flags and frAligns <> 0 then
    begin
    test:=Rng.HorizontalAlignment;
      if Flags and frHorizontalAlignment <> 0 then
        Rng.HorizontalAlignment := FHorizontalAlignment;
    test:=Rng.HorizontalAlignment;
      if Flags and frVerticalAlignment <> 0 then
        Rng.VerticalAlignment := FVerticalAlignment;
      if Flags and frOrientation <> 0 then
        Rng.Orientation := FOrientation;
      if Flags and frWrapText <> 0 then
        Rng.WrapText := FWrapText;
    end;
    if Flags and frShrinkToFit <> 0 then
      Rng.ShrinkToFit := FShrinkToFit;
    if Flags and frInterior <> 0 then
      with Rng.Interior do
      begin
        if Flags and frInteriorColorIndex <> 0 then
          ColorIndex := FInteriorColorIndex;
        if Flags and frInteriorPattern <> 0 then
          Pattern := FInteriorPattern;
        if Flags and frInteriorPCI <> 0 then
          PatternColorIndex := FInteriorPCI;
      end;
    if Flags and frNumberFormat <> 0 then
      NumberFormat := FNumberFormat;
  end;
  Rng:=nil;
end;



procedure TExcelSheet.UnProtectSheet(Password: string);
begin
  fsheet.Unprotect(Password,0);;
end;

procedure TExcelSheet.SetHPageBreaks(Rows: array of Integer);
var
  I: Integer;
  HPB: HPageBreaks;
  Rng: Range;
  WSH: _WorkSheet;
begin
  WSH := fsheet;
  HPB := WSH.Get_HPageBreaks;
  Rng := WSH.Get_Cells;
  for I := 0 to High(Rows) do
    HPB.Add(Rng.Item[Rows[I],1]);
  Rng:=nil;
  HPB:=nil;
  WSH:=nil;
end;

procedure TExcelSheet.SetVPageBreaks(Columns: array of Integer);
var
  I: Integer;
  VPB: VPageBreaks;
  Rng: Range;
  WSH: _WorkSheet;
begin
  WSH := fsheet;
  VPB := WSH.Get_VPageBreaks;
  Rng := WSH.Get_Cells;
  for I := 0 to High(Columns) do
    VPB.Add(Rng.Item[1,Columns[I]]);
  Rng:=nil;
  VPB:=nil;
  WSH:=nil;
end;
function TExcelSheet.getHPageBreakCount:integer;
var
  HPB: HPageBreaks;
  WSH: _WorkSheet;
begin
  WSH := fsheet;
  HPB := WSH.Get_HPageBreaks;
  result:=HPB.Count;
  HPB:=nil;
  WSH:=nil;
end;

function TExcelSheet.getHPageBreak(i:integer):integer;
var
  HPB: HPageBreaks;
  WSH: _WorkSheet;
  Rng: Range;
  HPBI:HPageBreak;
begin
  WSH := fsheet;
  HPB := WSH.Get_HPageBreaks;
  HPBI:=HPB.Item[i];
  if HPBI.Type_=xlPageBreakManual then
  begin
  Rng:=HPBI.Location;
  result:=Rng.Row;
  end
  else
  result:=0;
  Rng:=nil;
  HPB:=nil;
  WSH:=nil;
  HPBI:=nil;
end;

function TExcelSheet.getVPageBreakCount:integer;
var
  VPB: VPageBreaks;
  WSH: _WorkSheet;
begin
  WSH := fsheet;
  VPB := WSH.Get_VPageBreaks;
  result:=VPB.Count;
  VPB:=nil;
  WSH:=nil;
end;

function TExcelSheet.getVPageBreak(i:integer):integer;
var
  VPB: VPageBreaks;
  WSH: _WorkSheet;
begin
  WSH := fsheet;
  VPB := WSH.Get_VPageBreaks;
  result:=VPB.Item[i].Location.Column;
  VPB:=nil;
  WSH:=nil;
end;
procedure TExcelSheet.ResetAllPageBreaks;
begin
  fsheet.ResetAllPageBreaks;
end;



procedure TExcelReport.GetPageSetup(var PS: TPageSetup);
begin
  with (FApp.Get_ActiveSheet as _WorkSheet).Get_PageSetup do
  begin
    PS.BlackAndWhite := BlackAndWhite;
    PS.mm_BottomMargin := BottomMargin*PointsToMM;
    PS.CenterFooter := CenterFooter;
    PS.CenterHeader := CenterHeader;
    PS.CenterHorizontally := CenterHorizontally;
    PS.CenterVertically := CenterVertically;
    PS.Draft := Draft;
    PS.FirstPageNumber := FirstPageNumber;
    PS.FitToPagesTall := FitToPagesTall;
    PS.FitToPagesWide := FitToPagesWide;
    PS.mm_FooterMargin := FooterMargin*PointsToMM;
    PS.mm_HeaderMargin := HeaderMargin*PointsToMM;
    PS.LeftFooter := LeftFooter;
    PS.LeftHeader := LeftHeader;
    PS.mm_LeftMargin := LeftMargin*PointsToMM;
    PS.Order := Order;
    PS.Orientation := Orientation;
    PS.PaperSize := PaperSize;
    PS.PrintGridlines := PrintGridlines;
    PS.PrintHeadings := PrintHeadings;
    PS.RightFooter := RightFooter;
    PS.RightHeader := RightHeader;
    PS.mm_RightMargin := RightMargin*PointsToMM;
    PS.mm_TopMargin := TopMargin*PointsToMM;
    PS.Zoom := Zoom;
  end;
end;

procedure TExcelReport.SetPageSetup(var PS: TPageSetup);
begin
  with (FApp.Get_ActiveSheet as _WorkSheet).Get_PageSetup do
  begin
    BlackAndWhite := PS.BlackAndWhite;
    BottomMargin := PS.mm_BottomMargin*MMToPoints;
    CenterFooter := PS.CenterFooter;
    CenterHeader := PS.CenterHeader;
    CenterHorizontally := PS.CenterHorizontally;
    CenterVertically := PS.CenterVertically;
    Draft := PS.Draft;
    FirstPageNumber := PS.FirstPageNumber;
    FitToPagesTall := PS.FitToPagesTall;
    FitToPagesWide := PS.FitToPagesWide;
    FooterMargin := PS.mm_FooterMargin*MMToPoints;
    HeaderMargin := PS.mm_HeaderMargin*MMToPoints;
    LeftFooter := PS.LeftFooter;
    LeftHeader := PS.LeftHeader;
    LeftMargin := PS.mm_LeftMargin*MMToPoints;
    if PS.Order < 1 then
      Order := xlDownThenOver
    else
      Order := PS.Order;
    if PS.Orientation < 1 then
      Orientation := xlPortrait
    else
      Orientation := PS.Orientation;
    if PS.PaperSize < 1 then
      PaperSize := xlPaperA4
    else
      PaperSize := PS.PaperSize;
    PrintGridlines := PS.PrintGridlines;
    PrintHeadings := PS.PrintHeadings;
    RightFooter := PS.RightFooter;
    RightHeader := PS.RightHeader;
    RightMargin := PS.mm_RightMargin*MMToPoints;
    TopMargin := PS.mm_TopMargin*MMToPoints;
    Zoom := PS.Zoom;
  end;
end;

function TExcelReport.GetDisplayStatusBar: Boolean;
begin
  Result := FApp.Get_DisplayStatusBar(0);
end;

procedure TExcelReport.SetDisplayStatusBar(Value: Boolean);
begin
  FApp.Set_DisplayStatusBar(0,Value);
end;

procedure TExcelReport.SetDisplayFormulaBar(Value: Boolean);
begin
  FApp.Set_DisplayFormulaBar(0,Value);
end;

function TExcelSheet.GetDisplayPageBreaks: Boolean;
begin
  Result := fSheet.Get_DisplayPageBreaks;
end;

procedure TExcelSheet.SetDisplayPageBreaks(Value: Boolean);
begin
  fSheet.Set_DisplayPageBreaks(Value);
end;

function TExcelSheet.GetEnableSelection: Integer;
begin
  Result := fSheet.Get_EnableSelection;
end;

procedure TExcelSheet.SetEnableSelection(Value: Integer);
begin
  fSheet.Set_EnableSelection(Value);
end;

procedure TExcelSheet.Lock(R1, C1, R2, C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].Locked := True;
  Rng:=nil;
end;

procedure TExcelSheet.UnLock(R1, C1, R2, C2: Integer);
var
  Rng: Range;
begin
  if R1 > R2 then
    ExchgVals(R1,R2);
  if C1 > C2 then
    ExchgVals(C1,C2);
  Rng := fSheet.Get_Cells;
  Rng.Range_[Rng.Item[R1,C1],Rng.Item[R2,C2]].Locked := False;
  Rng:=nil;
end;




procedure TExcelSheet.InitVariables;
begin
  FBordersColorIndex := xlAutomatic;
  FBordersLineStyle := xlContinuous;
  FBordersWeight := xlThin;

  FFontBold := False;
  FFontColorIndex := xlAutomatic;
  FFontItalic := False;
  FFontName := 'Arial Cyr';
  FFontSize := 10;
  FFontStrikethrough := False;
  FFontSubscript := False;
  FFontSuperscript := False;
  FFontUnderline := Integer(xlUnderlineStyleNone);
  FFontApplied := false;

  FHorizontalAlignment := xlHAlignGeneral;
  FVerticalAlignment := Integer(xlVAlignBottom);
  FOrientation := Integer(xlHorizontal);
  FWrapText := False;
  FShrinkToFit := False;
  FInteriorColorIndex := Integer(xlColorIndexAutomatic);
  FInteriorPattern := Integer(xlPatternNone);
  FInteriorPCI := Integer(xlColorIndexAutomatic);

  FLeftWorkColumn := 1;
  FUpperWorkRow := 1;

  FNumberFormat := 'General';

end;
procedure TExcelReport.InitVariables;
begin
  FVisible := False;
end;
destructor TExcelSheet.Destroy;
begin
//fgrid.free;
ApplyMergeAreas;
fMergeAreas.Free;
fAutoFitRanges.free;
fSheet:=nil;
inherited destroy;
end;
constructor TExcelSheet.Create(owner:TExcelBook;ID:integer;Sheet:ExcelWorkSheet);
var i:integer;
begin
inherited Create;
fOwner:=owner;
fID:=ID;
InitVariables;
fSheet:=Sheet;
fMergeAreas:=TList.Create;
fAutoFitRanges:=TList.Create;
//fgrid:=TStringGrid.create(nil);
end;
function TExcelReport.getBook(index:integer):TExcelBook;
begin
result:=TExcelBook(fbooks[index-1]);
end;

function TExcelBook.getSheet(index:integer):TExcelSheet;
begin
result:=TExcelSheet(fsheets[index-1]);
end;
procedure TExcelBook.SaveAs(SavefileName:string);
begin
Savefilename:=utils.RemoveDuplicatedSlashes(savefilename);
logs.startproc('ExcelRPT','SaveAs','',savefilename,5);
FBook.SaveCopyAs(SaveFileName, EXLReportLCID);
 FBook.Close(true, SavefileName, Ua, EXLReportLCID);
end;
procedure TExcelBook.Close;
begin
 FBook.Close(false, Ua, Ua, EXLReportLCID);
end;
procedure TExcelReport.SetUserControl;
begin
        FApp.UserControl := True;
        visible:=true;
end;
function TExcelSheet.getName:string;
begin
result:=fsheet.Name;
end;
procedure TExcelSheet.SetName(s:string);
begin
fsheet.name:=s;
end;
function TExcelBook.getSheetCount:integer;
begin
 result:=fsheets.count;
end;
procedure TExcelBook.Activate;
begin
FWorkBook.Activate(EXLReportLCID);
end;
procedure TExcelSheet.MakeActive;
begin
fsheet.Activate(EXLReportLCID);
end;
function TExcelSheet.RightColumn:integer;
begin
 result:=fsheet.UsedRange[EXLReportLCID].Columns.Count;
end;
function TExcelSheet.BottomRow:integer;
begin
 result:=fsheet.UsedRange[EXLReportLCID].Rows.Count;
end;
function Col2Number(s:string):integer;
var i:integer;
begin
result:=strtointdef(s,-255);
if result=-255 then
begin
s:=UpperCase(s);
result:=0;
for i:=1 to length(s) do
begin
 if s[i] in ['A'..'Z'] then result:=result*26+ord(s[i])-ord('A')+1
 else begin result:=1; exit; end;
end;

end;
if result>256 then result:=256;
end;

procedure TExcelSheet.ClearAutoFitRanges;
var i:integer;
begin
for i:=0 to fAutoFitRanges.Count-1 do
 dispose(PRect(fAutoFitRanges[i]));
fAutoFitRanges.Clear;
end;
procedure TExcelSheet.ClearMergeAreas;
var i:integer;
begin
 for i:=0 to fMergeAreas.count-1 do
  Dispose(PRect(fMergeAreas[i]));
  fMergeAreas.Clear;
end;
procedure TExcelSheet.AddAutoFitArea(R1,C1,R2,C2:integer);
var R:PRect;
begin
new(R);
R^.Top:=R1;
R^.Left:=C1;
R^.Bottom:=R2;
R^.Right:=C2;
fAutoFitRanges.Add(R);
if fOwner.fowner.Progress<>nil then
  fOwner.fowner.Progress.MaxValue:=fOwner.fowner.Progress.MaxValue+1;

end;
procedure TExcelSheet.AddMergeArea(R1,C1,R2,C2:integer);
var i:integer;
    found:boolean;
    R:PRect;
begin
found:=false;
 for i:=0 to fMergeAreas.Count-1 do
  if (PRect(fMergeAreas[i])^.Left=C1)and(PRect(fMergeAreas[i])^.Top=R1) then
  begin
  PRect(fMergeAreas[i])^.Right:=C2;
  PRect(fMergeAreas[i])^.Bottom:=R2;
  exit;
  end;
  if fOwner.fowner.Progress<>nil then
  fOwner.fowner.Progress.MaxValue:=fOwner.fowner.Progress.MaxValue+2;
  New(R);
  R^.Left:=C1;
  R^.Top:=R1;
  R^.Right:=C2;
  R^.Bottom:=R2;
  fMergeAreas.add(R);
end;
function TExcelSheet.MergeCount:integer;
begin
result:=fMergeAreas.Count;
end;
function RectSort(p1,p2:pointer):integer;far;
begin
 if PRect(p1)^.Top<PRect(p2)^.Top then result:=-1
 else
 if PRect(p1)^.Top>PRect(p2)^.Top then result:=+1
 else
 if PRect(p1)^.Bottom<PRect(p2)^.Bottom then result:=-1
 else
 if PRect(p1)^.Bottom<PRect(p2)^.Bottom then result:=+1
 else
 result:=0;
end;
procedure TExcelSheet.ApplyMergeAreas;
var
  Rng: Range;
  i,j:integer;
  r,r2:PRect;
  outR:TRect;
  RowHeights,canautosize:TIntList;
  StartRow,endrow:integer;
  curHeight,ExtraHeight:integer;
  found:boolean;
begin
if fAutoFitRanges.Count>0 then
begin
Rng := fsheet.Get_Cells;
for i:=0 to fAutoFitRanges.Count-1 do
begin
r:=PRect(fAutoFitRanges[i]);
Rng.Range_[Rng.Item[R^.Top,r^.Left],Rng.Item[R^.Bottom,R^.Right]].WrapText:=true;
Rng.Range_[Rng.Item[R^.Top,1],Rng.Item[R^.Bottom,1]].EntireRow.AutoFit;
if fOwner.fowner.Progress<>nil then
  fOwner.fowner.Progress.AddProgress(1);
end;
ClearAutoFitRanges;
Rng:=nil;
end;
if  fMergeAreas.Count>0 then
begin
fMergeAreas.Sort(RectSort);
for i:=fMergeAreas.Count-1 downto 1 do
begin
r:=PRect(fMergeAreas[i]);
found:=false;
for j:=i-1 downto 0 do
 begin
 r2:=PRect(fMergeAreas[j]);
 if intersectRect(outR,r^,R2^) then
 begin
 found:=true;
 UnionRect(outR,r^,r2^);
 R2^:=OutR;
 end;
 end;
 if found then
 begin
 dispose(r);
 fMergeAreas.delete(i);
 end;
end;
RowHeights:=TIntList.Create;
canautosize:=TintList.Create;
try
StartRow:=PRect(fMergeAreas[0])^.Top;
EndRow:=StartRow;
  for i:=0 to fMergeAreas.Count-1 do
  begin
  r:=PRect(fMergeAreas[i]);
  if  r^.Bottom>endrow then endrow:=r^.bottom;
  end;
  Rng := fsheet.Get_Cells;
  for i:=StartRow to EndRow do
  begin
  RowHeights.add(Rng.Item[i,1].RowHeight);
  canautosize.add(1);
  end;
  for i:=fMergeAreas.Count-1 downto 0 do
  begin
  r:=PRect(fMergeAreas[i]);
  curHeight:=RowHeights[r^.Top-StartRow];
  extraheight:=0;
  for j:=r^.Top+1 to r^.Bottom do
   inc(extraheight,RowHeights[j-StartRow]);
  if curheight>extraheight then
  canAutoSize[r^.Top-StartRow]:=0;
  try
  Rng.Range_[Rng.Item[R^.Top,R^.Left],Rng.Item[R^.Bottom,R^.Right]].Merge(False);
  except
  end;
   if fOwner.fowner.Progress<>nil then
  fOwner.fowner.Progress.AddProgress(1);

  end;
for i:=fMergeAreas.Count-1 downto 0 do
  begin
  r:=PRect(fMergeAreas[i]);
   if fOwner.fowner.Progress<>nil then
  fOwner.fowner.Progress.AddProgress(1);
  if canAutoSize[r^.Top-StartRow]=1 then
  begin
  Rng.Item[R^.Top,1].EntireRow.AutoFit;
  canAutoSize[r^.Top-StartRow]:=0;
  end;
  end;
finally
canautosize.free;
RowHeights.free;
end;
  ClearMergeAreas;
  Rng:=nil;
end;
end;
end.

