unit ImageComboBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
 TItemCompare   = procedure(item1,item2:integer;var result:shortint)of Object;
  TImageComboBox = class(TComboBox)

  private
    { Private declarations }
    FImageList:TImageList;
    fItemCompare:TItemCompare;
  protected
    { Protected declarations }
  function getpictindex(index:integer):integer;
  procedure setpictindex(index,pn:integer);
  procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
  public
    { Public declarations }
  function foundpics(pi:integer):integer;
  constructor Create(AOwner:TComponent);override;
  destructor destroy;override;
  procedure Sort(asc:boolean);
  property pictindexes[index:integer]:integer read getpictindex write setpictindex;
  published
    { Published declarations }
    property ImageList:TImageList read FImageList write FImageList;
    property OnItemCompare:TItemCompare read FItemCompare write FItemCompare;
 end;
procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Additional', [TImageComboBox]);
end;
procedure TImageCombobox.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var textmargin,intindex:integer;
begin
//inherited DrawItem(index,rect,state);
Canvas.FillRect(Rect);
textmargin:=2;
intindex:=integer(items.Objects[index]);
if intindex=-1 then intindex:=index;
//BMP:=TBitMap.create;
 try
if assigned(FImagelist) then
begin
 textmargin:=FImagelist.width+2;
 if fimagelist.count>intindex then
 FImageList.Draw(canvas,rect.left,rect.top,intindex);
end;
 canvas.TextOut(rect.left+textmargin,rect.top,items[index]);
finally
 //BMP.free;
end;
end;
function TImageComboBox.getpictindex(index:integer):integer;
begin
 if index<items.count then
  result:=integer(items.objects[index])
 else
  result:=-1;
end;
procedure TImageComboBox.setpictindex(index,pn:integer);
begin
items.objects[index]:=pointer(pn);
end;
constructor TImageComboBox.Create(AOwner:TComponent);
begin
 inherited create(aowner);
end;
destructor TImageComboBox.destroy;
begin
 inherited destroy;
end;
function TImageComboBox.foundpics(pi:integer):integer;
var i:integer;
begin
 result:=0;
 for i:=0 to items.count-1 do
  if integer(items.objects[i])=pi then
   begin
    result:=i;
    exit;
   end;
end;
procedure TImageComboBox.Sort(asc:boolean);
var i,j:integer;
    r:shortint;
function findrange(rs,rf,it:integer):integer;
var res:shortint;
begin
if rs<rf then
begin
fitemcompare(it,integer(items.objects[(rs+rf)div 2]),res);
//showmessage(inttostr(it)+':'+inttostr(rs)+'-'+inttostr(rf));
if not asc then res:=-res;
if res<0 then
   result:=findrange(rs,(rs+rf) div 2,it)
else if res>0 then
   result:=findrange((rs+rf) div 2+1,rf,it)
else result:=(rs+rf) div 2+1
end
else result:=rf;
end;

begin
if not assigned(fItemcompare) then exit;
i:=2;
while i<=items.count-1 do
 begin
 fitemcompare(integer(items.objects[i]),integer(items.objects[i-1]),r);
 if not asc then r:=-r;
 if r<0 then
 begin
 j:=findrange(1,i-1,integer(items.objects[i]));
 items.Move(i,j);
// inc(i);
 end;
 inc(i);
 end;
end;
end.
