unit NC;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Mask, ToolEdit,Main,FileUtil,Dialogs,Menus,comctrls;

type
  TNewComps = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    DE: TDirectoryEdit;
    CheckBox1: TCheckBox;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Dates: TDateEdit;
    Prim: TMemo;
    procedure OKBtnClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NewComps: TNewComps;

implementation

uses utils, dcommon, compops, appConst, Umessages;

{$R *.DFM}

procedure TNewComps.OKBtnClick(Sender: TObject);
VAr 
    NewComps:TTreeNode;
    dirname:string;
    i:integer;
    samefolder:TTreeNode;
    isfound:boolean;
begin
if DE.Text='' then
begin
MessageDlg(umessages.enterthename,mtError,[mbOk],0);
exit;
end;
with OrgMasterMain do
begin
 dirname:=NormalDir(ClearSpaces(DE.Text));
dirname:=expandfilename(dirname);
isfound:=false;
samefolder:=nil;
 for i:=0 to compview.Items.Count-1 do
  if ANSIuppercase(expandfilename(TPComp(compview.items[i].data)^.filename))=ANSIuppercase(dirname) then
  begin
   isfound:=true;
   samefolder:=compview.items[i];
   break;
  end;
if isfound then
 begin
 compview.selected:=samefolder;
 samefolder.expanded:=true;
 exit;
 end;
if  not DirExists(dirname)and(dirname<>'') then
MkDir(DE.Text);
comp.Append;
Comp.FieldByName('Group').AsString:=ClearSpaces(Edit1.Text);
Comp.FieldByName('FileName').AsString:=dirname;
Comp.FieldByName('IsGroup').AsBoolean:=true;
Comp.FieldByName('Comment').AsString:=Prim.Text ;
Comp.FieldByName('MdfDate').AsDatetime:=Dates.Date;

Comp.Post;

Comp.Edit;
Comp.FieldByName('Tag').AsInteger:=Comp.FieldByName('N').AsInteger;
Comp.Post;

NewComps:=CompView.Items.AddChild(nil,Edit1.Text);
New(PComp);
PComp.Tag:=Comp.FieldByName('N').AsInteger;
PComp.N:=Comp.FieldByName('N').AsInteger;
PComp.FileName:=Comp.FieldByName('FileName').AsString;
PComp.IsGroup:=true;
PComp^.Comment:=Prim.Text;
//PComp.ParentGroup:=0;
NewComps.Data:=PComp;

CurrCompany:=Comp.FieldByName('Tag').AsInteger;

end;
 modalresult:=mrOk;
end;


procedure TNewComps.CheckBox1Click(Sender: TObject);
begin
DE.Enabled:= not Checkbox1.Checked;
DE.Text:=appconst.sysinfo.LocalDataDir + Edit1.Text;
end;

procedure TNewComps.Edit1Change(Sender: TObject);
begin
if CheckBox1.Checked then
DE.Text:=appconst.sysinfo.LocalDataDir + normalfilename(Edit1.Text);
end;



procedure TNewComps.FormActivate(Sender: TObject);
begin
Dates.date:=now;
end;

end.
