unit PProp;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Mask, DBCtrls, ToolEdit, checklst, ComCtrls,
  Grids, Menus, Dialogs, dcommon;

type
  TProProp = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    PageControl1: TPageControl;
    MainProp: TTabSheet;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    ClearLinks: TSpeedButton;
    Label3: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    LinksCombo: TComboBox;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Comm: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Dates: TDateEdit;
    Prim: TMemo;
    ProName: TEdit;
    Onum: TEdit;
    ABCPage: TTabSheet;
    Panel2: TPanel;
    Spr1: TComboBox;
    Spr2: TComboBox;
    Panel3: TPanel;
    IOName: TEdit;
    Label9: TLabel;
    Label8: TLabel;
    outName: TEdit;
    inName: TEdit;
    Label7: TLabel;
    Downgrade: TCheckBox;
    Protype: TComboBox;
    DoDowngrade: TSpeedButton;
    ABCList: TComboBox;
    Label11: TLabel;
    Label12: TLabel;
    DoEnableMirror: TCheckBox;
    Avtor: TComboEdit;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ClearLinksClick(Sender: TObject);
    procedure OnumKeyPress(Sender: TObject; var Key: Char);
    procedure ProtypeChange(Sender: TObject);
    procedure DowngradeClick(Sender: TObject);
    procedure DoDowngradeClick(Sender: TObject);
    procedure AvtorButtonClick(Sender: TObject);
    procedure ProtypeClick(Sender: TObject);
  private
    { Private declarations }
    proid:integer;
  public
    { Public declarations }
  end;

var
  ProProp: TProProp;

implementation

uses Main,  StrTab, DBTables,dbconsts,db, utils, appConst, prnprv,items,
  Umessages;

{$R *.DFM}

procedure TProProp.OKBtnClick(Sender: TObject);
var i:integer;
    l:TLiteLinks;
    newPrType:TPrjType;
    mo:PModelObject;
    idxcls:TOMItems;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if (spr1.itemindex<0) or (spr2.itemindex<0) then exit;
with STRTables do
begin
mo:=OrgMasterMain.modelcontense.getModelObjectByID(ModelTN.asInteger);
if abclist.ItemIndex>0 then
mo^.ABCCls:=PModelObject(ABCList.Items.Objects[abclist.ItemIndex])^.N
else
mo^.ABCCls:=0;
ModelT.Edit;
ModelT.FieldByName('Name').AsString:=ClearSpaces(Onum.text+' '+ProName.text);
ModelT.FieldByName('Comm').AsString:=Prim.Text;
ModelT.FieldByName('Avtor').AsString:=Avtor.Text;
ModelT.FieldByName('MDate').AsDateTime:=Dates.Date;
ModelTSp1.asInteger:=TModelObject(pointer(spr1.Items.Objects[spr1.itemindex])^).n;
ModelTSp2.asInteger:=TModelObject(pointer(spr2.Items.Objects[spr2.itemindex])^).n;
ModelTIdxN.AsInteger:=mo^.ABCCls;
//
 i:=linkscombo.ItemIndex;
if (i<>0) then
begin
 ModelT.FieldByName('SprType').asInteger:=TModelObject(pointer(linkscombo.Items.Objects[i])^).n
end
else
ModelT.FieldByName('SprType').asInteger:=0;
ModelT.Post;
//
begin
l:=TLiteLinks.create(nil);
idxcls:=TOMItems.create;
l.clear;
try
l.loadfromBLOB(ModelTMBData);

if mo^.abccls>0 then
begin
OrgMasterMain.FillSprData(mo^.ABCCls,idxcls);
l.ConnectABC(idxcls);
end
else
l.ConnectABC(nil);
Locate_MdlObj(mo^.n);
case  protype.ItemIndex of
0: newPrType:=ptLRN;
1: newPrType:=ptIOC;
2: newPrType:=ptIOM;
3: newPrType:=ptM;
4: newPrType:=ptC;
end;
if newPrType<>l.prjType then
begin
 if (l.prjType in [ptC,ptM])and(newprType in [ptLRN]) then
  for i:=1 to l.size do l[i].flags:=l[i].flags or 3;
l.prjType:=newprtype;
end;
l.doDetail:=downgrade.Checked;
l.MirrorEnabled:=DoEnableMirror.Checked;
l.DirMap[1]:=InName.text;
l.DirMap[2]:=OutName.text;
l.dirMap[3]:=IOName.text;
l.dirMap[4]:=IOName.text;
ModelT.Edit;
l.savetoBLOB(ModelTMBData);
ModelT.Post;
finally
l.free;
end;
end;
STRTables.updateHistory(ProID,' ');
ModelT.Refresh;
OrgMasterMain.ismodelmodify:=true;
end;
{$ENDIF}
{$ENDIF}
end;


procedure TProProp.FormActivate(Sender: TObject);
var i,j:longword;
    mo:PModelObject;
    l:TLiteLinks;
begin
{$IFDEF VIEW}
  OkBtn.Visible:=false;
{$ENDIF}
with STRTables do
 begin
 sprCache.doClear;
mo:=OrgMasterMain.curmo;
Locate_MDlobj(mo^.n);
OrgMasterMain.modelcontense.fillType(appconst.SPRID,ABCList.Items);
i:=ABCList.Items.IndexOfObject(TObject(OrgMasterMain.modelcontense.getModelObjectByID(mo^.ABCCls)));
ABCList.ItemIndex:=i;
ProName.text:=cutnumbers(ModelT.FieldByName('Name').AsString);
ONum.text:=getnumbers(ModelT.FieldByName('Name').AsString);
Prim.Text:=ModelT.FieldByName('Comm').AsString;
Avtor.Text:=ModelT.FieldByName('Avtor').AsString;
Dates.Date:=ModelT.FieldByName('MDate').AsDateTime;
proid:=ModelTN.asInteger;
for i:=0 to spr1.Items.count-1 do
if PModelObject(spr1.Items.objects[i])^.n=ModelTsp1.asInteger then
spr1.itemindex:=i;
for i:=0 to spr2.Items.count-1 do
if PModelObject(spr2.Items.objects[i])^.n=ModelTsp2.asInteger then
spr2.itemindex:=i;
linksCombo.enabled:=true;
clearlinks.enabled:=false;
linksCombo.ItemIndex:=0;
if ModelTsprType.asInteger<>0 then
if OrgMasterMain.ModelContense.GetModelObjectById(ModelTsprType.asInteger)<>nil then
begin
j:=0;
  for i:=1 to linkscombo.Items.Count-1 do
   if TModelObject(pointer(linkscombo.Items.Objects[i])^).n=ModelTsprType.asInteger then j:=i;
  linksCombo.ItemIndex:=j;
  linksCombo.enabled:=false;
  clearlinks.enabled:=true;
end
 else
  LinksCombo.Text:='<    >'
else
  LinksCombo.Text:='<    >';
 end;
PageControl1.activePage:=MainProp;
begin
ABCPage.visible:=true;
ABCPage.tabvisible:=true;
l:=TLiteLinks.create(nil);
l.clear;
try
l.loadfromBLOB(STRTables.ModelTMBData);
case l.prjType of
ptLRN:protype.ItemIndex:=0;
ptIOC:protype.ItemIndex:=1;
ptIOM:protype.ItemIndex:=2;
ptM:protype.ItemIndex:=3;
ptC:protype.ItemIndex:=4;
end;
protype.OnClick(protype);
downgrade.Checked:=l.dodetail;
DoEnableMirror.Checked:=l.MirrorEnabled;
DownGradeClick(Downgrade);
inName.font.charset:=204;
OutName.font.charset:=204;
IOName.font.charset:=204;
ABCList.font.charset:=204;

InName.text:=l.DirMap[1];
OutName.text:=l.DirMap[2];
IOName.text:=l.dirMap[3];
finally
l.free;
end;
end;
PageControl1.activePage:=MainProp;
end;

procedure TProProp.ClearLinksClick(Sender: TObject);
begin
LinksCombo.itemindex:=0;
end;

procedure TProProp.OnumKeyPress(Sender: TObject; var Key: Char);
begin
if not(key in[#8,'0'..'9','.']) then key:=#0;
end;


procedure TProProp.ProtypeChange(Sender: TObject);
begin
//Panel3.Visible:=proType.ItemIndex=0;
end;


procedure TProProp.DowngradeClick(Sender: TObject);
begin
dodowngrade.Visible:=downgrade.checked;
end;

procedure TProProp.DoDowngradeClick(Sender: TObject);
var l,ltemp:TLiteLinks;
    i:integer;
    left,right,middle,Prc:TOMItems;
    mo:PModelObject;
    isnew:boolean;
begin
{$IFNDEF VIEW}
mo:=OrgMasterMain.modelcontense.getModelObjectByID(proid);
if mo=nil then exit;
Prc:=TOMItems.create;
Left:=TOMItems.create;
Right:=TOMItems.create;
Middle:=TOMItems.create;
l:=TLiteLinks.Create(PRC);
ltemp:=TLiteLinks.Create(nil);
try
OrgMasterMain.FillSprData(mo^.sp1,Left);
OrgMasterMain.FillSprData(mo^.sp2,Right);
OrgMasterMain.FillSprData(mo^.sprt,Middle);
OrgMasterMain.FillSprData(mo^.prs,Prc);
STRTables.Locate_MdlObj(proid);
l.loadFromBLOB(STRTables.MODELTMbData);
l.connect(left,right,nil);
if mo^.sprt>0 then
l.ConnectToStreams(1,middle);
l.DeleteDublicates;
for i:=1 to l.size do ltemp.AddLinkObject(l[i]);
l.Clear;
l.doDetail:=true;
for i:=1 to ltemp.size do
l.intaddlink(ltemp[i],isnew);
STRTables.MODELT.Edit;
l.saveToBLOB(STRTables.MODELTMbData);
STRTables.MODELT.Post;
finally
l.free;
ltemp.Free;
left.free;
right.free;
middle.Free;
prc.free;
end;

{$ENDIF}
end;

procedure TProProp.AvtorButtonClick(Sender: TObject);
var Hist:TStringList;
    i:integer;
begin
Hist:=TStringList.Create;
try
STRTables.LoadHistory(proID,Hist);
PrintPreview.slines.clear;
PrintPreview.slines.add('');
for i:=Hist.Count-1 downto 0 do
PrintPreview.slines.add(' '+Hist[i]);
finally
Hist.Free;
end;
PrintPreview.Showmodal('  '+ProName.Text);
end;
procedure TProProp.ProtypeClick(Sender: TObject);
begin
inName.Enabled:=ProType.ItemIndex=0;
outName.Enabled:=ProType.ItemIndex=0;
IOName.Enabled:=ProType.ItemIndex=0;
case ProType.ItemIndex of
0:;
1:begin
      inName.Text:='';
      outName.Text:='';
      IOName.Text:='';
      end;
2:begin
      inName.Text:='';
      outName.Text:='';
      IOName.Text:='';
      end;
3:begin
      inName.Text:='';
      outName.Text:='';
      IOName.Text:='';
      end;
4:begin
      inName.Text:='';
      OutName.Text:='';
      IOName.Text:='';
      end;
end;

end;

end.
