unit SprP;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, checklst, ExtCtrls, ComCtrls, Mask, ToolEdit, CurrEdit,
  RXSpin, ImgList,otherlists;

type
  TsprProp = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    OKBtn: TButton;
    Button2: TButton;
    SprComment: TMemo;
    Label5: TLabel;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    SprMD: TEdit;
    Label3: TLabel;
    Label2: TLabel;
    SprName: TEdit;
    ONum: TEdit;
    Label7: TLabel;
    SprAvt: TComboEdit;
    Label6: TLabel;
    CommentHeader: TEdit;
    procedure ONumKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure SprAvtButtonClick(Sender: TObject);
  private
    { Private declarations }
    ndeleted:integer;
    ID:integer;
  public
    { Public declarations }
  function showmodal:integer;
  end;

var
  sprProp: TsprProp;

implementation

uses StrTab, MAIN, F25, utils,db, dcommon, Logs, appConst, items,Variants,
  prnprv, myLists, CombSelector;

{$R *.DFM}
function TsprProp.showmodal:integer;
var mask,i:longint;
   comlist:TStringList;
   curspr:TOMItems;
   s:string;
begin
curspr:=TOMItems.create;
try
 with STRTables,OrgMasterMain do
 begin
 STRTables.sprCache.doClear;
 FillSprData(ModelTN.asInteger,curspr);
 ID:=ModelTN.asInteger;
  self.sprName.text:=cutNumbers(ModelTName.asString);
  self.ONum.text:=getnumbers(ModelTName.asString);
  sprAvt.text:=modelTAvtor.asstring;
  sprMD.text:=DateToStr(modelTMDate.asDatetime);
  comlist:=TStringList.create;
  comlist.text:=(modelTComm.asstring);
  s:='';
  sprComment.lines.text:=(modelTComm.asstring);
  if (comlist.count>0)and(length(SprComment.Lines[comlist.count-1])>0)and(comlist[comlist.count-1][1]='@') then
  begin
  s:=copy(comlist[comlist.count-1],2,length(comlist[comlist.count-1]));
  ComList.Delete(comlist.count-1);
  if s='' then
  s:=curspr.comTitle;
  if s='' then
  s:='';
 end;
commentHeader.text:=s;
  SprComment.lines.clear;
  SprComment.Lines.addStrings(comlist);
  comlist.free;
logs.startProc('sprP','activate',sprComment.lines.text,'',8);
   pagecontrol1.activepage:=Tabsheet1;
   ndeleted:=0;
   result:=inherited showmodal;
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
   if result=mrOk then
   begin
   OrgMasterMain.ismodelmodify:=true;


  Locate_MdlObj(curspr.dirid);

  Modelt.edit;
   modelTName.asString:=ClearSpaces(onum.text+' '+self.sprName.text);
   modelTAvtor.asstring:=sprAvt.text;
   ModelTType.asInteger:=SPRID;
   //sprComment.lines.add('@'+CommentHeaders.Items[0]);
   modelTComm.asstring:=sprComment.text+'@'+CommentHeader.Text;
  ModelT.post;
curspr.caption:=modelTName.asString;
curspr.ComTitle:=CommentHeader.Text;
Save_spr(curspr.dirid,curspr,PB);
i:=ModelTN.asInteger;
   end;
STRTables.updateHistory(ID,' ');
{$ENDIF}
{$ENDIF}
 end;
finally
 curspr.free;
end;
end;
procedure TsprProp.ONumKeyPress(Sender: TObject; var Key: Char);
begin
if not(key in [#8,'0'..'9','.']) then key:=#0;
end;

procedure TsprProp.FormActivate(Sender: TObject);

begin
STRTables.locate_MdlObj(OrgMasterMain.curmo^.n);
{$IFDEF VIEW}
OkBtn.Visible:=false;
{$ENDIF}
pagecontrol1.ActivePage:=TabSheet1;
end;

procedure TsprProp.SprAvtButtonClick(Sender: TObject);
var Hist:TStringList;
    i:integer;
begin
Hist:=TStringList.Create;
try
STRTables.LoadHistory(ID,Hist);
PrintPreview.slines.clear;
PrintPreview.slines.add('');
for i:=Hist.Count-1 downto 0 do
PrintPreview.slines.add(' '+Hist[i]);
finally
Hist.Free;
end;
PrintPreview.Showmodal('  '+sprName.Text);
end;

end.
