unit FindUnit2;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ComCtrls;

type
  TReplace = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel1: TPanel;
    FindText: TComboBox;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    RadioGroup1: TRadioGroup;
    IsCase: TCheckBox;
    IsWord: TCheckBox;
    GoFwd: TRadioButton;
    GoBack: TRadioButton;
    GroupBox2: TGroupBox;
    FromCurr: TRadioButton;
    FromTop: TRadioButton;
    ReplaceText: TComboBox;
    Label2: TLabel;
    Button1: TButton;
    IsPromt: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Replace: TReplace;

implementation

uses Main,Finds{, FindUnit},dialogs,edtops,utils, Umessages, appConst ;

{$R *.DFM}



procedure TReplace.OKBtnClick(Sender: TObject);
var pos:integer;
    news,olds:string;
    findStr:TStringList;
begin
findtext.Items.Add(findtext.text);
replacetext.Items.Add(replacetext.text);
findStr:=TStringList.Create;
try
if isCase.Checked then
findStr.add(ClearSpaces(findtext.text))
else
findStr.add(ClearSpaces(ANSIUPPERCASE(findtext.text)));
if fromtop.checked then
begin
if utils.isfind(findStr,scAND,OrgMasterMain.sourcelist.insource[OrgMasterMain.sourcelist.insource.root].s,isword.checked,iscase.checked)and
  (OrgMasterMain.sourcelist.insource[OrgMasterMain.sourcelist.insource.root].deleted=0)   then
 pos:=OrgMasterMain.sourcelist.insource.root
else
 pos:= OrgMasterMain.sourcelist.insource.findbyname(OrgMasterMain.sourcelist.insource.root,findstr,scAND,true,iscase.checked,isword.checked)
end
else
pos:= OrgMasterMain.sourcelist.insource.findbyname(OrgMasterMain.sourcelist.selectedindex,findStr,scAND,gofwd.checked,iscase.checked,isword.checked);

if pos<>0 then
begin
OrgMasterMain.sourcelist.insource.makevisible(pos);
olds:=OrgMasterMain.sourcelist.insource[pos].s;
if iscase.checked then
news:=system.copy(olds,1,system.pos(findtext.text,olds)-1)+replacetext.text+system.copy(olds,system.pos(findtext.text,olds)+length(findtext.text),length(olds))
else
news:=system.copy(olds,1,system.pos(ansiuppercase(findtext.text),ansiuppercase(olds))-1)+
 replacetext.text+
 system.copy(olds,system.pos(ansiuppercase(findtext.text),ansiuppercase(olds))+length(findtext.text),length(olds));
if not ispromt.checked or
 (messagedlg(format(umessages.overwriteString,[olds,news]),mtConfirmation,[mbYes,mbNo],0)=mrYes) then
begin
 edtops.SetItem(pos,OrgMasterMain.sourcelist.insource[pos]);
 OrgMasterMain.sourcelist.insource[pos].s:=news;
 OrgMasterMain.sourcelist.insource[pos].samenode.text:=news;

 ismodify:=true;
end;
OrgMasterMain.sourcelist.rebuild(false,true);
OrgMasterMain.sourcelist.row:=OrgMasterMain.sourcelist.disprow[pos];
end
else
showmessage(' '+findtext.text+'  .');
finally
findStr.Free;
end;
end;
procedure TReplace.FormActivate(Sender: TObject);
begin
FindText.font.charset:=204;
ReplaceText.font.charset:=204;
FindText.SetFocus;
end;



procedure TReplace.Button1Click(Sender: TObject);
var pos,lp:integer;
    news,olds:string;
    findStr:TStringList;
begin
lp:=0;
findtext.Items.Add(findtext.text);
replacetext.Items.Add(replacetext.text);
findStr:=TStringList.Create;
try
if iscase.checked then
 findStr.add(ClearSpaces(findText.Text))
 else
 findStr.add(ANSIUPPERCASE(ClearSpaces(findText.Text)));
if fromtop.checked then
begin
if utils.isfind(findstr,scAND,OrgMasterMain.sourcelist.insource[OrgMasterMain.sourcelist.insource.root].s,isword.checked,iscase.checked)and
(OrgMasterMain.sourcelist.insource[OrgMasterMain.sourcelist.insource.root].deleted=0)   then
 pos:=OrgMasterMain.sourcelist.insource.root
else
 pos:= OrgMasterMain.sourcelist.insource.findbyname(OrgMasterMain.sourcelist.insource.root,findStr,scAND,true,iscase.checked,isword.checked)
end
else
pos:= OrgMasterMain.sourcelist.insource.findbyname(OrgMasterMain.sourcelist.selectedindex,findStr,scAND,gofwd.checked,iscase.checked,isword.checked);

while pos<>0 do
begin
if not OrgMasterMain.sourcelist.insource.isvisible(pos) then
begin
OrgMasterMain.sourcelist.insource.makevisible(pos);
OrgMasterMain.sourcelist.rebuild(false,true);
end;
olds:=OrgMasterMain.sourcelist.insource[pos].s;
if iscase.checked then
news:=system.copy(olds,1,system.pos(findtext.text,olds)-1)+replacetext.text+system.copy(olds,system.pos(findtext.text,olds)+length(findtext.text),length(olds))
else
news:=system.copy(olds,1,system.pos(ansiuppercase(findtext.text),ansiuppercase(olds))-1)+
 replacetext.text+
 system.copy(olds,system.pos(ansiuppercase(findtext.text),ansiuppercase(olds))+length(findtext.text),length(olds));
 OrgMasterMain.SourceList.row:=OrgMasterMain.SourceList.disprow[pos];
if ispromt.checked then
case messagedlg(format(umessages.overwriteString,[olds,news]),mtConfirmation,[mbYes,mbNo,mbCancel],0) of
mrYes:
begin
 edtops.SetItem(pos,OrgMasterMain.sourcelist.insource[pos]);
 OrgMasterMain.sourcelist.insource[pos].s:=news;
  OrgMasterMain.sourcelist.insource[pos].samenode.text:=news;
 ismodify:=true;
end;
mrCancel:break;
end
else
begin
 edtops.SetItem(pos,OrgMasterMain.sourcelist.insource[pos]);
 OrgMasterMain.sourcelist.insource[pos].s:=news;
 ismodify:=true;
end;
lp:=pos;
pos:= OrgMasterMain.sourcelist.insource.findbyname(pos,findStr,scAND,gofwd.checked or fromtop.checked,iscase.checked,isword.checked);
end;
OrgMasterMain.sourcelist.rebuild(false,true);
if lp<>0 then
OrgMasterMain.sourcelist.row:=OrgMasterMain.sourcelist.disprow[lp];
showmessage(umessages.SearchComplete);
finally
findstr.free;
end;

end;
end.
