unit uPBProp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, ToolEdit, Buttons, ExtCtrls, Db, Grids, DBGrids,
  ComCtrls, checklst, ImageComboBox, TB97, dcommon, TB97Tlbr, TB97Ctls,
  Menus;

type
  TStreamInfo=record
                     id,id0,idpro:integer;
                     idkind:byte;
                     name,sname:string;
                     schanged:boolean;
                     proimport:boolean;
                  end;
  TBPPropView = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    MtypesSel: TCheckListBox;
    BPName: TEdit;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    newname: TEdit;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    BPAvt: TEdit;
    BPComm: TMemo;
    Panel1: TPanel;
    ListBox1: TListBox;
    Label7: TLabel;
    ONum: TEdit;
    Enablecallouts: TCheckBox;
    BuiltDate: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
    classlist:array[1..50] of  TSTreamInfo;
    strcount:integer;
    prolistA:TModelArray;
  public
    { Public declarations }
  end;

var
  BPPropView: TBPPropView;

implementation

uses StrTab, MAIN, utils, items, appConst, prnprv;

{$R *.DFM}

procedure TBPPropView.FormActivate(Sender: TObject);
var s:string;
    i:integer;
    l:TLinks;
begin
pagecontrol1.activepage:=tabsheet1;

with strtables do
begin
BPName.text:=cutnumbers(BPTabName.asstring);
l:=TLinks.create(nil);
l.clear;
try
if STRTables.BPTabMBData.IsNull then
begin
STRTables.BPTabData.saveTofile(STRTables.Profile.tablename);
l.load(STRTables.Profile);
end
else
l.loadfromBLOB(STRTables.BPTabMBData);
finally
l.free;
end;

ONum.text:=getnumbers(BPTabName.asstring);
BPAvt.text:=BPTabAvtor.asstring;
BPComm.text:=BPTabComm.asstring;
enablecallouts.checked:=(BPTabSp2.asInteger and 1 )<>0;
if modelt.locate('N',bptabsp1.asinteger,[]) then
 edit2.text:=modeltName.asstring
 else
 edit2.text:='<  >';
modelt.first;
strcount:=0;
while not modelt.eof do
begin
if (modelttype.asinteger in [SPRID,LIBSPRID]) then
begin
inc(strcount);
classlist[strcount].id:=modeltN.asInteger;
classlist[strcount].id0:=0;
classlist[strcount].name:=modeltName.asstring;
classlist[strcount].sname:='';
classlist[strcount].schanged:=false;
end;
modelt.next;
end;
modelt.first;
listbox1.items.clear;

while not modelt.eof do
begin
if (modelTtype.AsInteger=0)and(modeltsp1.asinteger=BPTabN.asInteger) then
begin
 for i:=1 to strcount do if classlist[i].id=modeltsp2.asinteger then break;
 s:=modeltname.asstring;
 if i<=strcount then
 begin
  s:=s+' - '+classlist[i].name;
  classlist[i].id0:=modeltN.asinteger;
  classlist[i].sname:=modeltname.asstring;
  classlist[i].idpro:=(modelTSprType.AsInteger shr 5)and $1fff;
  classlist[i].idkind:=(modelTSprType.AsInteger shr 18);
  classList[i].proImport:=false;
 end
end;
modelt.next;
end;
for i:=1 to strcount do
if classlist[i].id0<>0 then listbox1.items.addobject(classlist[i].sname+'-'+classlist[i].name,@classlist[i]);
builtdate.text:=BPTabMdate.AsString;
end;
mtypessel.Clear;
newname.enabled:=false;
newname.text:='';
end;

procedure TBPPropView.ListBox1Click(Sender: TObject);
begin
newname.enabled:=false;
newname.text:=TStreaminfo(pointer(listbox1.Items.Objects[listbox1.itemindex])^).sname;
newname.enabled:=true;
end;


end.
