unit SelWEBImageDlgUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Spin;

type
  TSelWEBImageDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    DiagramType: TRadioGroup;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ImageWidth: TSpinEdit;
    ImageHeight: TSpinEdit;
    ImageType: TRadioGroup;
    GroupBox3: TGroupBox;
    IDEF0Enable: TCheckBox;
    DFDEnable: TCheckBox;
    LSAEnable: TCheckBox;
    NewDFDEnable: TCheckBox;
    PNDEnable: TCheckBox;
    procedure DiagramTypeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SelWEBImageDlg: TSelWEBImageDlg;

implementation

{$R *.DFM}

procedure TSelWEBImageDlg.DiagramTypeClick(Sender: TObject);
begin
  case DiagramType.ItemIndex of
   0: begin
        ImageWidth.Enabled:=False;
        ImageHeight.Enabled:=False;
      end;
   1: begin
        ImageWidth.Enabled:=True;
        ImageHeight.Enabled:=True;
      end;
   2: begin
        ImageWidth.Enabled:=True;
        ImageHeight.Enabled:=True;
      end;
  end;
end;

end.
