unit WrapLog;

interface

procedure WriteLog(ClassName,FunctionName,ErrorMessage:String);

Const filename='wrapper.log';

implementation

Uses Windows,SysUtils;

procedure WriteLog(ClassName,FunctionName,ErrorMessage:String);
Var F:TextFile;
    S:String;
begin
 try
 AssignFile(F,filename);
 {$I-}
  Append(F);
 {$I+}
 if IOResult<>0 then rewrite(F);
 S:=DateTimeToStr(Now)+' '+ClassName+':'+FunctionName+' Err:'+ErrorMessage;
 Write(F,S);
 CloseFile(F);
 except
  try
   AssignFile(F,'fioerror.sem');
   Rewrite(F);
   Write(F,'Unable to write log file');
  finally
   CloseFile(F);
  end;
 end;
end;

end.
