unit NewPrItm;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, Mask, ToolEdit,Dialogs, Db, DBTables,compOps,
  checklst,Utils;

type
  TNewCompItemLT = class(TForm)
    NewCompItem: TButton;
    CancelBtn: TButton;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    PrjName: TEdit;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Avtor: TEdit;
    Dates: TDateEdit;
    CheckBox1: TCheckBox;
    OldFN: TFilenameEdit;
    VF: TCheckBox;
    Prim: TMemo;
    Label6: TLabel;
    FN: TEdit;
    procedure NewCompItemClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PrjNameChange(Sender: TObject);
    procedure VFClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure OldFNBeforeDialog(Sender: TObject; var Name: String;
      var Action: Boolean);
    procedure OldFNChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NewCompItemLT: TNewCompItemLT;

implementation

{$R *.DFM}
Uses FileUtil,Main, Logs, appConst, F25,Umessages, NC, StrTab,variants;

procedure TNewCompItemLT.NewCompItemClick(Sender: TObject);
var NewComps,Folder:TTreeNode;
    IsExt:boolean;
    R:Integer;
    FNameIn ,FNameTo:String;
    MI:TModelInfo;
begin
if  PrjName.Text='' then
begin
MessageDlg(umessages.enterthename,mtError,[mbOk],0);
exit;
end;
if (FN.Text='') then
begin
MessageDlg(umessages.enterfilename,mtError,[mbOk],0);
exit;
end;
setcurrentdir(appconst.sysinfo.sysdir);
FN.Text:=CutFileExt(FN.Text)+BPJEXT   ;
Fnameto:=ExpandFileName(NormalDir(CurrCompDir)+NormalFileName(ExtractFileName(FN.Text)));
IsExt:=false;
if not VF.Checked then
begin
//FNameTo:=CutFileExt(ExtractFileName(FN.Text))+BPJEXT;
if fileexists(FNameTo) then
begin
MessageDlg(format(Umessages.OverWriteError,[fnameto]),mtError,[mbOK],0);
exit;
end;
OrgMasterMain.NewPrjs(FNameTo);
end
else
 begin
if (UPPERCASE(fnameto)<>UPPERCASE(oldfn.filename)) then
begin
if fileexists(FNameTo) then
begin

MessageDlg(format(Umessages.OverWriteError,[fnameto]),mtError,[mbOK],0);
exit;
end;
if not fileexists(Oldfn.filename) then
begin
MessageDlg(umessages.filenotfound,mtError,[mbOk],0);
exit;
end;
if ExtractfileExt(oldfn.filename)=B5JEXT then
begin
 f25.read_mdl25(FNameTo,oldfn.filename,mi,OrgMasterMain.PB);
 avtor.text:=mi.Author;
 if prjname.text=cutfileext(ExtractfileName(oldfn.filename)) then
 prjname.text:=mi.Name;
 Dates.Date:=mi.MDate;
 Prim.text:=mi.Comment;
end
else if  ExtractfileExt(oldfn.filename)=BPJEXT then
begin
fnamein:=Oldfn.filename;
begin
 if UpperCase(FNameTo)<>UpperCase(FNameIn) then
  begin
   if fileexists(FNameTo) and
     (MessageDlg(format(umessages.overwrite,[fnameto]),mtConfirmation,[mbYes,mbNo],0)<>mrYes) then exit;
   R:=FileOpen(FNameIn, fmShareDenyWrite);
   if R<=0 then
   begin
   exit;
   end
   else
   FileClose(R);
  if fileExists(FNameto) then
  begin
  R:=FileOpen(FNameto, fmShareDenyWrite);
  if R<=0 then
  begin
  exit;
  end
  else
  FileClose(R);


  DeleTeFile(FNameTo);
  DeleteFile(CutFileExt(FNameTo)+MBEXT);
    end;

try
utils.copySTRfile(FNameIn,FNameTo,OrgMasterMain.PB);
finally
OrgMasterMain.PB.Progress:=0;
//OrgMasterMain.Animate1.visible:=false;
end
end;

end
end

end

end;

FNameTo:=ExtractFileName(FNameTo);
if not OrgMasterMain.comp.locate('Tag;FileName',vararrayof([CurrComp,FNameTo]),[]) then
OrgMasterMain.Comp.Append
else
OrgMasterMain.comp.edit;
OrgMasterMain.Comp.FieldByName('Flags').AsInteger:=0;
OrgMasterMain.Comp.FieldByName('ItemName').AsString:=ClearSpaces(PrjName.Text);
OrgMasterMain.Comp.FieldByName('IsGroup').AsBoolean:=false;
OrgMasterMain.Comp.FieldByName('FileName').AsString:=FNameTo;
OrgMasterMain.Comp.FieldByName('Comment').AsString:=Prim.Text;
if dates.date<>0 then
OrgMasterMain.Comp.FieldByName('CrDate').AsDateTime:=Dates.Date
else
OrgMasterMain.Comp.FieldByName('CrDate').AsDateTime:=Date;
if dates.date<>0 then
OrgMasterMain.Comp.FieldByName('MdfDate').AsDateTime:=Dates.Date
else
OrgMasterMain.Comp.FieldByName('MdfDate').AsDateTime:=Now;
OrgMasterMain.Comp.FieldByName('Tag').AsInteger:=CurrComp;
OrgMasterMain.Comp.FieldByName('Avtor').AsString:=avtor.Text;
OrgMasterMain.Comp.Post;
OrgMasterMain.Comp.Refresh;
OrgMasterMain.comp.FlushBuffers;
Folder:=FindCompNode(OrgMasterMain.CompView,CurrComp);
newcomps:=FindModelNode(OrgMasterMain.CompView,OrgMasterMain.comp.fieldbyName('N').AsInteger);
if newcomps=nil then
begin
NewComps:=OrgMasterMain.CompView.Items.AddChild(Folder,ClearSpaces(PrjName.Text));
New(PComp);
end
else
begin
PComp:=NewComps.Data;
NewComps.Text:=ClearSpaces(PrjName.Text);
end;
PComp.Tag:=CurrComp;
PComp.FileName:=FNameTo;
PComp.IsGroup:=false;
//PComp.ParentGroup:=CurrComp;
PComp.N:=OrgMasterMain.Comp.FieldByName('N').AsInteger;
PComp^.Comment:=Prim.Text;
PComp^.Avtor:=Avtor.Text;

NewComps.Data:=PComp;

if (pos(appconst.sysinfo.LocalDataDir,ANSIUpperCase(expandfilename(TPComp(Folder.Data)^.FileName)))=1) then
begin
NewComps.ImageIndex:=1;
NewComps.SelectedIndex:=1;
end
else
begin
NewComps.ImageIndex:=5;
NewComps.SelectedIndex:=5;
end;
OrgMasterMain.CompView.selected:=newcomps;
Close;
OrgMasterMain.CompViewDblClick(OrgMasterMain.compview);
end;

procedure TNewCompItemLT.FormActivate(Sender: TObject);
var i:integer;
begin
logs.startproc('newcompitem','formactivate','start','',5);
Dates.Date:=sysutils.Date;
{$IFNDEF VIEW}
{$ELSE}
{$ENDIF}
With OrgMasterMain do
begin
//NewSpis.Clear;
//StdSp.first;
i:=0;
{While not StdSp.EOF do
begin
NewSpis.Items.Add(StdSp.FieldByname('Name').asString);
if StdSp.FieldByname('Incl').asBoolean then
NewSpis.Checked[i]:=true;
inc(i);
StdSp.Next;
end
}
end;
FN.Enabled:=not CheckBox1.Checked;
logs.startproc('newcompitem','formactivate','finish','',6);
end;



procedure TNewCompItemLT.PrjNameChange(Sender: TObject);
begin
If CheckBox1.Checked then
FN.Text:=normalfilename(PrjName.Text)+BPJEXT;
end;

procedure TNewCompItemLT.VFClick(Sender: TObject);
begin
{$IFNDEF VIEW}
{$ELSE}
 vf.Checked:=true;
{$ENDIF}
oldfn.Enabled:=vf.checked;
end;

procedure TNewCompItemLT.CheckBox1Click(Sender: TObject);
begin
if CheckBox1.Checked then
begin
FN.Text:=PrjName.Text+BPJEXT;
end;
FN.Enabled:=not CheckBox1.Checked;
end;

procedure TNewCompItemLT.OldFNBeforeDialog(Sender: TObject; var Name: String;
  var Action: Boolean);
begin
Action:=VF.Checked;
end;

procedure TNewCompItemLT.OldFNChange(Sender: TObject);
begin
FN.Text:=CutFileExt(ExtractFileName(OldFN.Text))+BPJEXT;
PrjName.Text:=CutFileExt(ExtractFileName(OldFN.Text));
CheckBox1.checked:=true;
end;

procedure TNewCompItemLT.FormShow(Sender: TObject);
begin
if OrgMasterMain.CompView.Selected=nil then
exit;
{
if OrgMasterMain.CompView.Selected.parent=nil then
caption:='    "'+OrgMasterMain.CompView.Selected.text+'"'
else
caption:='    "'+OrgMasterMain.CompView.Selected.Parent.text+'"'}
end;

procedure TNewCompItemLT.FormCreate(Sender: TObject);
begin
avtor.text:=appconst.sysinfo.defavtor;
OLDFN.Filter:=appconst.ModelFilter;
end;

end.
