Unit BPDef;
{
(c) .  1997,2006
}
{$INCLUDE Compmode.inc}
{ Corrected 24-12-98 }
{ Corrected 12-09-98 }
{ Added     30-09-98 }
{ Added     22-11-01 }

Interface

Uses Windows,Messages,Graphics, classes;

Type
      TVeryShortString=String[15];
      TLinkShortString=String[24];
      TLevelEvent=procedure(level:string) of object;
      TBPMultipleMask=(bpmm_None,bpmm_From,bpmm_To,bpmm_FromTo);
      TBPOrdinate=Array[0..9] of Integer;
      TBPAcceptPos=Array[0..9] of Boolean;


      { Node definition }
      PBPNode=^TBPNode;
      TBPNode=packed record
         ssCaption:ShortString;  {  㧫 }
        dwNodeNumber:DWORD;     {  㧫  痢 }
        ssNodeNumber:TVeryShortString; { 㥬  㧫 }
        fABCValue:Double;
        dwNodeIndex:DWORD;
        Left:array[0..9] of Integer;
        Top:array[0..9] of Integer;
        AcceptPosition:array[0..9] of Boolean;
        ssComment:ShortString;
     end;

      PBPDNode=^TBPDNode;
      TBPDNode=packed record
        ssCaption:ShortString;
        dwNodeNumber:DWORD;
        ssNodeNumber:TVeryShortString; { 㥬  㧫 }
        fABCValue:Double;
        dwNodeIndex:DWORD;
        dwFlags:DWORD;
        Left:array[0..9] of Integer;
        Top:array[0..9] of Integer;
        AcceptPosition:array[0..9] of Boolean;
        ssComment:ShortString;
      end;

      { Link definition }
      TLinkType=(lt_Left,lt_Right,lt_Top,lt_Bottom);

      PBPLink=^TBPLink;
      TBPLink=packed record
        ssFromCaption:ShortString;       {  裡  室  }
        ssToCaption:ShortString;         {  裡  室 }
        ssUnMovedFrom:ShortString;
        ssUnMovedTo:ShortString;
        ssGlobalCaption:TVeryShortString;
                                         {   室-室 }
        dwFromNodeNumber:DWORD;          {  㧫  }
        dwToNodeNumber:DWORD;            {  㧥  }
        dwFlags:DWORD;                   {  ⠭ 䫠 裡 }
        dwFromLinkNumber:int64;          {  裡 室騩 }
        dwToLinkNumber:int64;            {  裡 室騩 }
        dwLinkIndex:DWORD;
        FromLeft:array[0..9] of Integer;
        FromTop:array[0..9] of Integer;
        FromAcceptPosition:array[0..9] of Boolean;
        ToLeft:array[0..9] of Integer;
        ToTop:array[0..9] of Integer;
        ToAcceptPosition:array[0..9] of Boolean;
        IP_SRC:Integer;
        IP_DST:Integer;
        DNodeAcceptPosition:Boolean;
        ssFromPath:ShortString;
        ssToPath:ShortString;
      end;
TSaveBPLink=packed record
        ssFromCaption:ShortString;       {  裡  室  }
        ssToCaption:ShortString;         {  裡  室 }
        ssGlobalCaption:TVeryShortString;
                                         {   室-室 }
        dwFromNodeNumber:DWORD;          {  㧫  }
        dwToNodeNumber:DWORD;            {  㧥  }
        dwFlags:DWORD;                   {  ⠭ 䫠 裡 }
        dwFromLinkNumber:DWORD;          {  裡 室騩 }
        dwToLinkNumber:DWORD;            {  裡 室騩 }
        dwLinkIndex:DWORD;
        FromLeft:array[0..9] of Integer;
        FromTop:array[0..9] of Integer;
        FromAcceptPosition:array[0..9] of Boolean;
        ToLeft:array[0..9] of Integer;
        ToTop:array[0..9] of Integer;
        ToAcceptPosition:array[0..9] of Boolean;
        IP_SRC:Integer;
        IP_DST:Integer;
        DNodeAcceptPosition:Boolean;
        ssFromPath:ShortString;
        ssToPath:ShortString;
      end;
      PSaveBPLink=^TSaveBPLink;
      PBPDLink=^TBPDLink;
      TBPDLink=packed record
        ssFromCaption:ShortString;       {  裡  室  }
        ssToCaption:ShortString;
        ssUnMovedFrom:ShortString;
        ssUnMovedTo:ShortString;         {  裡  室 }
        ssGlobalCaption:TVeryShortString;
                                         {   室-室 }
        dwFromNodeNumber:DWORD;          {  㧫  }
        dwToNodeNumber:DWORD;            {  㧥  }
        dwFlags:DWORD;                   {  ⠭ 䫠 裡 }
        dwFromLinkNumber:int64;          {  裡 室騩 }
        dwToLinkNumber:int64;            {  裡 室騩 }
        dwLinkIndex:DWORD;
        FromLeft:array[0..9] of Integer;
        FromTop:array[0..9] of Integer;
        FromAcceptPosition:array[0..9] of Boolean;
        ToLeft:array[0..9] of Integer;
        ToTop:array[0..9] of Integer;
        ToAcceptPosition:array[0..9] of Boolean;
        IP_SRC:Integer;
        IP_DST:Integer;
        DNodeAcceptPosition:Boolean;
        ssFromPath:ShortString;
        ssToPath:ShortString;
      end;

      PBPNodeTypes=^TBPNodeTypes;
      TBPNodeTypes=packed record
        dwNodeIndex:DWORD;
        dwID:DWORD;
        dwParent:DWORD;
        ssCaption:String[64];
        dwFontColor:TColor;
        dwPaintColor:TColor;
        dwDrawColor:TColor;
        dwShadowColor:TColor;
        dwShadowStyle:DWORD;
        dwRectStyle:DWORD;
      end;


      PBPLinkTypes=^TBPLinkTypes;
      TBPLinkTypes=packed record
        dwLinkIndex:DWORD;
        dwID:DWORD;
        dwParent:DWORD;
        ssCaption:String[64];
        dwColor:TColor;
        dwPenStyle:TPenStyle;
        dbShowLinkType:Boolean;
      end;


   {  BPD File structure:
          Header
          NodesTypesInfo
          LinksTypesInfo
          Tree
          Data1
          Data2
          Data3
          Data4
          .....
          OperTree
          OpData1
          OpData2
          OpData3
          ......  }


    PBPHeader = ^TBPHeader;
    TBPHeader = packed record
      ssModel:ShortString;    { Model name }
      ssCompany:ShortString;  { Company name }
      ssAuthor:ShortString;   { Author }
      dfDateTime:TDateTime;   { Date and Time creating model }
      dwRevision:DWORD;       { Document revision }
      dwNodesTypesCount:DWORD;
      dwLinksTypesCount:DWORD;
      dwOpEntries:DWORD;
      dwIPEntries:DWORD;
    end;

    TDraftStatusModes = (dsWorking,dsDraft,dsRecomended,dsPublication);
    TDraftStatus = set of TDraftStatusModes;

    PBPOpDetail=^TBPOpDetail;
    TBPOpDetail= packed record
      ssCaption:ShortString;
    end;

    PBPOPTree=^TBPOpTree;
    TBPOpTree= packed record
     dwDataOffset:DWORD;
      dwLevel:Integer;
      dwParent:Integer;
      ssCaption:ShortString;
      dwOpDetailCount:DWORD;
      dwNodeIndex:DWORD;
      lpOpDetail:TStringList;
      btFlags:byte;
      end;

    PBPTree =^TBPTree;
    TBPTree = packed record
       dwDataOffset:DWORD;
       dwLevel:Integer;          { Opened level e.q. 123 = 1.2.3,
                                   10  ন !,
                                 砫  -1 }
      dwID:DWORD;                           
      dwParent:Integer;       { Parent level  }
      dwDepth:Integer;
      ssLevel:String[64];     { level in string 11.21.12.1 }
      ssCaption:ShortString;  { Level Caption }
      ssNotes:ShortString;
      dwRevision:DWORD;       { Shit Revision }
      dwNodesCount:DWORD;     { Nodes count   }
      dwLinksCount:DWORD;     { Links count   }
      dwStatus:TDraftStatus;  { Draft status  }
      dwPageNumber:DWORD;     { Page Number   }
      dwNodesMemRequired:DWORD;
      dwLinksMemRequired:DWORD;
      lpNodes:TList;
      lpLinks:TList;
   end;

    PBPInfo =^TBPInfo;
    TBPInfo = packed record
      dwLevel:Integer;
      ssLevel:ShortString;
      ssCaption:ShortString;
    end;

      PByte=^Byte;
    PBPInProcessNode=^TBPInProcessNode;
    TBPInProcessNode= packed record
      dwNodeNumber:Integer;
      ssCaption:ShortString;
      dwNodeIndex:Integer;
      Left:TBPOrdinate;
      Top:TBPOrdinate;
      AcceptPosition:TBPAcceptPos;
      ssComment:ShortString;
      ssPath:ShortString;
      ssMechanism:ShortString;
      ssControl:ShortString;
    end;

    PBPNodeRenameStructure=^TBPNodeRenameStructure;
    TBPNodeRenameStructure=packed record
      dwNodeNumber:DWORD;
      ssNodeNumber:TVeryShortString;
      LinksLeft:DWORD;
      LinksRight:DWORD;
      LinksTop:DWORD;
      LinksBottom:DWORD;
      LinksBottomDFD:WORD;
      level:integer;
    end;

    PBPLinkRenameStructure=^TBPLinkRenameStructure;
    TBPLinkRenameStructure=packed record
       link:PBPLink;
      linkRenamedFrom:Boolean;
      linkRenamedTo:Boolean;
      FromLinkNumber:int64;
      ToLinkNumber:int64;
      level:integer;
      fromWeight,toWeight:integer;
      firstFrom,firstTo:boolean;
      forkfrom,forkTo:boolean;
      parent,next,prev,sameParentL,sameParentR:PBPLinkRenameStructure;
   end;

Const  BPGlobalLeftNodeNumber    = $10000000;
       BPGlobalRightNodeNumber   = $20000000;
       BPGlobalTopNodeNumber     = $40000000;
       BPGlobalBottomNodeNumber  = $80000000;
{@@@}  BPGlobalMask              = $FC000000; {/@@@}
       BPGlobalNotOpMask         = $F0000000;
{@@@}  BPUnreachedNodeNumber     = $03FFFFFF; {/@@@}
{@@@}  BPNotGlobalMask           = $03FFFFFF; {/@@@}
       BPGlobalNodeLeft          = $10000000;
       BPGlobalNodeRight         = $20000000;
       BPGlobalNodeTop           = $40000000;
       BPGlobalNodeBottom        = $80000000;
       BPGlobalNodeOperation     = $08000000;
{@@@}  BPGlobalNodeInProcess     = $04000000; {/@@@}
  { Links dwFlags constant }
       BP_FROMNODE_LEFT =     $00000001; { From node - left side }
       BP_FROMNODE_RIGHT =    $00000002; { From node - right side }
       BP_FROMNODE_TOP =      $00000004; { From node - top side }
       BP_FROMNODE_BOTTOM =   $00000008; { From node - bottom side }
       BP_FROMMASK =          $0000000F; { From node side Mask }
       BP_FROMMASK_INVERT =   $FFFFFFF0;
       BP_TONODE_LEFT =       $00000010; { To node - left side }
       BP_TONODE_RIGHT =      $00000020; { To node - right side }
       BP_TONODE_TOP =        $00000040; { To node - top side }
       BP_TONODE_BOTTOM =     $00000080; { To node - bottom side }
       BP_TOMASK =            $000000F0; { To node side mask }
       BP_TOMASK_INVERT =     $FFFFFF0F;
       { From -> To both mask }
       BP_FROMTOMASK  =       $000000FF; { Both from & to sides mask }
       BP_LEFT_LEFT =         $00000011;
       BP_LEFT_RIGHT =        $00000021;
       BP_LEFT_TOP =          $00000041;
       BP_LEFT_BOTTOM =       $00000081;
       BP_RIGHT_LEFT =        $00000012;
       BP_RIGHT_RIGHT =       $00000022;
       BP_RIGHT_TOP =         $00000042;
       BP_RIGHT_BOTTOM =      $00000082;
       BP_TOP_LEFT =          $00000014;
       BP_TOP_RIGHT =         $00000024;
       BP_TOP_TOP =           $00000044;
       BP_TOP_BOTTOM =        $00000084;
       BP_BOTTOM_LEFT =       $00000018;
       BP_BOTTOM_RIGHT =      $00000028;
       BP_BOTTOM_TOP =        $00000048;
       BP_BOTTOM_BOTTOM =     $00000088;
       BP_SHOW_FROMCAPTION =  $00000100; { Show from node link caption }
       BP_SHOW_TOCAPTION =    $00000200; { Show to node link caption }
       BP_SHOW_GLOBALCAPTION= $00000400; { Show global caption  }
       BP_DATALINK_DOCUMENT=  $20000000; { Show circle on link }
       BP_NOTUSED_NOW       = $C0000000; { Unused link - posible damaged }
       BP_NOTUSED_FROM   =    $40000000;
       BP_NOTUSED_TO       =  $80000000;
       BP_HAS_FROMPATH=       $00001000; { Has from document path }
       BP_HAS_TOPATH=         $00002000; { Has to document path }


      { Level constant }
       BP_LEVEL_NONE         = -2;
       BP_LEVEL_MODEL        = -1;
       BP_LEVEL_MODELDECOMP  =  0;

Const WM_UNSELECTALL = WM_USER + 1;
      crMyCursor = 5;


Implementation

end.