unit bpfpcreateform;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, dcommon, Grids, ExtCtrls, Buttons, CheckLst, ComCtrls;

type

  TBPFromProForm = class(TForm)
    Button3: TButton;
    Button4: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    BaseClass: TComboBox;
    BPName: TEdit;
    PRSClass: TComboBox;
    GroupBox2: TGroupBox;
    AvailablePro: TListBox;
    UsedPro: TListBox;
    Button1: TButton;
    Button2: TButton;
    ObjectNumber: TEdit;
    NLabel: TLabel;
    Protype: TComboBox;
    pdistrselect: TComboBox;
    Label4: TLabel;
    UseIn: TCheckBox;
    Label5: TLabel;
    EnhancedSet: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure BaseClassClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure UsedProClick(Sender: TObject);
    procedure ProTypeClick(Sender: TObject);
    procedure UseInClick(Sender: TObject);
    procedure ObjectNumberKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    ProCount:integer;
    {$IFNDEF ED}
    ProArray:array[1..32] of   TProData;
    {$ELSE}
    ProArray:array[1..10] of   TProData;
    {$ENDIF}
    cpd:PProdata;
    prsID:integer;
  public
    { Public declarations }
  end;

var
  BPFromProForm: TBPFromProForm;

implementation

uses MAIN, appConst,  StrTab, dbtables,db, items,utils;

{$R *.DFM}

procedure TBPFromProForm.FormCreate(Sender: TObject);
var i:integer;
begin
BaseClass.items.clear;
PRSClass.items.clear;
UsedPro.items.clear;
proType.enabled:=false;
usein.enabled:=false;
AvailablePro.items.clear;
with OrgMasterMain do
begin
 for i:=1 to modelcontense.count do
 if modelcontense[i].otype and 31 =SPRID  then
 begin
  self.BaseClass.items.addobject(modelcontense[i]^.name,TObject(modelcontense[i]));
  PRSClass.items.addobject(modelcontense[i]^.name,TObject(modelcontense[i]));
 end;
end;
PRSClass.itemindex:=-1;
Availablepro.enabled:=false;
Button1.enabled:=false;
end;

procedure TBPFromProForm.BaseClassClick(Sender: TObject);
var i:integer;
    id:integer;
    l:TLiteLinks;
begin
pdistrselect.clear;
pdistrselect.Items.AddObject('  ',nil);
UsedPro.items.clear;
AvailablePro.items.clear;
if  PRSClass.itemindex>=0 then
prsid:=PModelObject(pointer(PRSClass.items.objects[PRSClass.itemindex]))^.n
else
prsid:=0;
if BaseClass.itemindex<0 then exit;
id:=PModelObject(pointer(BaseClass.items.objects[BaseClass.itemindex]))^.n;
BPName.text:=utils.cutnumbers(BaseClass.items[BaseClass.itemindex]);
ProCount:=0;
with OrgMasterMain do begin
for i:=1 to ModelContense.count do
if (modelcontense[i].otype in [PROID])then
if  ((modelcontense[i].prs=0)or(modelcontense[i].prs=prsid))and
     (modelcontense[i].sp1<>prsid)and
     (modelcontense[i].sp2<>prsid)and
     ((modelcontense[i].sprt<>prsid)or(modelcontense[i].sprt=0)) and
    ((modelcontense[i].sp1=id)or
     (modelcontense[i].sp2=id)or
     (modelcontense[i].sprt=id)or EnhancedSet.checked) then
begin
inc(proCount);
ProArray[procount].mp:=modelcontense[i];
ProArray[procount].usein:=true;
strtables.spr_2.locate('N',modelcontense[i].n,[]);
if  modelcontense[i].otype=PROID then
begin
l:=TLiteLinks.create(nil);
try
l.loadfromblob(STRTables.spr_2MBData);
case l.prjtype of
ptLRN:ProArray[procount].kind:=0;
ptIOC:ProArray[procount].kind:=1;
ptIOM:ProArray[procount].kind:=2;
ptM:ProArray[procount].kind:=3;
ptC:ProArray[procount].kind:=4;
end;
finally
l.free;
end;
end
else ProArray[procount].kind:=-1;
self.AvailablePro.items.addObject(modelcontense[i].name,@ProArray[procount]);
end
else
if  (modelcontense[i]^.otype  in [PROID])and(modelcontense[i]^.prs=0)and
((modelcontense[i]^.sp1=id)and(modelcontense[i]^.sp2=prsid)or
(modelcontense[i]^.sp2=id)and(modelcontense[i]^.sp1=prsid))and
((modelcontense[i]^.sprt=id)or(modelcontense[i]^.sprt=0)) then
pdistrselect.Items.AddObject(ClearSpaces(modelcontense[i]^.name),TObject(modelcontense[i]));
end;
if pdistrselect.Items.count>1 then
pdistrselect.itemindex:=1
else
pdistrselect.itemindex:=0;
availablepro.enabled:=true;
Button1.enabled:=true;
end;

procedure TBPFromProForm.Button1Click(Sender: TObject);
begin
UsedPro.items.addObject(AvailablePro.items[AvailablePro.itemindex],AvailablePro.items.objects[AvailablePro.itemindex]);
TProData(pointer(AvailablePro.items.objects[AvailablePro.itemindex])^).usein:=PRSClass.itemindex>=0;
AvailablePro.items.Delete(AvailablePro.itemindex);
end;

procedure TBPFromProForm.Button2Click(Sender: TObject);
begin
AvailablePro.items.addObject(UsedPro.items[UsedPro.itemindex],UsedPro.items.objects[UsedPro.itemindex]);
UsedPro.items.Delete(UsedPro.itemindex);
end;

procedure TBPFromProForm.Button3Click(Sender: TObject);
var i,id:integer;
    mp,mo:PModelObject;
    ms:TMemoryStream;
    bs:TBlobStream;
    pd:TProData;
    grpid:integer;
    l:TLiteLinks;
    mask:word;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if (BaseClass.ItemIndex<0) then exit;
if usedpro.items.count=0 then exit;
mask:=0;

with STRTables do
begin
 modelT.append;
 ModelT.edit;
 ModelTName.asString:=ClearSpaces(Objectnumber.Text+' '+BPName.text);
 ModelTSp1.asInteger:=PModelObject(pointer(BaseClass.items.objects[BaseClass.itemindex]))^.n;
 PModelObject(pointer(BaseClass.items.objects[BaseClass.itemindex]))^.PRS:=1;
 ModelTType.asInteger:=NewBPID;
 if pdistrselect.itemindex>0 then
 grpid:=PModelObject(pointer(PDistrselect.items.objects[pdistrselect.itemindex]))^.n
 else
 grpid:=0;
 ModelTSp2.asInteger:=grpid;
 ModelTSprType.asInteger:=prsid;
 ModelT.Post;
 mo:=OrgMasterMain.appendnewmodelitem;
 id:=ModelTN.asInteger;

 ms:=TMemorystream.create;
 for i:=0 to UsedPro.items.count-1 do
 begin
 pd:=TProData(pointer(UsedPro.items.objects[i])^);
  mp:=pd.mp;
  mp^.grp:=grpid;
  if pd.usein then
  begin
  mp^.PRS:=PRSID;
  mp^.prssubst:=PModelObject(pointer(BaseClass.items.objects[BaseClass.itemindex]))^.n;
  end
  else
  begin
  mp^.prs:=0;
  mp^.prssubst:=0;
  end;
  if STRTables.Locate_MdlObj(mp^.n) then
  begin
  STRTables.ModelT.Edit;
  STRTables.ModelTPrsN.AsInteger:=mp^.PRS;
  STRTables.ModelTGrpNum.AsInteger:=mp^.grp;
  STRTables.ModelTPrsSubstN.AsInteger:=mp^.prsSubst;
  STRTables.ModelT.Post;
  end;

  spr_2.locate('N',mp^.n,[]);
  if mp^.otype=PROID then
  begin
  l:=TLiteLinks.create(nil);
  try
  l.loadfromblob(spr_2MBData);
  case pd.kind of
  0: l.prjType:=ptLRN;
  1: l.prjType:=ptIOC;
  2: l.prjType:=ptIOM;
  3: l.prjType:=ptM;
  4: l.prjType:=ptC;
  end;
  spr_2.edit;
  l.savetoblob(spr_2mbdata);
  spr_2.post;
  finally
  l.free;
  end;
  end;
  id:=i+1;
  ms.Write(id,sizeof(id));
  id:=mp^.n;
  ms.Write(id,sizeof(id));
  id:=0;
  ms.Write(id,sizeof(id));
  ms.Write(id,sizeof(id));
  ms.Write(id,sizeof(id));
  ms.Write(id,sizeof(id));
  ms.Write(id,sizeof(id));
 end;
 id:=0;
 Locate_MdlObj(mo^.n);
 ModelT.edit;
 ms.Write(id,sizeof(id));
 bs:=TBlobStream.create(ModelTMbData,bmWrite);
 ms.SaveToStream(bs);
 bs.free;
 ModelT.post;
 ms.free;
end;
OrgMasterMain.fillmodelpanel(OrgMasterMain.BPList);
OrgMasterMain.BPlist.Selected:=mo.li;
OrgMasterMain.ismodelmodify:=true;
{$ENDIF}
{$ENDIF}
end;

procedure TBPFromProForm.UsedProClick(Sender: TObject);
begin
 cpd:=PProData(pointer(UsedPro.items.objects[UsedPro.itemIndex]));

 Protype.itemindex:=cpd^.kind;
 usein.checked:=cpd^.usein;
 proType.enabled:=cpd^.kind>=0;
 usein.enabled:=PrsClass.ItemIndex>=0;
end;

procedure TBPFromProForm.ProTypeClick(Sender: TObject);
begin
 cpd:=PProData(pointer(UsedPro.items.objects[UsedPro.itemIndex]));
 cpd^.kind:=protype.itemindex;
end;

procedure TBPFromProForm.UseInClick(Sender: TObject);
begin
 cpd:=PProData(pointer(UsedPro.items.objects[UsedPro.itemIndex]));
 cpd^.usein:=usein.checked;

end;

procedure TBPFromProForm.ObjectNumberKeyPress(Sender: TObject;
  var Key: Char);
begin
if not (key in [#8,'0'..'9','.']) then Key:=#0;
end;

end.
