unit bpvProp;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, BitEdit, ComCtrls, RXSpin, items,dcommon;

type
  TBPViewProp = class(TForm)
    PageControl1: TPageControl;
    MainSheet: TTabSheet;
    OperFilter: TRadioGroup;
    ShowFNumbers: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    ContextType: TRadioGroup;
    FunctionGroup: TCheckBox;
    LevelBox: TGroupBox;
    Panel1: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    RxSpinEdit1: TRxSpinEdit;
    CheckBox1: TCheckBox;
    StreamFilter: TRadioGroup;
    StreamFrom1: TBitEdit;
    StreamFromA: TBitEdit;
    LevelGrp: TTreeView;
    procedure Button1Click(Sender: TObject);
    procedure LevelGrpChange(Sender: TObject; Node: TTreeNode);
    procedure RxSpinEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    clsList,nodesList:TList;
  public
    { Public declarations }
    Model:TModelArray;
    procedure processSpr(cls:TOMItems);
    procedure getSpr(cls:TOMItems);
    function showmodal:integer;
  end;

var
  BPViewProp: TBPViewProp;
implementation

uses appConst,itutils;

{$R *.DFM}
var stripes1,stripes2:word;
procedure TBPViewProp.Button1Click(Sender: TObject);
begin
case OperFilter.itemindex of
0: appconst.sysinfo.opermode:=0;
1: appconst.sysinfo.opermode:=1;
2: appconst.sysinfo.opermode:=2;
end;
end;
function TBPViewProp.showmodal:integer;
begin
operfilter.itemindex:=appconst.sysinfo.opermode;
FunctionGroup.Checked:=appconst.sysinfo.GroupFunctions;
ShowFNumbers.checked:=appconst.sysinfo.showFunctionNumbers;
if itutils.contextam0 then
 ContextType.itemindex:=0
 else
 ContextType.ItemIndex:=1;
 result:=inherited showmodal;
 if result=mrOK then
 begin
 appconst.sysinfo.showFunctionNumbers:=ShowFNumbers.checked;
appconst.sysinfo.GroupFunctions:=FunctionGroup.Checked;
 case contextType.ItemIndex of
 0:itutils.contextam0:=true;
 1:itutils.contextam0:=false;
 end;
 end;
end;
procedure TBPViewProp.LevelGrpChange(Sender: TObject; Node: TTreeNode);
begin
RxSpinEdit1.Enabled:=false;
CheckBox1.Enabled:=false;
if node=nil then exit;
RxSpinEdit1.AsInteger:=integer(node.Data)and $1F;
CheckBox1.Checked:=integer(node.Data) and $100=$100;
RxSpinEdit1.Enabled:=true;
CheckBox1.Enabled:=node.parent=nil;
STreamFilter.ItemIndex:=(integer(node.Data)and $E0)shr 5;
StreamFrom1.value:=(integer(node.Data) shr 17)and $3FF;
StreamFromA.value:=(integer(node.Data) shr 26)and $3E or 1;
STReamFilter.Enabled:=CheckBox1.Enabled;
StreamFrom1.enabled:=CheckBox1.Enabled;
StreamFromA.enabled:=CheckBox1.Enabled;
end;

procedure TBPViewProp.RxSpinEdit1Change(Sender: TObject);
var d:integer;
begin
if not rxspinedit1.Enabled then exit;
if LevelGrp.Selected=nil then exit;
d:=(RxSpinEdit1.AsInteger and $1F)or(integer(checkbox1.Checked)shl 8)or
(StreamFilter.ItemIndex shl 5)or
(StreamFrom1.value and $3FF shl 17)or
((StreamFromA.value and $3E) shl 26);

LevelGrp.Selected.Data:=pointer(d);
end;
procedure TBPViewProp.processSpr(cls:TOMItems);
var i:integer;
    curnode:TTreeNode;
    d:integer;
begin
 d:=((cls.viewMode shr 3+1)and $1f)or(cls.viewMode and $100)or
     (cls.viewMode and 7 shl 5)or(cls.ViewMode and $FFFFFE00);
 curnode:=levelGrp.items.AddChildObject(nil,cls.caption,Pointer(d));
  clsList.add(cls);
 nodesList.add(curnode);
 levelgrp.Selected:=curnode;
end;
procedure TBPViewProp.getSpr(cls:TOMItems);
var i:integer;
    curnode:TTreeNode;
    d:integer;
begin
i:=clsList.IndexOf(cls);
if i<0 then exit;
curnode:=TTreeNode(nodesList[i]);
d:=Integer(curnode.data);
cls.viewMode:=(((d-1) and $1F) shl 3) or (d and $100) or (d and $FFFFFE00)or (d shr 5)and 7;
end;
procedure TBPViewProp.FormCreate(Sender: TObject);
begin
clsList:=TList.create;
NodesList:=TList.create;
end;

procedure TBPViewProp.FormDestroy(Sender: TObject);
begin
clslist.free;
nodeslist.Free;
end;
initialization
stripes1:=0;
stripes2:=1;
end.
