unit itUtils;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface
uses items,windows,mylists,mylisttypes,otherLists,otherlisttypes, bpdef,comctrls,stdctrls,coloredgrid,classes,dcommon,db,dbtables;
procedure GetBPSides(prType:TPrjType;globalLeft,globalRight:boolean;flags:integer;var lts,ltd:TLinkType);
function hasAnylink(items,pitems,lclass:TOMItems;links:TLiteLinks;root:integer;IncludeSubNodes,Direction:Boolean;showmode:integer):boolean;
procedure convLinksExpanded(LCN:integer;ls,lr:TLiteLinks;left,right,middle:TOMItems;double:boolean);
procedure convLinksNode(Model:TModelArray;ls,lr,res:TLiteLinks;node:integer);
procedure convLinksNodeL(Model:TModelArray;ls,lr,res:TLiteLinks;node:integer;RaiseLevel:boolean);
procedure ConvFunProcFun(ls,lr:TLiteLinks;LCN:integer;left,proc:TOMItems;TopParent:integer);
procedure ConvFunProcFunL(ls,lr:TLiteLinks;left,proc:TOMItems);
procedure ConvFunProcFunSimple(ls,lr:TLiteLinks;LCN:integer;left,proc:TOMItems;PRC:integer);
procedure ConvFunProcFunLSimple(ls,lr:TLiteLinks;left,proc:TOMItems;PRC:integer);
function RotIndex(left,right:integer;sleft,sright,smiddle:integer):word;
function getusingflags(l:TLiteLinks;i:TOMLink;PLeft,PRight:boolean;oleft,oright:boolean;level:integer):DWORD;
function ApplyProcFilter(ProcN,ProcN2,ProcFilter:Integer;use0:boolean;ProcClass:TOMItems):Boolean;
function ApplyProcFilter1(ProcN,ProcFilter:Integer;use0:boolean;ProcClass:TOMItems):Boolean;
function FilterWithPro(lcand,procfilter:integer; proclass,fclass:TOMItems;pdistr:TLiteLinks):Integer;
function FilterWithProTotal(procfilter:integer; proclass,fclass:TOMItems;pdistr:TLiteLinks):integer;
procedure prepareNext(l:TLiteLinks;node:integer);
procedure FillCombo(tree:TTreeNode;combo:TCombobox;c:TOMItems);
procedure fillcomboAll(tree:TTreeView;combo:TCombobox;c:TOMItems);
function setRWpro(l:TLiteLinks;left:TOMItems):boolean;
procedure level(c:TOMItems);
procedure AdjustStreamLevels(Model:TModelArray;lr:TLiteLinks;node:integer;res:TLiteLinks;compressLeaves:boolean);
procedure CompressIndexes(lr:TLiteLinks);
procedure getChild(src:TOMItems;id:integer;list:TIntList);
procedure applyFuncFilter(Groups:TLiteLinks;procfilter:integer;ProcClass:TOMItems;grid:TColoredGrid);
procedure DeleteUnused(tree:TTreeView;bp:TOMItems;group:TLiteLinks;usesubs:boolean);
function getDirHeader(prj:TLiteLinks;flag:integer):string;
function EncodePropsAndIndexes(li:TOMLink;lo:TLiteLinks):string;
procedure RebulidStructure(cls:TOMItems);
function InterSect(l1,l2:TList):boolean;
procedure SelectByBPTotal(src,dst,bpclass:TOMItems;grouplinks:TLiteLinks;root,p,pf:integer;incdeleted:boolean;mode:byte);
procedure setWParamUsed(bpclass:TOMItems;bpfilter:TLiteLinks);
procedure ClearWP(cls:TOMItems);
procedure incWP(Cls:TOMItems;root:integer;delta:integer);
function isFEO(lcand,PROC:integer;fclass,bpclass:TOMItems;la:Array of TLiteLinks;count:integer;grouplinks:TLiteLinks):boolean;
procedure CopyParams(ToCls,Fromcls:TOMItems);
procedure GetPairs(ls:TLiteLinks;cls:TOMItems;res:TList);
procedure SortTemplates(l:TStrings);
procedure ProcessComment(item:TOMItem;s:string);
function findbyWP(cls:TOMItems;WP:LongWord):integer;
procedure SetLevel(cls:TOMItems;root,top:integer);
function StructureByPro(Source:TOMItems;Links:TLiteLinks;Root:integer):boolean;
function CopyCls(source,Dest:TOMItems;Mode:byte):integer;
function GetBPContense(MA:TModelArray;BPData:TBlobField;ProList:TStringList):integer;
function DownGrade(l:TLiteLinks):integer;
procedure CloseLinks(l:TLiteLinks);
function isSingleRoot(cls:TOMItems;pos:integer):boolean;
function Before(item1,item2:TOMItem):boolean;
function CheckIn(cls:TOMItems;PosList:TIntList;Cand:integer):boolean;
procedure GroupSelSort(var a:array of integer;b:array of TOMItems;n:integer);
var contextam0:boolean;
implementation
uses sysutils,dialogs,appconst,utils,logs,strUtils;
function hasanylink(items,pitems,lclass:TOMItems;links:TLiteLinks;root:integer;IncludeSubNodes,Direction:Boolean;showmode:integer):boolean;
var i,j:integer;
begin
 result:=true;
 if direction then
 begin
 for i:=1 to links.size do
  if (links[i].lnum=0)or(lclass=nil)or(lclass.canshow(links[i].lnum,(lclass.viewmode)and 7)) then
 begin
 if  ((links[i].intd<>0)and(pitems.canshow(links[i].intd,showmode))) then
  if (links[i].s=items[root].dbid)then
  exit
  else if IncludeSubNodes then
  begin
   j:=links[i].ints;
   while j<>0 do
   begin
    if (j=root) then
    exit;
    j:=items[j].intparent;
   end;
  end;
 end
end
 else
 for i:=1 to links.size do
 if (links[i].lnum=0)or(lclass=nil)or(lclass.canshow(links[i].lnum,lclass.viewmode and 7)) then
 begin
 if  ((links[i].ints<>0)and(pitems.canshow(links[i].ints,showmode))) then
  if (links[i].d=items[root].dbid)then
  exit
  else if IncludeSubNodes then
  begin
   j:=links[i].intd;
   while j<>0 do
   begin
    if (j=root) then
    exit;
    j:=items[j].intparent;
   end;
  end;
 end;
result:=false;
end;

procedure convLinksExpanded(LCN:integer;ls,lr:TLiteLinks;left,right,middle:TOMItems;double:boolean);
var i:integer;
    pos:integer;
    la:TOMLink;
begin
logs.startproc('itUtils','ConvLinksExpanded',inttostr(ls.size),'start',12);
lr.ABCMAp:=ls.ABCMap;
lr.AssignDirs(ls);
double:=double and ls.MirrorEnabled;
//lr.connect(ls.left,ls.right,ls.groups);
//lr.connecttostreams(1,ls.middle,nil);
lr.SETClasses(ls.left,ls.right,ls.Middle);
lr.caption:=ls.caption;
for i:=1 to ls.size do
if (ls[i].ints>0)and(ls[i].intd>0) then
begin
if (ls.prc<>nil)and not applyprocfilter(ls[i].procN,ls[i].procN2,appconst.sysinfo.procfilter,appconst.sysinfo.showprs0,ls.prc) then continue;

 la:=lr.AddLinkObject(ls[i]);
 pos:=ls[i].ints;
 la.procN:=0;
 la.procN2:=0;
 la.ints:=left.getUp(pos);
 pos:=ls[i].intd;
 la.intd:=right.getUp(pos);
 pos:=ls[i].lnum;

 if middle<>nil then
 la.lnum:=middle.getUp(pos)
 else begin la.lnum:=0; end;
 la.s:=0;
 la.d:=0;
 la.ldb:=0;

 la.lcn:=lcn;
 la.flags:=la.flags and $fff;
 if double and(left.dirid=right.dirid)and(ls[i].ints<>ls[i].intd) then
 begin
 la:=lr.AddLinkObject(ls[i]);
 pos:=ls[i].intd;
 la.ints:=left.getUp(pos);
 pos:=ls[i].ints;
 la.intd:=right.getUp(pos);
 pos:=ls[i].lnum;
 if middle<>nil then
 la.lnum:=middle.getUp(pos)
 else begin la.lnum:=0;  end;
 la.s:=0;
 la.d:=0;
 la.ldb:=0;
 la.lcn:=lcn;
 la.flags:=la.flags xor 1;
 la.flags:=la.flags and $fff;
end;
 if double and(middle<>nil)and(left.dirid=middle.dirid)and(ls[i].ints<>ls[i].lnum) then
 begin
 la:=lr.AddLinkObject(ls[i]);
 la.s:=0;
 la.d:=0;
 la.ldb:=0;
 pos:=ls[i].lnum;
 la.ints:=left.getUp(pos);
 pos:=ls[i].intd;
 la.intd:=right.getUp(pos);
 pos:=ls[i].ints;
 la.lnum:=middle.getUp(pos);
 la.s:=0;
 la.d:=0;
 la.ldb:=0;
 la.flags:=la.flags xor 1;
  la.flags:=la.flags and $fff;
 la.lcn:=lcn;
end;
 if double and(middle<>nil)and(middle.dirid=right.dirid)and(ls[i].lnum<>ls[i].intd) then
 begin
 la:=lr.AddLinkObject(ls[i]);
 la.s:=0;
 la.d:=0;
 la.ldb:=0;
 pos:=ls[i].ints;
 la.ints:=left.getUp(pos);
 pos:=ls[i].lnum;
 la.intd:=right.getUp(pos);
 pos:=ls[i].intd;
 la.lnum:=middle.getUp(pos);
 la.s:=0;
 la.d:=0;
 la.ldb:=0;
 la.flags:=la.flags;
  la.flags:=la.flags and $fff;
 la.lcn:=lcn;
end;

end;
lr.DeleteDublicates;
logs.startproc('itUtils','ConvLinksExpanded',inttostr(lr.size),'finish',12);
end;

function RotIndex(left,right:integer;sleft,sright,smiddle:integer):word;
begin
if (left=sleft)and(right=sright) then //$39
    result:=$39
else if (left=sright)and(right=sleft) then //$1b
    result:=$1b
else if (left=sright)and(right=smiddle) then    //$1e
    result:=$1e
else if (left=smiddle)and(right=sleft) then  //$27
    result:=$27
else if (left=smiddle)and(right=sright) then  //$2d
    result:=$2d
else  if (left=sleft)and(right=smiddle) then  //$36
    result:=$36
else result:=0;

end;
function getusingflags(l:TLiteLinks;i:TOMLink;PLeft,PRight:boolean;oleft,oright:boolean;level:integer):DWORD;
const  boolstr:array[boolean] of string=('false','true');
var j:integer;
begin
//showmessage(boolstr[Pleft]+'-'+boolstr[Pright]+'/'+boolstr[oleft]+'-'+boolstr[oright]);
result:=BP_NOTUsed_NOW;
if (oleft)and((i.parentlink<>nil)or(level=0)) then result:=result and not BP_NOTUSED_FROM;
if (oright)and((i.parentlink<>nil)or(level=0)) then result:=result and not BP_NOTUSED_TO;
if not PLeft then result:=result and not BP_NOTUSED_TO;
if not PRight then result:=result and not BP_NOTUSED_FROM;
if i.flags and 1 =1 then
begin
for j:=1 to l.size do
if l[j].parentlink=i then
begin
if (l[j].ints=i.intd)or(l[j].intd=i.intd) then result:=result and not BP_NOTUSED_FROM;
if (l[j].intd=i.ints)or(l[j].ints=i.ints) then result:=result and not BP_NOTUSED_TO;
end;
end
else
begin
for j:=1 to l.size do
if l[j].parentlink=i then
begin
if (l[j].ints=i.ints)or(l[j].intd=i.ints) then result:=result and not BP_NOTUSED_FROM;
if (l[j].intd=i.intd)or(l[j].ints=i.intd) then result:=result and not BP_NOTUSED_TO;
end;
end

end;
function ApplyProcFilter(ProcN,ProcN2,ProcFilter:Integer;use0:boolean;ProcClass:TOMItems):Boolean;
begin
result:=true;
if procclass=nil then exit;
if (procN=0)and(procN2=0)and((use0))or (procfilter=0) then result:=true
else
result:=applyprocfilter1(procN,procfilter,use0,procclass) or applyprocfilter1(procN2,procfilter,use0,procclass);
end;
function ApplyProcFilter1(ProcN,ProcFilter:Integer;use0:boolean;ProcClass:TOMItems):Boolean;
begin
result:=true;
if procclass=nil then exit;
logs.startproc('itUtils','ApplyProcFilter1',inttostr(ProcN)+'/'+inttostr(ProcFilter)+':'+utils.Boolean10[use0],procclass.caption,20);
result:=false;
if (procN=0)and(use0 )or (procfilter=0)then result:=true
else
if {procclass.canshow(procN,appconst.sysinfo.procmode)or}
    (procfilter<>0)and ((procfilter=procN) or procclass.isparent(procfilter,procN) or
                        procclass.isparent(procN,procfilter)and(procN>0)) then
result:=true
{else
result:=procclass.canshow(procN,3)}
end;
procedure ConvFunProcFunSimple(ls,lr:TLiteLinks;LCN:integer;left,proc:TOMItems;PRC:integer);
var i:integer;
    la:TOMLink;
    smode:integer;
begin
logs.startproc('itUtils','ConvProcFunSimple',inttostr(ls.size),'start',12);
lr.clear;
lr.prjtype:=ls.prjtype;
lr.ABCMap:=ls.ABCMap;
lr.assignDirs(ls);
lr.connect(left,left,ls.Groups);
lr.connecttostreams(LCN,ls.middle);
if ls.middle<>nil then smode:=(ls.Middle.viewMode and 7)
                  else smode:=0;
for i:=1 to ls.size do
if (ls[i].flags and lcHideLink=0)then
if (lr.middle=nil)or(ls[i].lnum=0)or lr.middle.canshow(ls[i].lnum,smode) then
if ((ls[i].ints=0)or(ls.Left[ls[i].ints].deleted=0))and((ls[i].intd=0)or(ls.Right[ls[i].intd].deleted=0)) then
begin
if (ls.prc<>nil)and not applyprocfilter(ls[i].procN,ls[i].procN2,PRC,false,ls.prc) then continue;
if ls[i].procN<>ls[i].procN2 then
begin
 if not(ls.PRC.isparent(PRC,ls[i].procN)or
        ls.PRC.isparent(PRC,ls[i].procN2)or
        ls.PRC.isparent(ls[i].procN,PRC)or
        ls.PRC.isparent(ls[i].procN2,PRC)) then continue;
end;
 la:=TOMLink.create(lr);
 la.assign(ls[i]);
 if ls.prc<>nil then
 begin
 if applyprocfilter1(la.procN,PRC,false,ls.PRC) then
  la.procN:=0;
 if applyprocfilter1(la.procN2,PRC,false,ls.PRC) then
  la.procN2:=0;
 end;
   la.s:=0;
  la.d:=0;
 la.lnum:=ls[i].lnum;
 la.abc:=ls[i].abc;
 if la.procN=0 then
 la.ints:=left.GetById(ls[i].ints or (PRC shl 16))
 else
 la.ints:=0;
 if la.procN2=0 then
 la.intd:=left.GetById(ls[i].intd or (PRC shl 16))
 else
 la.intd:=0;
 if (la.ints>0)or(la.intd>0) then
 lr.AddLinkObject(la);
 la.Free;
end;
lr.clearautocreate;
for i:=1 to lr.size do
 if lr[i].flags and 1=0 then lr[i].turn;
lr.deletedublicates;
logs.startproc('itUtils','ConvProcFunSimple',inttostr(lr.size),'finish',12);
end;


procedure ConvFunProcFun(ls,lr:TLiteLinks;LCN:integer;left,proc:TOMItems;TopParent:integer);
var i,j,k:integer;
    la:TOMLink;
    srcproc,dstproc:TIntList;
    upsrc,updst:integer;
    smode:integer;
    PRC:integer;
begin
logs.startproc('itUtils','ConvProcFun',inttostr(ls.size),'start',12);
PRC:=appconst.sysinfo.procFilter;
lr.clear;
lr.prjtype:=ls.prjtype;
lr.ABCMap:=ls.ABCMap;
lr.assignDirs(ls);
lr.connect(left,left,ls.Groups);
srcproc:=TIntList.create;
dstproc:=TIntList.Create;
lr.connecttostreams(LCN,ls.middle);
if ls.middle<>nil then smode:=(ls.Middle.viewMode and 7)
                  else smode:=0;
for i:=1 to ls.size do
if (ls[i].flags and lcHideLink=0) then
if (lr.middle=nil)or(ls[i].lnum=0)or lr.middle.canshow(ls[i].lnum,smode) then
if ((ls[i].ints=0)or(ls.Left[ls[i].ints].deleted=0))and((ls[i].intd=0)or(ls.Right[ls[i].intd].deleted=0)) then
begin
if (ls.prc<>nil)and not applyprocfilter(ls[i].procN,ls[i].procN2,PRC,appconst.sysinfo.showprs0,ls.prc) then continue;
if ls[i].procN<>ls[i].procN2 then
begin
 if not(ls.PRC.isparent(PRC,ls[i].procN)or
        ls.PRC.isparent(PRC,ls[i].procN2)or
        ls.PRC.isparent(ls[i].procN,PRC)or
        ls.PRC.isparent(ls[i].procN2,PRC)) then continue;
end;
 la:=TOMLink.create(lr);
 la.assign(ls[i]);
 if not applyprocfilter1(la.procN,appconst.sysinfo.procfilter,appconst.sysinfo.showprs0,ls.prc) then
 begin
 { pos:=UpToPictogram(ls.left,la.ints,appconst.sysinfo.FunGroupID);
  if (pos>0)and(pos<>ContextGroup) then la.procN:=0;}
 end
 else
 if not applyprocfilter1(la.procN2,appconst.sysinfo.procfilter,appconst.sysinfo.showprs0,ls.prc) then
 begin
  {pos:=UpToPictogram(ls.left,la.intd,appconst.sysinfo.FunGroupID);
  if (pos>0)and(pos<>ContextGroup) then la.procN2:=0;}
 end;

 srcproc.clear;
 dstproc.clear;
 if ls.prc<>nil then
 begin
{ if ls.PRC.isparent(PRC,la.procN) then la.procN:=PRC;
 if ls.PRC.isparent(PRC,la.procN2) then la.procN2:=PRC;}
{if ls.PRC.isparent(la.procN,PRC) then la.procN:=PRC;
 if ls.PRC.isparent(la.procN2,PRC) then la.procN2:=PRC;}
 if ls.prc.isparent(PRC,la.procN)and(la.procN>0) then
 begin
 upsrc:=ls.prc.getup(la.procN);
 getChild(ls.PRC,upsrc,srcProc);
 la.procN:=0
 end
 else
  if ls.prc.isparent(la.procN,PRC)and(la.procN>0) then
 begin
 getChild(ls.PRC,PRC,srcProc);
 la.procN:=0
 end
 else srcproc.add(la.procN);
 if ls.prc.isparent(PRC,la.procN2)and(la.procN2>0) then
 begin
 updst:=ls.prc.getup(la.procN2);
 getChild(ls.PRC,updst,dstProc);
 la.procN2:=0
 end
 else if ls.prc.isparent(la.procN2,PRC)and(la.procN2>0) then
 begin
 getChild(ls.PRC,PRC,dstProc);
 la.procN2:=0
 end
 else dstproc.add(la.procN2);

 end
 else
 begin
 getchild(proc,prc,srcproc);
 getchild(proc,prc,dstproc);
 end;

   la.s:=0;
  la.d:=0;
 if ls.middle<>nil then
 if ls.Middle.viewMode and $100<>0 then
 la.lnum:=ls.middle.getup(ls[i].lnum)
 else
 la.lnum:=ls[i].lnum;
 la.abc:=ls[i].abc;
 if (ls[i].procN<>ls[i].procN2) then
 for j:=0 to srcproc.Count-1 do
 begin

  for k:=0 to dstproc.Count-1 do
  begin
    if ls[i].ints<>0 then
  begin
  if la.procN=0 then
  if ls.Left.isparent(TopParent,ls[i].ints) then
  la.ints:=left.GetById(ls[i].ints or (srcproc[j] shl 16))
  else
  la.ints:=left.GetById(ls[i].ints)
  else
  la.ints:=left.GetById(ls[i].ints or (srcproc[j] shl 16));
  end
  else
  la.ints:=0;
  if ls[i].intd<>0 then
  begin
  if la.procN2=0 then

  if ls.Left.isparent(TopParent,ls[i].intd) then
  la.intd:=left.GetById(ls[i].intd or (dstproc[k] shl 16))
  else
  la.intd:=left.GetById(ls[i].intd)
  else
  la.intd:=left.GetById(ls[i].intd or (dstproc[k] shl 16));
  end
  else
  la.intd:=0;
 if (la.ints>0)then
 begin
 la.procN:=0;
 while (la.ints>0)and(lr.left[la.ints].deleted>0) do la.ints:=lr.left[la.ints].intparent;
 end
 else  la.ints:=0;
 if (la.intd>0)then
 begin
 la.procN2:=0;
 while (la.intd>0)and(lr.left[la.intd].deleted>0) do la.intd:=lr.left[la.intd].intparent;
 end
 else  la.intd:=0;

{ if (la.flags and 3=2)and(la.ProcN=0) then
  la.procN2:=0
  else
 if (la.flags and 3=3)and(la.ProcN2=0) then
  la.procN:=0;}

  //if la.flags and 1 =0 then la.turn;
  if ((la.ints>0)or(la.procN>0))and((la.intd>0)or(la.procN2>0)) then
  lr.AddLinkObject(la);

  end;
 end
else if (ls[i].procN>0) then
begin
for k:=0 to srcproc.Count-1 do
  begin
if ls[i].ints<>0 then
begin
if la.procN=0 then
if ls.Left.isparent(TopParent,ls[i].ints) then
  la.ints:=left.GetById(ls[i].ints or (srcproc[k] shl 16))
  else
  la.ints:=left.GetById(ls[i].ints)
  else
  la.ints:=left.GetById(ls[i].ints or (srcproc[k] shl 16));
end
else
la.ints:=0;
if ls[i].intd<>0 then
begin
  if la.procN2=0 then
  if ls.Left.isparent(TopParent,ls[i].intd) then
  la.intd:=left.GetById(ls[i].intd or (dstproc[k] shl 16))
  else
  la.intd:=left.GetById(ls[i].intd)
  else
  la.intd:=left.GetById(ls[i].intd or (dstproc[k] shl 16));
end
else
la.intd:=0;
 if (la.ints>0)then
 begin
 la.procN:=0;
 while (la.ints>0)and(lr.left[la.ints].deleted>0) do la.ints:=lr.left[la.ints].firstchild;
 end
 else  la.ints:=0;
 if (la.intd>0)then
 begin
 la.procN2:=0;
 while (la.intd>0)and(lr.left[la.intd].deleted>0) do la.intd:=lr.left[la.intd].firstchild;
 end
 else la.intd:=0;

  //if la.flags and 1 =0 then la.turn;
{ if (la.flags and 3=2)and(la.ProcN=0) then
  la.procN2:=0
  else
 if (la.flags and 3=3)and(la.ProcN2=0) then
  la.procN:=0;}
 if ((la.ints>0)or(la.procN>0))or((la.intd>0)or(la.procN2>0)) then
  lr.AddLinkObject(la);

  end;
end
else
  begin
  la.ints:=left.GetById(ls[i].ints or (PRC shl 16));
  la.intd:=left.GetById(ls[i].intd or (PRC shl 16));
 if (la.ints>0)then
 begin
 la.procN:=0;
 while (la.ints>0)and(lr.left[la.ints].deleted>0) do la.ints:=lr.left[la.ints].firstchild;
 end;
 if (la.intd>0)then
 begin
 la.procN2:=0;
 while (la.intd>0)and(lr.left[la.intd].deleted>0) do la.intd:=lr.left[la.intd].firstchild;
 end;
 if (la.flags and 3=2)and(la.ProcN=0) then
  la.procN2:=0
  else
 if (la.flags and 3=3)and(la.ProcN2=0) then
  la.procN:=0;
 if ((la.ints>0)or(la.procN>0))and((la.intd>0)or(la.procN2>0)) then
  lr.AddLinkObject(la);

  end;



 la.Free;

// if (la.ints=0)and not contextam0 then begin la.ints:=left.GetById(la.ProcN); {la.procN:=0;} end;

// if (la.intd=0)and not contextam0 then begin la.intd:=left.GetById(la.ProcN2); {la.procN2:=0;} end;}

end;
lr.clearautocreate;
for i:=1 to lr.size do
begin
 lr[i].s:=0;
 lr[i].d:=0;
 lr[i].procID:=0;
 lr[i].procID2:=0;
 lr[i].ABCID:=0;
 lr[i].ldb:=0;
 if lr[i].flags and 1=0 then lr[i].turn;
end;
lr.deletedublicates;
logs.startproc('itUtils','ConvProcFun',inttostr(lr.size),'finish',12);
end;

procedure convLinksNode(Model:TModelArray;ls,lr,res:TLiteLinks;node:integer);
var i,m:integer;
    la:TOMLink;
    s,d:integer;
begin
logs.startproc('itUtils','ConvLinksNode',inttostr(ls.size),'start',12);
lr.clear;
lr.prjtype:=ls.prjtype;
lr.ABCMap:=ls.ABCMap;
lr.assignDirs(ls);
lr.connect(ls.Left,ls.Right,ls.Groups);
lr.connecttostreams(1,ls.middle);
if ls.size=0 then exit;
for i:=1 to ls.size do
begin
la:=TOMLink.create(lr);
try
la.assign(ls[i]);
 if la.flags and 1=0 then la.turn;
    lr.Left.adjustlevel(la.ints,la.intd,s,d);
    if (la.ints>0)and lr.left.isparent(node,la.ints) then
 begin
  m:=lr.left.getLevel(la.ints,node);
  if (la.ints<>m) and (ls[i].flags and $4000 =$4000) then continue;
  la.ints:=m;
 end
 else
 begin
 la.ints:=s;
 end;
 if (la.intd>0)and lr.left.isparent(node,la.intd) then
 begin
  m:=lr.left.getLevel(la.intd,node);
  if (la.intd<>m)and(ls[i].flags and $4000 =$4000) then continue;
  la.intd:=m;
 end
 else
 begin
 la.intd:=d;
 end;
 la.flags:=la.flags and not $4000;
 lr.AddLinkObject(la);
 finally
 la.free;
 end;
end;
if lr.size=0 then exit;
lr.DeleteDublicates;
 for i:=lr.size downto 1 do
  if lr[i].ints=lr[i].intd then
   lr.DeleteLink(i);
if lr.size=0 then exit;
for i:=lr.size downto 1 do
 if (not lr.left.isparent(node,lr[i].ints) or (node=lr[i].ints))and
    (not lr.left.isparent(node,lr[i].intd)or (node=lr[i].intd)) then
     lr.deletelink(i);
if lr.size=0 then exit;
lr.deletedublicates;
//CompressIndexes(lr);
adjuststreamlevels(Model,lr,node,res,false);
//CompressProps(lr);
prepareNext(lr,node);
logs.startproc('itUtils','ConvLinksNode',inttostr(lr.size),'finish',12);
end;
procedure ConvFunProcFunLSimple(ls,lr:TLiteLinks;left,proc:TOMItems;PRC:integer);
var i:integer;
    la:TOMLink;
begin
logs.startproc('itUtils','ConvFunProcLSimple',inttostr(ls.size),'start',12);
lr.prjtype:=ls.prjtype;
lr.ABCMap:=ls.ABCMap;
lr.assignDirs(ls);
  lr.connect(left,ls.right,ls.Groups);
  lr.connecttostreams(1,ls.middle);
for i:=1 to ls.size do
if (ls[i].flags and lcHideLink=0)then
if (ls[i].ints>0)and(ls[i].intd>0)and(ls.Left[ls[i].ints].deleted=0)and(ls.Right[ls[i].intd].deleted=0) then
begin
if (ls.prc<>nil)and not applyprocfilter1(ls[i].procN,PRC,false,ls.prc) then continue;
   la:=TOMLink.create(lr);
  la.assign(ls[i]);
  la.procN:=0;
  la.intd:=ls[i].intd;
  la.lnum:=lr.Middle.getup(la.lnum);
  la.ints:=lr.Left.GetById(ls[i].ints or (PRC shl 16));
  lr.AddLinkObject(la);
 la.Free;
end;
for i:=1 to lr.size do
if lr[i].ints<=0 then lr[i].isautocreate:=true;
lr.clearautocreate;
lr.deletedublicates;
logs.startproc('itUtils','ConvFunProcLSimple',inttostr(lr.size),'finish',12);
end;

procedure ConvFunProcFunL(ls,lr:TLiteLinks;left,proc:TOMItems);
var i,j:integer;
    la:TOMLink;
    upsrc:integer;
    srcproc:TIntList;
    smode:integer;
    PRC:integer;
function getRight(li:TOMLink):integer;
begin
result:=li.intd;
end;
begin
logs.startproc('itUtils','ConvFunProcL',inttostr(ls.size),'start',12);
lr.prjtype:=ls.prjtype;
PRC:=appconst.sysinfo.procfilter;
srcProc:=TIntList.create;
lr.ABCMap:=ls.ABCMap;
lr.assignDirs(ls);
lr.connect(left,ls.Right,ls.Groups);
smode:=ls.right.viewMode and 7;
if lr.Right<>nil then
for i:=1 to ls.size do
if (ls[i].flags and lcHideLink=0)then
if (ls[i].ints>0)and(ls[i].intd>0)and(ls.Left[ls[i].ints].deleted=0)and(ls.Right[ls[i].intd].deleted=0) then
if lr.right.canshow(getright(ls[i]),smode) then
begin

if (ls.prc<>nil)and not applyprocfilter1(ls[i].procN,PRC,appconst.sysinfo.showprs0,ls.prc) then
begin
continue;
end;
 srcproc.clear;
   la:=TOMLink.create(lr);
  la.assign(ls[i]);
 if (ls.PRC<>nil) then
  if ls.prc.isparent(PRC,ls[i].procN)and(ls[i].procN>0) then
 begin
 upsrc:=ls.prc.getup(ls[i].procN);
 getChild(ls.PRC,upsrc,srcProc);
 la.procN:=0
 end
 else
  if ls.prc.isparent(ls[i].procN,PRC)and(ls[i].procN>0) then
 begin
 getChild(ls.PRC,PRC,srcProc);
 la.procN:=0
 end
 else srcproc.add(ls[i].procN)
 else  begin getchild(proc,prc,srcproc) end;
  la.procN:=0;
  la.intd:=getright(ls[i]);
    if lr.Right.viewMode and $100<>0 then
  la.intd:=lr.right.getup(la.intd);
  la.lnum:=0;
  for j:=0 to srcproc.count-1 do
  begin
  la.ints:=lr.Left.GetById(ls[i].ints or (srcproc[j] shl 16));
 if (la.ints>0)then
 begin
 while (la.ints>0)and(lr.left[la.ints].deleted>0) do la.ints:=lr.left[la.ints].firstchild;
 end
 else continue;

  if (la.ints>0)and(lr.left[la.ints].deleted>0)then
 begin
 la.isautocreate:=true;
 continue;
 end;
 if ((la.ints>0)or(la.procN>0)) then
  lr.AddLinkObject(la);
 end;
 la.Free;
end;
for i:=1 to lr.size do
if lr[i].ints<=0 then lr[i].isautocreate:=true;
srcproc.free;
for i:=1 to lr.size do
begin
lr[i].s:=0;
lr[i].d:=0;
lr[i].procID:=0;
lr[i].procID2:=0;
lr[i].ABCID:=0;
lr[i].ldb:=0;
end;
lr.clearautocreate;
lr.deletedublicates;
logs.startproc('itUtils','ConvFunProcL',inttostr(lr.size),'finish',12);
end;
procedure convLinksNodeL(Model:TModelArray;ls,lr,res:TLiteLinks;node:integer;RaiseLevel:boolean);
var i,m:integer;
    la:TOMLink;
begin
logs.startproc('itUtils','ConvLinksNodeL',inttostr(ls.size),'start',12);
lr.prjtype:=ls.prjtype;
lr.ABCMap:=ls.ABCMap;
lr.assignDirs(ls);
lr.connect(ls.left,ls.Right,ls.Groups);
for i:=1 to ls.size do
begin
la:=TOMLink.create(lr);
try
la.assign(ls[i]);
if lr.left.isparent(node,la.ints) and (node<>la.ints) then
begin
  m:=lr.left.getlevel(la.ints,node);
  if (la.ints<>m)and (ls[i].flags and $4000 =$4000) then continue;
  la.ints:=m;
  la.flags:=la.flags and not $4000;
 if ((la.ints>0)or(la.procN>0)) then
  lr.AddLinkObject(la);
end;
finally
 la.Free;
end;
end;
for i:=1 to lr.size do
if lr[i].ints<=0 then lr[i].isautocreate:=true;
lr.clearautocreate;
lr.deletedublicates;
{CompressProps(lr);
CompressIndexes(lr);}
adjuststreamlevels(Model,lr,node,res,false);
logs.startproc('itUtils','ConvLinksNodeL',inttostr(ls.size),'finish',12);
end;
procedure GetBPSides(prType:TPrjType;globalLeft,globalRight:boolean;flags:integer;var lts,ltd:TLinkType);
begin
if globalLeft then
case prType of
ptLRN:lts:=lt_Right;
ptIOC:case flags and 3 of
      0,1:lts:=lt_Right;
      2,3:lts:=lt_Top;
      end;
ptM:lts:=lt_Top;
ptC:lts:=lt_Bottom;
ptIOM:case flags and 3 of
      0,1:lts:=lt_Right;
      2,3:lts:=lt_Bottom;
      end;
end
else
lts:=lt_Right;
if not globalright then
case prType of
ptLRN:ltd:=lt_Left;
ptIOC:case flags and 3 of
      0,1:ltd:=lt_Left;
      2,3:ltd:=lt_Top;
      end;
ptM:ltd:=lt_Top;
ptC:ltd:=lt_Bottom;
ptIOM:case flags and 3 of
      0,1:ltd:=lt_Left;
      2,3:ltd:=lt_Bottom;
      end;
end
else
ltd:=lt_Left;

end;
procedure prepareNext(l:TLiteLinks;node:integer);
var i,j:integer;
begin
logs.startproc('itUtils','PrepareNext',inttostr(l.size),'',18);
for i:=1 to l.size do
begin
l[i].next:=nil;
 for j:=i+1 to l.size do
  if ((l[i].ints=l[j].ints)and(l[i].procN=l[j].procN)
  {or(appconst.sysinfo.groupmode=1)})and
     ((l[i].intd=l[j].intd)and(l[i].procN2=l[j].procN2))and
     (l[i].lcn=l[j].lcn)and
     (l[i].lnum=l[j].lnum)and
     (l[i].flags and $7=l[j].flags and $7)and(l[i].abc=l[j].ABC) then
  begin
  l[i].next:=l[j];
  break;
  end;
end;
end;

procedure fillcomboAll(tree:TTreeView;combo:TCombobox;c:TOMItems);
var i:integer;
begin
combo.Items.Clear;
for i:=0 to tree.Items.Count-1 do
 if tree.Items[i].IsVisible then
 begin
    combo.items.addObject(stringofChar('-',tree.items[i].Level)+tree.items[i].text,tree.items[i].data);
 end;
combo.ItemIndex:=0;
end;

procedure FillCombo(tree:TTreeNode;combo:TCombobox;c:TOMItems);

procedure fillcombolevel(node:TTreeNode);
var i:integer;

begin
if node.Expanded then
 for i:=0 to node.count-1 do
 begin
   combo.items.addObject(stringofChar('-',node.item[i].Level-tree.level)+node.item[i].text,node.item[i].data);
   if node.item[i].HasChildren then fillcomboLevel(node.item[i]);
 end;

end;
begin
 combo.items.clear;
 if tree=nil then exit;
 combo.items.addObject(tree.text,tree.data);
 fillcombolevel(tree);
 combo.ItemIndex:=0;
end;
function setRWpro(l:TLiteLinks;left:TOMItems):boolean;
begin
result:=false;
 if l.left=left then
    if l.right.clsflags and 2=2 then result:=true
    else if (l.middle<>nil)and(l.middle.clsflags and 2=2) then begin l.MR; result:=true;end
         else result:=true
 else if l.right=left then begin l.inverse; result:=setRWpro(l,left);end
 else if l.middle=left then begin l.RL; result:=setRWpro(l,left);end;
end;
procedure level(c:TOMItems);
procedure fixparent(c:TOMItems;r,p:integer);
var i:integer;
begin
i:=r;
while i>0 do
begin
c[i].intparent:=p;
if c[i].firstchild>0 then fixparent(c,c[i].firstchild,i);
i:=c[i].nextitem;
end;
end;
function levelstep(c:TOMItems;r:integer):integer;
var cnt,i,fc,p,n:integer;
begin
 i:=r;
 cnt:=0;
 while i>0 do
 begin
  if c[i].deleted=0 then
  begin
  inc(cnt);
  if c[i].firstchild>0 then
  begin
  fc:=levelstep(c,c[i].firstchild);
  if (fc<>i){and(c[fc].itype=0)} then
  begin
  n:=c[i].nextitem;
  p:=c[i].intparent;
  c.cutfromlist(i);
  c.insertitem(fc,p,n);
  c[fc].interval:=c[i].interval;
  c[i].deleted:=1;
  //c[fc].expanded:=c[i].expanded;
  if i=r then r:=fc;
  i:=fc;
  end;
  end;
  end;
  i:=c[i].nextitem;
 end;
if (cnt=1) then
result:=r
else
result:=c[r].intparent;
end;
begin
levelstep(c,c.root);
fixparent(c,c.root,0);
setLevel(c,c.root,0);
//c.root:=i;
end;
function FilterWithProTotal(procfilter:integer; proclass,fclass:TOMItems;pdistr:TLiteLinks):integer;
var i,j,pos1:integer;
    np:integer;
procedure setchildWP(root,w:integer);
var i:integer;
begin
 i:=root;
 while i>0 do
 begin
 fclass[i].WParam:=w;
 setChildWP(fclass[i].firstchild,w);
 i:=fclass[i].nextitem;
 end;
end;
begin
 result:=0;
 if fclass=nil then exit;
 result:=fclass.count;
 if proclass=nil then exit;
 if (pdistr=nil)or(procfilter=0) then
 begin
  for i:=1 to fclass.count do fclass[i].WParam:=1;
  exit;
 end;
 logs.startproc('itUtils','FilterWithProTotal',inttostr(pdistr.size),'',18);
 pdistr.setstate($39);
 if pdistr.Right.diriD=proclass.dirid then
 pdistr.inverse
 else
 if (pdistr.Left.diriD<>fclass.diriD)and(pdistr.Middle<>nil) and (pdistr.Middle.dirid=proclass.dirid) then
 pdistr.ML;
 pdistr.sort(lsFull);
 try
  for i:=1 to fclass.count do fclass[i].WParam:=0;
  result:=0;
  for i:=1 to pdistr.size do
  begin
  pos1:=pdistr[i].ints;
   if not pdistr[i].isautocreate and(pos1>0)and(pdistr[i].intd>0)
    and((procfilter = pdistr[i].ints)or
      proclass.isparent(procfilter,pos1) or
      proclass.isparent(pos1,procfilter)) then
      begin
      j:=pdistr[i].intd;
      if (pdistr[i].lnum=0) then
      np:=1
      else
      np:=-pdistr[i].lnum;
      SetChildWP(fclass[j].firstchild,np);
      fclass[j].WParam:=np;
      inc(result);
      while j>0 do
      begin
       if fclass[j].WParam<np then
          fclass[j].WParam:=np;
        j:=fclass[j].intparent;
      end;
      end;
     end;
 finally
 pdistr.inverse;
 pdistr.sort(lsFull);
 end;
end;
function FilterWithPro(lcand,procfilter:integer; proclass,fclass:TOMItems;pdistr:TLiteLinks):integer;
var i:integer;
    hasany:boolean;
    res:integer;
begin
result:=1;
//exit;
if lcand=0 then exit;
if procfilter=0 then exit;
if (pdistr=nil)or(fclass<>pdistr.left)or(proclass.dirid<>pdistr.Right.dirid) then exit;
hasany:=true;
res:=0;
for i:=1 to pdistr.size do
if (pdistr[i].intd>0)and(pdistr[i].intd>0)and
  ((procfilter=pdistr[i].intd)or
   proclass.isparent(procfilter,pdistr[i].intd) Or
   proclass.isparent(pdistr[i].intd,procfilter))then
begin
hasany:=true;
if fclass.isparent(pdistr[i].ints,lcand) then
  begin result:=1; exit;end
else if fclass.isparent(lcand,pdistr[i].ints) then
begin
res:=1;
end;
end;
if hasany then result:=res;
end;
function getToplevel(Model:TModelArray;cls:TOMItems;pos:integer):integer;
begin
 result:=((cls.viewMode) shr 3)and($1F);
end;

procedure AdjustStreamLevelsCM(Model:TModelArray;lr:TLiteLinks;node:integer;res:TLiteLinks;compressLeaves:boolean);
var
    i,j,k,m,l:integer;
    mName,lName:integer;
    roots,flags,nroots:TIntList;
    curindex:integer;
    ismultiabc:boolean;
    GroupABC:integer;
    isMI:TIntList;

begin
 logs.startproc('itUtils','AdjustStreamLevelsCM',inttostr(lr.size),'start',15);
lr.sort(lsDirections);
roots:=TIntList.create;
nroots:=TIntList.Create;
flags:=TIntList.create;
isMI:=TIntList.Create;
try
curindex:=0;
if node>0 then i:=lr.left[node].firstchild
          else i:=lr.left.root;
while i>0 do
begin
if (lr.Left[i].expanded and not lr.left[i].isleaf)or compressLeaves then
begin
m:=-1;
roots.Clear;
flags.clear;
nroots.Clear;
ismi.Clear;
lName:=0;
 for j:=1 to lr.size do
 if (lr[j].ints=i)and(lr[j].flags and (lcNoneGroup or lcTonnel)=0) then
 begin

  if m=-1 then
  begin
  m:=lr[j].intd;
  curindex:=lr[j].ABC;
  mName:=lr[j].lnum;
  groupabc:=curindex;
  isMultiABC:=false;
   end
         else
         begin
          l:=lr.Right.getCommonParent(m,lr[j].intd);
          if lr.Middle<>nil then
          lName:=lr.Middle.getCommonParent(mName,lr[j].lnum);
          if (l<>0)and(lr.Right[l].level>=getTopLevel(Model,lr.Right,m))and
          ((lr.Middle=nil)or(lName<>0)and(lr.Middle[lname].level>=getTopLevel(Model,lr.Middle,mName)))
           then
           begin
            m:=l;
            mName:=lName;
            isMultiABC:=isMultiABC or (groupABC<>lr[j].ABC);
           end
          else
          begin
          roots.add(m);
          nroots.add(mName);
          flags.add(curindex);
          m:=lr[j].intd;
          curindex:=lr[j].ABC;
          groupABC:=curindex;
          ismi.add(integer(isMultiabc));
          isMultiABC:=false;
          end;
         end
 end;
 roots.add(m);
 nroots.add(mName);
 flags.add(curindex);
 ismi.add(integer(isMultiabc));

 for j:=1 to lr.size do
  if (lr[j].ints=i)and(lr[j].flags and (lcNoneGroup or lcTonnel)=0) then
  begin
   for k:=0 to roots.count-1 do
    if lr.right.isparent(roots[k],lr[j].intd)and
       ((lr.Middle=nil)or lr.Middle.isparent(nroots[k],lr[j].lnum)) then
    begin
   if (lr[j].intd<>integer(roots[k]))or(lr[j].lnum<>integer(nroots[k])) then
   begin
      lr[j].flags:=lr[j].flags and 7;
   end;
  lr[j].intd:=integer(roots[k]);
  lr[j].lnum:=integer(nroots[k]);
  if Boolean(isMI[k]) then lr[j].ABC:=0;
  break;
  end;
  end;
  lr.deletedublicates;
  lr.sort(lsAdjustStreams);
end;
i:=lr.Left[i].nextitem;
end;
for j:=1 to lr.size do
lr[j].flags:=lr[j].flags and 7;
lr.DeleteDublicates;
if res<>nil then
for i:=1 to lr.size do
   res.AddLink(0,0,lr[i].ints,lr[i].intd,lr[i].lnum,0,1,0,0);
if res<>nil then
  res.DeleteDublicates;
finally
ismi.free;
roots.free;
nroots.free;
flags.free;
end;
 logs.startproc('itUtils','AdjustStreamLevelsCM',inttostr(lr.size),'finish',15);
end;
procedure AdjustStreamLevelsIO(Model:TModelArray;lr:TLiteLinks;node:integer;res:TLiteLinks;compressLeaves:boolean);
var
    i,j,k,m,l:integer;
    groupabc:integer;
    roots,flags,isMI:TIntList;
    leftpos,rightpos:integer;
    curindex,nextindex:integer;
    LRGroup:TList;
    indexswitch,ismultiabc:boolean;
    fitem:TOMLink;
    singleName:boolean;
    Done,UnDone:TList;
    curlink,curlink2:TOMLink;
    found:boolean;
begin
 logs.startproc('itUtils','AdjustStreamLevelsIO',inttostr(lr.size),'start',15);
roots:=TIntlist.create;
flags:=TIntList.create;
isMI:=TIntList.Create;
LRGroup:=TList.Create;
Done:=TList.Create;
UnDone:=TList.Create;
try
lr.sort(lsFull);
for i:=1 to lr.size do
if (lr[i].lnum=0)or(lr[i].s<>0)or
   (lr[i].flags and lcTonnel<>0)or
   (lr[i].flags and lcNoneGroup<>0) then
Done.add(lr[i])
else
UnDone.add(lr[i]);
for i:=UnDone.Count-1 downto 0 do
begin
curlink:=TOMLink(Undone[i]);
found:=false;
leftpos:=curLink.ints;
rightpos:=curLink.intd;
if ((curLink.procN>0)or(leftpos<=0)or compressLeaves or (lr.Left[leftpos].dbid and $FFFF0000=0)or lr.Left[leftpos].expanded and not lr.left[leftpos].isleaf)and
    ((curLink.procN2>0)or(rightpos<=0)or compressLeaves or(lr.Left[rightpos].dbid and $FFFF0000=0)or  lr.Left[rightpos].expanded and not lr.left[rightpos].isleaf) then
for j:=Done.Count-1 downto 0 do
begin
curlink2:=TOMLink(Done[j]);
if (curlink2.ints=curlink.ints)and
   (curlink2.intd=curlink.intd)and
   lr.Middle.isparent(curlink2.lnum,curlink.lnum)and
   (curlink2.procN=curlink.procN)and
   (curlink2.procN2=curlink.procN2)and
   (curlink2.ABC=curlink.ABC)and
   (curlink2.flags and 7=curlink.flags and 7) then
   begin
   found:=true;
   curlink.lnum:=curlink2.lnum;
   break;
   end;
if found then
begin
 Done.add(curlink);
 UnDone.Delete(i);
end;
end;
end;
 for i:=0 to UnDone.Count-1 do
 begin
 curLink:=TOMLink(UnDone[i]);
 leftpos:=curLink.ints;
 rightpos:=curLink.intd;
 if (curLink.lnum>0)and(curLink.s=0)and
  ((curLink.procN>0)or(leftpos<=0)or compressLeaves or (lr.Left[leftpos].dbid and $FFFF0000=0)or lr.Left[leftpos].expanded and not lr.left[leftpos].isleaf)and
    ((curLink.procN2>0)or(rightpos<=0)or compressLeaves or(lr.Left[rightpos].dbid and $FFFF0000=0)or  lr.Left[rightpos].expanded and not lr.left[rightpos].isleaf) then
 begin
 lrgroup.clear;
  roots.clear;
 flags.clear;
 ismi.clear;
 singleName:=(lcNoneGroup and curLink.flags)=lcNoneGroup;

 lrgroup.add(curLink);
 curLink.s:=-1;
  curindex:=(curLink.flags and 7);
 for j:=i+1 to UnDone.Count-1 do
 begin
 curlink2:=TOMLink(Undone[j]);
  if (curlink2.s=0)and (not singlename) and
  (curlink2.ints=leftpos)and(curlink2.procN=curlink.procN)and
  (curlink2.intd=rightpos)and(curlink2.procN2=curlink.procN2)and
  (curlink2.flags and 7 =curlink.flags and 7) then
 begin
 lrgroup.add(curlink2);
 curlink2.S:=-1;
 end;
 end;
  lrgroup.sort(items.DirCompare);
  ismultiabc:=false;
  m:=TOMLink(lrgroup[0]).lnum;
  groupabc:=TOMLink(lrgroup[0]).ABC;

  for j:=0 to lrgroup.count-1 do
  begin
  fitem:=TOMLink(lrgroup[j]);

          l:=lr.Middle.getCommonParent(m,fitem.lnum);
          if (l<>0)and(lr.middle[l].level>=getTopLevel(Model,lr.Middle,m))
               then begin m:=l;
                    ismultiabc:=ismultiabc or (groupabc<>fitem.ABC);
                     end
          else begin
          roots.add(m);
          flags.add(curindex);
          ismi.add(integer(ismultiabc));
          m:=fitem.lnum;
          groupabc:=fitem.ABC;
          ismultiabc:=false;
          end;
   end;
   roots.add(m);
   flags.add(curindex);
   ismultiabc:=ismultiabc or (groupabc<>fitem.ABC);
   ismi.add(integer(ismultiabc));
   for j:=0 to lrgroup.count-1 do
   begin
   fitem:=TOMLink(lrgroup[j]);
    for k:=0 to roots.count-1 do
     if lr.Middle.isparent(integer(roots[k]),fitem.lnum)and(fitem.flags and 7 =flags[k] and 7) then
     begin
      if fitem.lnum<>integer(roots[k]) then
      begin
      fitem.flags:=fitem.flags and 7;
      //if boolean(ismi[k]) and (appconst.sysinfo.groupmode=0) then fitem.ABC:=0;
      end;
      if boolean(ismi[k]){ and (appconst.sysinfo.groupmode=0)} then fitem.ABC:=0;
      fitem.lnum:=integer(roots[k]);
      fitem.s:=-1;break;
     end;
  end
  end;
  //lr[i].flags:=lr[i].flags and 7;
 end;
finally
 roots.free;
 flags.free;
 ismi.Free;
 lrgroup.free;
 Done.free;
 UnDone.free;
end;
lr.DeleteDublicates;
if res<>nil then
for i:=1 to lr.size do
with
res.AddLink(0,0,lr[i].ints,lr[i].intd,lr[i].lnum,1,1,lr[i].flags and 3,lr[i].ABC) do
begin
ABC:=lr[i].ABC;
procN:=lr[i].procN;
procN2:=lr[i].procN2;
end;
if res<>nil then
res.deletedublicates;
 logs.startproc('itUtils','AdjustStreamLevelsIO',inttostr(lr.size),'finish',15);
end;
procedure AdjustStreamLevels(Model:TModelArray;lr:TLiteLinks;node:integer;res:TLiteLinks;compressLeaves:boolean);
begin
if res=nil then exit;
CloseLinks(lr);
lr.sort(lsAdjustStreams);
if lr.prjType in [PtC,ptM] then
begin
 AdjustStreamLevelsCM(Model,lr,node,res,compressLeaves);
end
else
//------------------------------------------lr.middle
if (lr.prjType in [ptIOC,ptIOM,ptLRN])and(lr.Middle<>nil) then
begin
AdjustStreamLevelsIO(Model,lr,node,res,compressLeaves);
end;

lr.deletedublicates;

end;
procedure getChild(src:TOMItems;id:integer;list:TIntList);
var i:integer;
begin
if id=0 then exit;
 if src[id].isleaf or not src[id].expanded then
  list.add(id)
 else
 begin
  i:=src[id].firstchild;
  while i>0 do
  begin
  if src[i].deleted=0 then
  getchild(src,i,list);
  i:=src[i].nextitem;
  end;
 end;

end;
procedure applyFuncFilter(Groups:TLiteLinks;procfilter:integer;ProcClass:TOMItems;grid:TColoredGrid);
var i,j:integer;
    total:boolean;
begin
if procfilter=0 then exit;
if groups.Left.diriD<>grid.insource.diriD then exit;
logs.startproc('itutils','applyfuncfilter',grid.insource.caption,inttostr(groups.size)+':'+inttostr(grid.insource.Count)+':'+inttostr(procfilter),12);
for i:=1 to procclass.Count do procclass[i].WParam:=0;
for i:=1 to groups.size do
//  if procClass.isparent(procfilter,groups[i].intd) then
   procClass[groups[i].intd].WParam:=1;
if procclass[procfilter].WParam=0 then
begin
total:=true;
for i:=1 to procclass.count do
if procclass.isparent(procfilter,i) then
if (procclass[i].WParam=1) then total:=false
else if procclass[i].isleaf  then
begin
j:=i;
while (j<>0)and(procclass[j].WParam=0) do j:=procclass[j].intparent;
if j<>0 then begin total:=false; break; end;
end;
end
else total:=false;
if not total then
begin
for i:=1 to grid.insource.Count do grid.Filtered[i]:=false;
for i:=1 to groups.size do
  if procClass.isparent(procfilter,groups[i].intd)or
     procClass.isparent(groups[i].intd,procfilter)then
  begin
   grid.FilterPosition(groups[i].ints);
   j:=grid.insource[groups[i].ints].intparent;
   while j>0 do
   begin
   grid.filtered[j]:=true;
   j:=grid.insource[j].intparent;
   end;
  end
end;

end;
function getDirHeader(prj:TLiteLinks;flag:integer):string;
begin
case prj.prjType of
ptLRN: case flag and 3 of
        0: result:=prj.dirmap[1];
        1: result:=prj.dirmap[2];
        2,3:result:=prj.dirmap[3];
        end;
ptIOC: case flag and 3 of
        0: result:='';
        1,3: result:='';
        2:result:='';
        end;
ptM :result:='';
ptC :result:='';
ptIOM: case flag and 3 of
        0: result:='';
        1,3: result:='';
        2:result:='';
        end;
end;
end;
procedure DeleteUnused(tree:TTreeView;bp:TOMItems;group:TLiteLinks;usesubs:boolean);
var i:integer;
    cnode:TTreeNode;

procedure SetOverlay(node:TTreeNode);
var i:integer;
begin
if node=nil then exit;
 for i:=0 to node.Count-1 do
 begin
  node.Item[i].OverlayIndex:=1;
  setOverLay(node.Item[i]);
 end;
end;
begin
 if group=nil then exit;
 if group.Right.dirid<>bp.diriD then
 group.inverse;
 for i:=0 to tree.Items.Count-1 do
  tree.items[i].OverlayIndex:=-1;
 for i:=1 to group.size do
 if group[i].intd>0 then
 begin
   cnode:=bp[group[i].intd].samenode;
   if usesubs then
  setoverlay(cnode);
 { cnode.OverlayIndex:=1;
  if usesubs then}
  while cnode<>nil do
  begin
   cnode.OverlayIndex:=1;
   cnode:=cnode.Parent;
  end;

 end;
 Tree.Items[0].OverlayIndex:=1;
 for i:= tree.Items.Count-1 downto 0 do
 if   tree.items[i].OverlayIndex=-1 then tree.Items[i].Delete
 else tree.items[i].OverlayIndex:=-1;
end;
function EncodePropsAndIndexes(li:TOMLink;lo:TLiteLinks):string;
var props,indexes:TStringList;
    nextlink,nlp:TOMLink;
    has0props,has0indexes:boolean;
    k:integer;
begin
props:=TStringList.create;
indexes:=TStringList.create;
result:='';
try
 props.clear;
 indexes.Clear;
 has0props:=false;
 nextLink:=li;
 has0indexes:=false;
 repeat
 if (nextlink.abc=0) then has0indexes:=true;
 if (nextLink.abc >0)and(indexes.IndexOfObject(lo.abcMap[nextLink.ABC])=-1) then indexes.addObject(lo.abcMAp[nextLink.ABC].s,lo.abcMAp[nextLink.ABC]);
 nextlink:=nextlink.next;
 until nextLink=nil;
 if props.count>0 then
 begin
 if has0props then result:=result+'[*, '+props[0]
 else
 result:=result+'['+props[0];
 for k:=1 to props.Count-1 do result:=result+', '+props[k];
 result:=result+']';
 end;
 if indexes.count>0 then
 begin
 if has0indexes then
  result:=result+'<*, '+indexes[0]
  else
 result:=result+'<'+indexes[0];
 for k:=1 to indexes.Count-1 do result:=result+', '+indexes[k];
 result:=result+'>';
 end;

 nextlink:=li.next;
 while nextLink<>nil do
 begin
 nlp:=nextLink;
 nextLink:=nextLink.next;
 nlp.lnum:=0;
 nlp.flags:=nlp.flags and 7;
if ((nlp.ints=li.ints)and(nlp.ints<>0)or(nlp.ints=li.ints)and(nlp.procN=li.procN))and
   ((nlp.intd=li.intd)and(nlp.intd<>0)or(nlp.intd=li.intd)and(nlp.ProcN2=li.procN2)) then
 begin
 nlp.ints:=0;
 nlp.intd:=0;
 end; end;
 li.next:=nil;
finally
 props.free;
 indexes.free;
end;
end;
procedure RebulidStructure(cls:TOMItems);
var temp:TOMItems;
begin
if cls.count=0 then exit;
{$IFDEF ED}
temp:=TOMItems.Create(true);
{$ELSE}
temp:=TOMItems.Create;
{$ENDIF}
try
 temp.AssignProperties(cls);
 cls.saveto(temp);
 cls.assignTotal(temp);
finally
temp.Free;
end;
end;
function InterSect(l1,l2:TList):boolean;
var i:integer;
begin
 result:=false;
 for i:=0 to l1.Count-1 do
  if l2.IndexOf(l1[i])>=0 then
  begin
   result:=true;
   exit;
  end;
end;
procedure SelectByBPTotal(src,dst,bpclass:TOMItems;grouplinks:TLiteLinks;root,p,pf:integer;incdeleted:boolean;mode:byte);
type TCheckRec=Record
                id,jumpto:integer;
               end;
     PCheckRec=^TCheckRec;

var toCheck:TList;
procedure SelectByBP(src,dst,bpclass:TOMItems;grouplinks:TLiteLinks;root,p,PNEXT,pf:integer;incdeleted,rootonly:boolean;mode:byte);forward;
procedure AddtoCheck(ID:integer;IA:integer);
var p:PCheckRec;
begin
 new(p);
 p^.id:=id;
 p^.jumpto:=IA;
 tocheck.add(p);
end;
procedure ProcessChecked(lookfor:integer;newp,newnext:integer);
var i:integer;
begin
 for i:=0 to tocheck.Count-1 do
  if PCheckRec(tocheck[i])^.id=lookfor then
  begin
  SelectByBP(src,dst,bpclass,grouplinks,PCheckRec(tocheck[i])^.jumpto,newP,newNext, PF,incdeleted,true,mode);
//  tocheck.delete(i);
  exit;
  end;
end;
procedure SelectByBP;
label skipnode;
var i,pos,j:integer;
    np:smallint;
    trans,transP,transN:integer;
    doshow:boolean;
    RealP:integer;
begin
 i:=root;

 while i>0 do
 begin
 doshow:=false;
 if ((src[i].deleted=0)or(incdeleted)) then
  begin
 np:=src[i].WParam;//itutils.FilterWithPro(i,pf,bpclass,src,grouplinks);
 if (np<>0)and  src.canshow(i,mode) then
 begin
 if np>0 then
 begin
 doshow:=true;
 pos:=dst.ADDChildItem(p,'').pos;
 dst[pos].assignData(src[i]);
 dst[pos].WParam:=np;
 dst[pos].dbID:=src[i].dbID;
 realP:=p;
 j:=pos;
 while (dst[j].previtem>0)and(dst[dst[j].previtem].wparam<np) do j:=dst[j].previtem;
 if j<>pos then
 begin
 dst.cutfromlist(pos);
 dst.insertitem(pos,p,j);
 end;
 end
 else if np<0 then
 begin
 trans:=0;
 for trans:=dst.count downto 1 do
 if dst[trans].idloaded=-np then break;
 if trans=0 then
 begin
  AddToCheck(-np,i);
  goto SkipNode;
 end;
 doshow:=true;
 transP:=dst[trans].intparent;
 realP:=transP;
 transN:=dst[trans].nextitem;
 pos:=dst.addChildItem(transP,'').pos;
 dst[pos].assigndata(src[i]);
 dst[pos].dbID:=src[i].dbid;
 if transN<>0 then
 begin
 dst.cutfromlist(pos);
 dst.insertitem(pos,Transp,TransN);
 end;
 dst[pos].WParam:=dst[trans].WParam;
 end;
 dst[pos].idloaded:=i;
 end
 else
 pos:=p;
if doshow and rootonly and (pNext>0) then
begin
 dst.cutfromlist(pos);
 dst.insertitem(pos,realP,pNext);
end;
skipnode: selectbybp(src,dst,bpclass,grouplinks,src[i].firstchild,pos,0,pf,incdeleted,false,mode);
if doshow then
processChecked(i,realp,dst[pos].nextitem);
 end;
 if not rootonly then
  i:=src[i].nextitem
  else
  i:=0;
end;
end;
var i:integer;
begin
tocheck:=TList.create;
try
SelectByBP(src,dst,bpclass,grouplinks,root,p,0,pf,incdeleted,false,mode);
for i:=1 to dst.count do
 if dst[i].idloaded>0 then dst[i].assignData(src[dst[i].idloaded]);
finally
for i:=0 to  tocheck.count-1 do
 dispose(PCheckRec(tocheck[i]));
tocheck.free;
end;
end;
procedure setWParamUsed(bpclass:TOMItems;bpfilter:TLiteLinks);
var i,j:integer;
procedure setwpc(id:integer);
var i:integer;
begin
 i:=id;
 while i>0 do
 begin
 bpclass[i].WParam:=1;
 setwpc(bpclass[i].firstchild);
 i:=bpclass[i].nextitem;
 end;
end;
begin
if bpclass=nil then exit;
for i:=1 to bpclass.count do   bpclass[i].WParam:=1;
if bpfilter=nil then exit;
if bpfilter.size=0 then exit;
//bpfilter.connect(nil,bpclass,nil);
for i:=1 to bpclass.count do
       bpclass[i].WParam:=0;
for i:=1 to bpfilter.size do
        begin
        j:=bpfilter[i].intd;
        while j>0 do
         begin
         bpclass[j].WParam:=1;
         j:=bpclass[j].intparent;
         end;
        j:=bpfilter[i].intd;
        if j>0 then
        setwpc(bpclass[j].firstchild);
        end;
end;
procedure CompressIndexes(lr:TLiteLinks);
var i,j:integer;
    found:boolean;
begin
 if lr.Left=lr.Right then
 begin
  for i:=1 to lr.size-1 do
   if ((lr[i].ints<=0)or(lr.left[lr[i].ints].firstchild>0))and
      ((lr[i].intd<=0)or(lr.right[lr[i].intd].firstchild>0)) then
      begin
      found:=false;
       for j:=i+1 to lr.size do
        if (lr[j].ints=lr[i].ints)and
           (lr[j].intd=lr[i].intd)and
           (lr[j].ProcN=lr[i].ProcN)and
           (lr[j].ProcN2=lr[i].ProcN2)and
           (lr[j].lnum=lr[i].lnum)and
           (lr[j].ABC<>lr[i].ABC) then
           begin
           lr[j].flags:=lr[j].flags and $F007;
           found:=true;
           end;
        if found then lr[i].flags:=lr[i].flags and $F007;
      end;
 end;
{else
begin
  for i:=1 to lr.size-1 do
   if ((lr[i].ints=0)or(lr.left[lr[i].ints].firstchild>0)) then
      begin
      found:=false;
       for j:=i+1 to lr.size do
        if (lr[j].ints=lr[i].ints)and
           (lr[j].intd=lr[i].intd)and
           (lr[j].ProcN=lr[i].ProcN)and
           (lr[j].ProcN2=lr[i].ProcN2)and
           (lr[j].lnum=lr[i].lnum)and
           (lr[j].flags=lr[i].flags)and
           (lr[j].lnum2<>lr[i].lnum2) then
           begin
           lr[j].lnum2:=0;
           found:=true;
           end;
        if found then lr[i].lnum2:=0;
      end;
 end;}
 lr.DeleteDublicates;
end;
function isFEO(lcand,PROC:integer;fclass,bpclass:TOMItems;la:Array of TLiteLinks;count:integer;grouplinks:TLiteLinks):boolean;
var i,j:integer;
    l:TLiteLinks;
begin
result:=true;
for i:=0 to count-1 do
if (la[i]<>nil)and(la[i]<>grouplinks) then
 begin
  l:=la[i];
  for j:=1 to l.size do
  begin
   if (l.Left=fclass)and
   ((l[j].procN=PROC)or
    bpclass.isparent(l[j].procN,PROC)or
    bpclass.isparent(PROC,l[j].procN)) and
   (l[j].ints>0)and(lcand<>l[j].ints)and fclass.isparent(lcand,l[j].ints) then
   begin
    result:=false;
    exit;
   end;
   if (l.Right=fclass)and
    ((l[j].procN2=PROC)or
    bpclass.isparent(l[j].procN2,PROC)or
    bpclass.isparent(PROC,l[j].procN2))
    and(l[j].intd>0)and(lcand<>l[j].intd)and fclass.isparent(lcand,l[j].intd) then
   begin
    result:=false;
    exit;
   end;
   if (l.Middle=fclass)and
    ((l[j].procN=PROC)or
    bpclass.isparent(l[j].procN,PROC)or
    bpclass.isparent(PROC,l[j].procN))
    and(l[j].lnum>0)and(lcand<>l[j].lnum)and fclass.isparent(lcand,l[j].lnum) then
   begin
    result:=false;
    exit;
   end;
  end;
 end;
end;
procedure ClearWP(cls:TOMItems);
var i:integer;
begin
 for i:=1 to cls.Count do cls[i].WParam:=0;
end;
procedure CopyParams(ToCls,Fromcls:TOMItems);
begin
 if tocls=fromcls then exit;
 tocls.caption:=fromcls.caption;
end;
procedure incWP(Cls:TOMItems;root:integer;delta:integer);
var i:integer;
begin
if root=0 then exit;
cls[root].WParam:=cls[root].wparam+delta;
i:=cls[root].firstchild;
while i>0 do
begin
 incWP(cls,i,delta);
end;
end;
procedure GetPairs(ls:TLiteLinks;cls:TOMItems;res:TList);
var i:integer;
    Pro2L,Pro2R,Pro2M,Pro2P,Pro2I:TLiteLinks;
function CheckID(cls1,cls2:TOMItems):boolean;
begin
result:=(cls1<>nil)and(cls2<>nil)and(cls1.diriD=cls2.diriD);
end;
procedure AppendLink(l:TLiteLinks;ints,intd:integer);
begin
 if l=nil then exit;
 if (ints<=0)or(intd<=0) then exit;
 l.AddLink(0,0,ints,intd,ls.proid,1,1,3,0);
end;
function GetPro(clsto:TOMItems):TLiteLinks;
var i:integer;
    l:TLiteLinks;
begin
result:=nil;
if clsto=nil then exit;
 for i:=0 to res.Count-1 do
  begin
   l:=TLiteLinks(res[i]);
   if l.Right.diriD=clsto.diriD then
   begin
    result:=l;
    exit;
   end;
  end;
  result:=TLiteLinks.Create(nil);
  result.connect(cls,clsto,nil);
  res.Add(result);
end;
begin
if checkID(cls,ls.Left) then
with ls do
begin
 Pro2L:=nil;
 Pro2R:=GetPro(Right);
 Pro2M:=GetPro(Middle);
 Pro2P:=GetPro(PRC);
 Pro2I:=GetPro(ABCMap);
  for i:=1 to sizetotal do
  begin
  AppendLink(Pro2L,itemsNF[i].ints,itemsNF[i].ints);
  AppendLink(Pro2R,itemsNF[i].ints,itemsNF[i].intd);
  AppendLink(Pro2M,itemsNF[i].ints,itemsNF[i].lnum);
  AppendLink(Pro2P,itemsNF[i].ints,itemsNF[i].ProcN);
  AppendLink(Pro2P,itemsNF[i].ints,itemsNF[i].ProcN2);
  AppendLink(Pro2I,itemsNF[i].ints,itemsNF[i].ABC);
  end;
end;
if CheckID(cls,ls.Right) then
with ls do
begin
 Pro2L:=GetPro(Left);
 Pro2R:=nil;
 Pro2M:=GetPro(Middle);
 Pro2P:=GetPro(PRC);
 Pro2I:=GetPro(ABCMap);
  for i:=1 to sizetotal do
  begin
  AppendLink(Pro2L,itemsNF[i].intd,itemsNF[i].ints);
  AppendLink(Pro2R,itemsNF[i].intd,itemsNF[i].intd);
  AppendLink(Pro2M,itemsNF[i].intd,itemsNF[i].lnum);
  AppendLink(Pro2P,itemsNF[i].intd,itemsNF[i].ProcN);
  AppendLink(Pro2P,itemsNF[i].intd,itemsNF[i].ProcN2);
  AppendLink(Pro2I,itemsNF[i].intd,itemsNF[i].ABC);
  end;
end;
if CheckID(cls,ls.Middle) then
with ls do
begin
 Pro2L:=GetPro(Left);
 Pro2R:=GetPro(Right);
 Pro2M:=Nil;
 Pro2P:=GetPro(PRC);
 Pro2I:=GetPro(ABCMap);
  for i:=1 to sizetotal do
  begin
  AppendLink(Pro2L,itemsNF[i].Lnum,itemsNF[i].ints);
  AppendLink(Pro2R,itemsNF[i].lnum,itemsNF[i].intd);
  AppendLink(Pro2M,itemsNF[i].Lnum,itemsNF[i].lnum);
  AppendLink(Pro2P,itemsNF[i].Lnum,itemsNF[i].ProcN);
  AppendLink(Pro2P,itemsNF[i].Lnum,itemsNF[i].ProcN2);
  AppendLink(Pro2I,itemsNF[i].Lnum,itemsNF[i].ABC);
  end;
end;
if CheckID(cls,ls.PRC) then
with ls do
begin
 Pro2L:=GetPro(Left);
 Pro2R:=GetPro(Right);
 Pro2M:=GetPro(Middle);
 Pro2P:=getPro(PRC);
 Pro2I:=GetPro(ABCMap);
  for i:=1 to sizetotal do
  begin
  AppendLink(Pro2L,itemsNF[i].ProcN,itemsNF[i].ints);
  AppendLink(Pro2R,itemsNF[i].ProcN,itemsNF[i].intd);
  AppendLink(Pro2M,itemsNF[i].ProcN,itemsNF[i].lnum);
  AppendLink(Pro2P,itemsNF[i].ProcN,itemsNF[i].ProcN2);
  AppendLink(Pro2I,itemsNF[i].ProcN,itemsNF[i].ABC);
  AppendLink(Pro2L,itemsNF[i].ProcN2,itemsNF[i].ints);
  AppendLink(Pro2R,itemsNF[i].ProcN2,itemsNF[i].intd);
  AppendLink(Pro2M,itemsNF[i].ProcN2,itemsNF[i].lnum);
  AppendLink(Pro2I,itemsNF[i].ProcN2,itemsNF[i].ABC);
  end;
end;
if CheckID(cls,ls.ABCMap) then
with ls do
begin
 Pro2L:=GetPro(Left);
 Pro2R:=GetPro(Right);
 Pro2M:=GetPro(Middle);
 Pro2P:=GetPro(PRC);
 Pro2I:=nil;
  for i:=1 to sizetotal do
  begin
  AppendLink(Pro2L,itemsNF[i].Abc,itemsNF[i].ints);
  AppendLink(Pro2R,itemsNF[i].Abc,itemsNF[i].intd);
  AppendLink(Pro2M,itemsNF[i].Abc,itemsNF[i].lnum);
  AppendLink(Pro2P,itemsNF[i].Abc,itemsNF[i].ProcN);
  AppendLink(Pro2P,itemsNF[i].Abc,itemsNF[i].ProcN2);
  AppendLink(Pro2I,itemsNF[i].Abc,itemsNF[i].ABC);
  end;
end;

end;
procedure SortTemplates(l:TStrings);
var i,j,start:integer;
    p1,p2:PModelObject;

begin
 j:=0;
 start:=-1;
 for i:=0 to l.Count-1 do
 begin
 p1:=PmodelObject(l.Objects[i]);
 if p1<>nil then begin start:=i; break;end;
 end;
if start<0 then exit;
j:=1;
while start<l.count-1-j do
begin
for i:=start to l.count-1-j do
begin
 p1:=PmodelObject(l.Objects[i]);
 p2:=PmodelObject(l.Objects[i+1]);
 if p1^.sp1>p2^.sp1 then l.Exchange(i,i+1);
end;
inc(j);
end;
end;
procedure ProcessComment(item:TOMItem;s:string);
begin
if AnsiStartsStr('|| ',s) then
item.comment:=item.comment+copy(s,4,length(s))+#02;
end;
function findbyWP(cls:TOMItems;WP:LongWord):integer;
var i:integer;
begin
 for i:=1 to cls.count do
  if cls[i].WParam=WP then
  begin
   result:=i;
   exit;
  end;
result:=0;  
end;
procedure SetLevel(cls:TOMItems;root,top:integer);
var i:integer;
begin
i:=root;
while i>0 do
begin
 cls[i].level:=top;
 SetLevel(cls,cls[i].firstChild,top+1);
 i:=cls[i].nextitem;
end;
end;
function StructureByPro(Source:TOMItems;Links:TLiteLinks;Root:integer):boolean;
var i,s,d:integer;
    moved:boolean;
begin
repeat
moved:=false;
 for i:=1 to Links.size do
 begin
  s:=links[i].ints;
  d:=links[i].intd;
  if (s=0)or(d=0) then continue;
  if Source.isparent(d,s) then continue;
  Source.cutfromlist(d);
  Source.insertitem(d,s,0);
  links[i].isautocreate:=true;
  Moved:=true;
 end;
 links.clearautocreate;
until not moved;
end;
function CopyCls(source,Dest:TOMItems;Mode:byte):integer;
procedure CopyLevel(root,Top:integer);
var i:integer;
    newit:TOMItem;
begin
 i:=root;
 while i>0 do
 begin
  if (Source[i].deleted=0)and Source.canshow(i,mode) then
  begin
   newit:=Dest.ADDChildItem(top,Source[i].s);
   newit.assignData(Source[i]);
   newit.WParam:=i;
   CopyLevel(Source[i].firstchild,newit.pos);
  end;
  i:=Source[i].nextitem;
 end;
end;
begin
 Dest.AssignProperties(Source);
 CopyLevel(Source.Root,0);
result:=Dest.count; 
end;
function GetBPContense(MA:TModelArray;BPData:TBlobField;ProList:TStringList):integer;
var bs:TBlobStream;
    ms:TMemoryStream;
    id:integer;
    mo:PModelObject;
    cnt:integer;
begin
 ms:=TMemoryStream.Create;
 try
 bs:=TBlobStream.Create(BPData,bmRead);
 try
 cnt:=bs.Size;

 ms.LoadFromStream(bs);
 finally
 bs.free;
 end;
 cnt:=ms.Size;
 id:=0;
 ms.Seek(0,soFromBeginning);
  if ms.read(id,sizeof(id))<>sizeof(id) then id:=0;
 if ms.read(id,sizeof(id))<>sizeof(id) then id:=0;
 while id>0 do
 begin
 mo:=MA.getModelObjectByID(id);
 if mo<>nil then
 Prolist.addObject(mo^.name,TObject(mo));
 ms.read(id,sizeof(id));
 ms.read(id,sizeof(id));
 ms.read(id,sizeof(id));
 ms.read(id,sizeof(id));
 ms.read(id,sizeof(id));
 ms.read(id,sizeof(id));
 ms.read(id,sizeof(id));
 end;
 finally
 ms.free;
 end;
end;
function DownGrade(l:TLiteLinks):integer;
var temp:TLiteLinks;
    i:integer;
    isnew:boolean;
begin
temp:=TLiteLinks.Create(l.PRC);
try
 temp.connect(l.Left,l.Right,nil);
 if l.Middle<>nil then
 temp.ConnectToStreams(1,l.Middle);
 temp.ConnectABC(l.ABCMap);
 for i:=1 to l.sizetotal do
  temp.AddLinkObject(l.itemsNF[i]);
 l.Clear;
 l.doDetail:=true;
 for i:=1 to temp.sizetotal do
  l.intaddlink(temp.itemsNF[i],isnew);
finally
temp.free;
end;
result:=l.sizetotal;
end;
procedure CloseLinks(l:TLiteLinks);
var i:integer;
begin

 for i:=1 to l.sizetotal do
 begin
  if l.Left<>nil then
   l.itemsNF[i].ints:=l.Left.getClosed(l.itemsNF[i].ints);
  if l.Right<>nil then
   l.itemsNF[i].intd:=l.Right.getClosed(l.itemsNF[i].intd);
  if l.Middle<>nil then
  l.itemsNF[i].lnum:=l.Middle.getClosed(l.itemsNF[i].lnum);
  if l.ABCMap<>nil then
  l.itemsNF[i].ABC:=l.ABCMap.getClosed(l.itemsNF[i].ABC);
  if l.PRC<>nil then
  begin
  l.itemsNF[i].procN:=l.PRC.getClosed(l.itemsNF[i].procN);
  l.itemsNF[i].procN2:=l.PRC.getClosed(l.itemsNF[i].procN2);
  end;
 end;
 l.DeleteDublicates;
end;
function Before(item1,item2:TOMItem):boolean;
var i1,i2:integer;
begin
result:=true;
if item1.owner<>item2.owner then exit;
i1:=item1.pos;
i2:=item2.pos;
if (item1.level>item2.level) then
begin
while (item1.intparent>0)and(item1.level>item2.level) do item1:=item1.owner[item1.intparent];
if item1=item2 then begin result:=false;exit;end;
end;
if (item2.level>item1.level) then
begin
while (item1.intparent>0)and(item2.level>item1.level) do item2:=item2.owner[item2.intparent];
if item1=item2 then begin result:=true;exit;end;
end;
While (item1.intparent<>item2.intparent)and
      (item1.intparent>0)and(item2.intparent>0) do
begin
item1:=item1.owner[item1.intparent];
item2:=item2.owner[item2.intparent];
end;
while (item2.nextitem>0)and(item2.nextitem<>item1.pos) do item2:=item2.owner[item2.nextItem];
if item2.nextitem>0 then result:=false;
end;
function isSingleRoot(cls:TOMItems;pos:integer):boolean;
var i,cnt:integer;
begin
 result:=true;
 if pos=0 then exit;
 if cls[pos].intparent<>cls[cls.root].intparent then result:=false
 else
 begin
  i:=cls.root;
  cnt:=0;
  while (i>0)and(cnt<2) do
  begin
  if cls[i].deleted=0 then inc(cnt);
  i:=cls[i].nextitem;
  end;
  result:=cnt<2;
 end;
end;
function CheckIn(cls:TOMItems;PosList:TIntList;Cand:integer):boolean;
var i:integer;
begin
 result:=false;
 for i:=0 to PosList.Count-1 do
  if cls.isParent(PosList[i],cand) then
  begin
   result:=true;
   exit;
  end;
end;
procedure GroupSelSort(var a:array of integer;b:array of TOMItems;n:integer);
var i,j:integer;
    d:integer;
    p:pointer;
begin
for i:= low(a) to low(a)+n-2 do
begin
 for j:=i+1 to low(a)+n-1 do
  if
  (b[i]<>nil)and(b[j]=nil)or
  (b[i]<>nil)and(b[j]<>nil)and
  (b[i].dirid>b[j].dirid)or
  ((b[i]=b[j])and
  (a[i]>a[j])) then
   begin
   d:=a[i];
   a[i]:=a[j];
   a[j]:=d;
   p:=b[i];
   b[i]:=b[j];
   b[j]:=p;
   end;
end;
end;

initialization
contextam0:=true;
end.
