unit lnkpropF;
{
(c) . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ToolEdit, Mask, ExtCtrls, RXCalc, ComCtrls, ColoredGrid,
  ToolWin, Grids, items, RXSpin, ImgList, Buttons, ImageComboBox;

type
  TLinkProp = class(TForm)
    RxCalculator1: TRxCalculator;
    Button2: TButton;
    Button1: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    LnkName: TEdit;
    DatePanel: TPanel;
    LnkComment: TEdit;
    Panel1: TGroupBox;
    Label8: TLabel;
    Label7: TLabel;
    LnkLeft: TEdit;
    LnkRight: TEdit;
    Label12: TLabel;
    Label17: TLabel;
    ABCChange: TComboBox;
    DirCombo: TComboBox;
    Label3: TLabel;
    GotoLeft: TSpeedButton;
    GotoRight: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CInfoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ABCChangeChange(Sender: TObject);
    procedure PosFromCommentClick(Sender: TObject);
    procedure GotoLeftClick(Sender: TObject);
    procedure GotoRightClick(Sender: TObject);
  private
    { Private declarations }
    frebuild:boolean;
    procedure addInfo(ints,intd,lnum:integer;scale,coeff:extended);
  public
    { Public declarations }
    Class_startDate,Class_FinishDate:TDateTime;
    links:TLiteLinks;
    id:TOMLink;
    RotMode:byte;
    property dorebuild:boolean read frebuild;
  end;

var
  LinkProp: TLinkProp;

implementation

uses MAIN, utils,  myLists, Umessages, appConst, otherlisttypes;

{$R *.DFM}

procedure TLinkProp.FormActivate(Sender: TObject);
var j,lcpos:integer;
    i:TOMLink;
    imgList:TStringList;
begin
frebuild:=false;
DirCombo.Items.Clear;
LnkLeft.font.charset:=204;
LnkRight.font.charset:=204;
LnkName.font.charset:=204;
LnkComment.font.charset:=204;
ABCChange.font.charset:=204;

ABCChange.items:=OrgMasterMain.ABCCombo.items;
PageControl1.activePage:=PageControl1.pages[0];
links:=id.owner;
i:=id;
case links.prjType of
ptLRN: begin
       DirCombo.Items.AddObject(links.dirmap[1],pointer(0));
       DirCombo.Items.AddObject(links.dirmap[2],pointer(1));
       DirCombo.Items.AddObject(links.dirmap[3],pointer(3));
       case id.flags and 3 of
       0,1:DirCombo.ItemIndex:=id.flags and 1;
       2,3:DirCombo.ItemIndex:=2;
       end;
       end;
ptIOC: begin
       DirCombo.Items.AddObject('',pointer(0));
       DirCombo.Items.AddObject('',pointer(1));
       DirCombo.Items.AddObject('<'+'',pointer(2));
       DirCombo.Items.AddObject(''+'>',pointer(3));
       if RotMode in [1,4,5] then
       DirCombo.ItemIndex:=(id.flags xor 1) and 3
       else
       DirCombo.ItemIndex:=id.flags and 3;
       end;
ptIOM: begin
       DirCombo.Items.AddObject('',pointer(0));
       DirCombo.Items.AddObject('',pointer(1));
       DirCombo.Items.AddObject('<'+'',pointer(2));
       DirCombo.Items.AddObject(''+'>',pointer(3));
       if RotMode in [1,4,5] then
         DirCombo.ItemIndex:=(id.flags xor 1) and 3
       else
       DirCombo.ItemIndex:=id.flags and 3;
       end;
ptM: begin
       DirCombo.Items.AddObject('',pointer(0));
       DirCombo.ItemIndex:=0;
       end;
ptC: begin
       DirCombo.Items.AddObject('',pointer(0));
       DirCombo.ItemIndex:=0;
       end;
end;

with OrgMasterMain do
begin
case rotMode of
0: //L-M-R
begin
Lnkleft.text:=i.owner.Left.getcomboname(i.owner.Left.GetClosed(i.ints),$ffff,0,true);
LnkRight.text:=i.owner.right.getcomboname(i.owner.Right.getClosed(i.intd),$ffff,0,true);
lcpos:=i.lnum;
end;
1: //R-M-L
begin
Lnkleft.text:=i.owner.Left.getcomboname(i.owner.Left.GetClosed(i.intd),$ffff,0,true);
LnkRight.text:=i.owner.right.getcomboname(i.owner.Right.GetClosed(i.ints),$ffff,0,true);
lcpos:=i.lnum;
end;
2: //L-R-M
begin
Lnkleft.text:=i.owner.Left.getcomboname(i.owner.Left.GetClosed(i.ints),$ffff,0,true);
LnkRight.text:=i.owner.right.getcomboname(i.owner.Right.GetClosed(i.lnum),$ffff,0,true);
lcpos:=i.intd;
end;
3: //M-L-R
begin
Lnkleft.text:=i.owner.Left.getcomboname(i.owner.Left.GetClosed(i.lnum),$ffff,0,true);
LnkRight.text:=i.owner.right.getcomboname(i.owner.Right.GetClosed(i.intd),$ffff,0,true);
lcpos:=i.ints;
end;
4: //M-R-L
begin
Lnkleft.text:=i.owner.Left.getcomboname(i.owner.Left.GetClosed(i.lnum),$ffff,0,true);
LnkRight.text:=i.owner.right.getcomboname(i.owner.Right.GetClosed(i.ints),$ffff,0,true);
lcpos:=i.intd;
end;
5: //R-L-M
begin
Lnkleft.text:=i.owner.Left.getcomboname(i.owner.Left.GetClosed(i.intd),$ffff,0,true);
LnkRight.text:=i.owner.right.getcomboname(i.owner.Right.GetClosed(i.lnum),$ffff,0,true);
lcpos:=i.ints;
end;
end;
 lnkname.enabled:=false;
 lnkname.text:='';
 lnkcomment.text:=i.linkcomment;
 if lcpos<>0 then
 begin
// lnkName.enabled:=true;
 lnkname.text:=i.owner.middle.GetComboName(lcpos,$ffff,0,true);
 end;
//
DatePanel.visible:=false;
ABCChange.Items.Clear;
if id.owner.ABCMap<>nil then
ABCChange.itemindex:= id.owner.abcmap.fillList(ABCChange.items,id.ABC,'')
else
ABCChange.enabled:=false;
begin
DatePanel.visible:=true;
end
end;
end;

procedure TLinkProp.Button2Click(Sender: TObject);
var i:TOMLink;
begin
i:=id;
{ try
 links[i].funcoeff:=strtofloat(lnkscale.caption);
 except
 end;}
i.linkcomment:=lnkcomment.text;
i.flags:=(i.flags and not 7)or
          Integer(dircombo.items.objects[dircombo.itemindex]);
if rotmode in [1,4,5] then i.flags:=i.flags xor 1;
end;

procedure TLinkProp.addInfo(ints,intd,lnum:integer;scale,coeff:extended);
var li,ri,mi:integer;
begin
 li:=ints;
 ri:=intd;
 mi:=lnum;
 utils.rotateNormal(links.state,li,ri,mi);
end;

procedure TLinkProp.CInfoMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var c,r:integer;
begin
if sender is TStringGrid then
with TStringGrid(sender) do
begin
mousetocell(x,y,c,r);
if   (c>=0)and(r>=0) then
label12.caption:=cells[c,r];
end
else label12.caption:='';
end;
procedure TLinkProp.ABCChangeChange(Sender: TObject);
begin
if ABCChange.itemindex=-1 then ABCChange.itemindex:=0;
end;

procedure TLinkProp.PosFromCommentClick(Sender: TObject);
var newitem:TOMItem;
    cpos:integer;
begin
{$IFNDEF VIEW}
if id.owner.middle.dirid<=0 then exit;
if LnkComment.text='' then exit;
with OrgMasterMain do
begin
case rotmode of
0,1:cpos:=id.lnum;
2,4:cpos:=id.intd;
3,5:cpos:=id.ints;
end;
newitem:=id.owner.middle.ADDChildItem(cpos,lnkComment.text);
case rotmode of
0,1:id.lnum:=newitem.pos;
2,4:id.intd:=newitem.pos;
3,5:id.ints:=newitem.pos;
end;
 lnkname.text:=id.owner.middle.GetComboName(newitem.pos,$ffff,0,true);
end;
lnkComment.text:='';
{$ENDIF}
end;

procedure TLinkProp.GotoLeftClick(Sender: TObject);
begin
case rotmode of
0,2:id.owner.Left.makevisible(id.owner.Left.GetClosed(id.ints));
1,5:id.owner.Left.makevisible(id.owner.Left.GetClosed(id.intd));
3,4:id.owner.Left.makevisible(id.owner.Left.GetClosed(id.lnum));
end;
frebuild:=true;
end;

procedure TLinkProp.GotoRightClick(Sender: TObject);
begin
case rotmode of
0,3:id.owner.Right.makevisible(id.owner.Right.GetClosed(id.intd));
1,4:id.owner.Right.makevisible(id.owner.Right.GetClosed(id.ints));
2,5:id.owner.Right.makevisible(id.owner.Right.GetClosed(id.lnum));
end;
frebuild:=true;
end;

end.
